/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { FormResultModel } from '../models';
import { FormResultStatus } from '../models';
import { FormResultsModel } from '../models';
import { FormTemplatePlatform } from '../models';
import { FormTemplateType } from '../models';
import { UpdateFormResultCommand } from '../models';
/**
 * FormResultsApi - axios parameter creator
 * @export
 */
export declare const FormResultsApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Delete formResult
     * @param {string} formResultId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormresultsFormResultIdDelete: (formResultId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get formResult
     * @param {string} formResultId
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormresultsFormResultIdGet: (formResultId: string, languageCode?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update formResult
     * @param {string} formResultId
     * @param {UpdateFormResultCommand} [updateFormResultCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormresultsFormResultIdPut: (formResultId: string, updateFormResultCommand?: UpdateFormResultCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get formResults
     * @param {string} [languageCode]
     * @param {Date} [startDate]
     * @param {Date} [endDate]
     * @param {string} [hospitalId]
     * @param {boolean} [noHospitalOnly]
     * @param {FormTemplatePlatform} [platform]
     * @param {FormTemplateType} [formTemplateType]
     * @param {FormResultStatus} [status]
     * @param {string} [userId]
     * @param {boolean} [noUserOnly]
     * @param {string} [userName]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormresultsGet: (languageCode?: string, startDate?: Date, endDate?: Date, hospitalId?: string, noHospitalOnly?: boolean, platform?: FormTemplatePlatform, formTemplateType?: FormTemplateType, status?: FormResultStatus, userId?: string, noUserOnly?: boolean, userName?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * FormResultsApi - functional programming interface
 * @export
 */
export declare const FormResultsApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Delete formResult
     * @param {string} formResultId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormresultsFormResultIdDelete(formResultId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FormResultModel>>;
    /**
     *
     * @summary Get formResult
     * @param {string} formResultId
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormresultsFormResultIdGet(formResultId: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FormResultModel>>;
    /**
     *
     * @summary Update formResult
     * @param {string} formResultId
     * @param {UpdateFormResultCommand} [updateFormResultCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormresultsFormResultIdPut(formResultId: string, updateFormResultCommand?: UpdateFormResultCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FormResultModel>>;
    /**
     *
     * @summary Get formResults
     * @param {string} [languageCode]
     * @param {Date} [startDate]
     * @param {Date} [endDate]
     * @param {string} [hospitalId]
     * @param {boolean} [noHospitalOnly]
     * @param {FormTemplatePlatform} [platform]
     * @param {FormTemplateType} [formTemplateType]
     * @param {FormResultStatus} [status]
     * @param {string} [userId]
     * @param {boolean} [noUserOnly]
     * @param {string} [userName]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormresultsGet(languageCode?: string, startDate?: Date, endDate?: Date, hospitalId?: string, noHospitalOnly?: boolean, platform?: FormTemplatePlatform, formTemplateType?: FormTemplateType, status?: FormResultStatus, userId?: string, noUserOnly?: boolean, userName?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FormResultsModel>>;
};
/**
 * FormResultsApi - factory interface
 * @export
 */
export declare const FormResultsApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Delete formResult
     * @param {string} formResultId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormresultsFormResultIdDelete(formResultId: string, options?: any): AxiosPromise<FormResultModel>;
    /**
     *
     * @summary Get formResult
     * @param {string} formResultId
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormresultsFormResultIdGet(formResultId: string, languageCode?: string, options?: any): AxiosPromise<FormResultModel>;
    /**
     *
     * @summary Update formResult
     * @param {string} formResultId
     * @param {UpdateFormResultCommand} [updateFormResultCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormresultsFormResultIdPut(formResultId: string, updateFormResultCommand?: UpdateFormResultCommand, options?: any): AxiosPromise<FormResultModel>;
    /**
     *
     * @summary Get formResults
     * @param {string} [languageCode]
     * @param {Date} [startDate]
     * @param {Date} [endDate]
     * @param {string} [hospitalId]
     * @param {boolean} [noHospitalOnly]
     * @param {FormTemplatePlatform} [platform]
     * @param {FormTemplateType} [formTemplateType]
     * @param {FormResultStatus} [status]
     * @param {string} [userId]
     * @param {boolean} [noUserOnly]
     * @param {string} [userName]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormresultsGet(languageCode?: string, startDate?: Date, endDate?: Date, hospitalId?: string, noHospitalOnly?: boolean, platform?: FormTemplatePlatform, formTemplateType?: FormTemplateType, status?: FormResultStatus, userId?: string, noUserOnly?: boolean, userName?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<FormResultsModel>;
};
/**
 * Request parameters for apiV1FormresultsFormResultIdDelete operation in FormResultsApi.
 * @export
 * @interface FormResultsApiApiV1FormresultsFormResultIdDeleteRequest
 */
export interface FormResultsApiApiV1FormresultsFormResultIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof FormResultsApiApiV1FormresultsFormResultIdDelete
     */
    readonly formResultId: string;
}
/**
 * Request parameters for apiV1FormresultsFormResultIdGet operation in FormResultsApi.
 * @export
 * @interface FormResultsApiApiV1FormresultsFormResultIdGetRequest
 */
export interface FormResultsApiApiV1FormresultsFormResultIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof FormResultsApiApiV1FormresultsFormResultIdGet
     */
    readonly formResultId: string;
    /**
     *
     * @type {string}
     * @memberof FormResultsApiApiV1FormresultsFormResultIdGet
     */
    readonly languageCode?: string;
}
/**
 * Request parameters for apiV1FormresultsFormResultIdPut operation in FormResultsApi.
 * @export
 * @interface FormResultsApiApiV1FormresultsFormResultIdPutRequest
 */
export interface FormResultsApiApiV1FormresultsFormResultIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof FormResultsApiApiV1FormresultsFormResultIdPut
     */
    readonly formResultId: string;
    /**
     *
     * @type {UpdateFormResultCommand}
     * @memberof FormResultsApiApiV1FormresultsFormResultIdPut
     */
    readonly updateFormResultCommand?: UpdateFormResultCommand;
}
/**
 * Request parameters for apiV1FormresultsGet operation in FormResultsApi.
 * @export
 * @interface FormResultsApiApiV1FormresultsGetRequest
 */
export interface FormResultsApiApiV1FormresultsGetRequest {
    /**
     *
     * @type {string}
     * @memberof FormResultsApiApiV1FormresultsGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {Date}
     * @memberof FormResultsApiApiV1FormresultsGet
     */
    readonly startDate?: Date;
    /**
     *
     * @type {Date}
     * @memberof FormResultsApiApiV1FormresultsGet
     */
    readonly endDate?: Date;
    /**
     *
     * @type {string}
     * @memberof FormResultsApiApiV1FormresultsGet
     */
    readonly hospitalId?: string;
    /**
     *
     * @type {boolean}
     * @memberof FormResultsApiApiV1FormresultsGet
     */
    readonly noHospitalOnly?: boolean;
    /**
     *
     * @type {FormTemplatePlatform}
     * @memberof FormResultsApiApiV1FormresultsGet
     */
    readonly platform?: FormTemplatePlatform;
    /**
     *
     * @type {FormTemplateType}
     * @memberof FormResultsApiApiV1FormresultsGet
     */
    readonly formTemplateType?: FormTemplateType;
    /**
     *
     * @type {FormResultStatus}
     * @memberof FormResultsApiApiV1FormresultsGet
     */
    readonly status?: FormResultStatus;
    /**
     *
     * @type {string}
     * @memberof FormResultsApiApiV1FormresultsGet
     */
    readonly userId?: string;
    /**
     *
     * @type {boolean}
     * @memberof FormResultsApiApiV1FormresultsGet
     */
    readonly noUserOnly?: boolean;
    /**
     *
     * @type {string}
     * @memberof FormResultsApiApiV1FormresultsGet
     */
    readonly userName?: string;
    /**
     *
     * @type {number}
     * @memberof FormResultsApiApiV1FormresultsGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof FormResultsApiApiV1FormresultsGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof FormResultsApiApiV1FormresultsGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * FormResultsApi - object-oriented interface
 * @export
 * @class FormResultsApi
 * @extends {BaseAPI}
 */
export declare class FormResultsApi extends BaseAPI {
    /**
     *
     * @summary Delete formResult
     * @param {FormResultsApiApiV1FormresultsFormResultIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FormResultsApi
     */
    apiV1FormresultsFormResultIdDelete(requestParameters: FormResultsApiApiV1FormresultsFormResultIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<FormResultModel, any>>;
    /**
     *
     * @summary Get formResult
     * @param {FormResultsApiApiV1FormresultsFormResultIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FormResultsApi
     */
    apiV1FormresultsFormResultIdGet(requestParameters: FormResultsApiApiV1FormresultsFormResultIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<FormResultModel, any>>;
    /**
     *
     * @summary Update formResult
     * @param {FormResultsApiApiV1FormresultsFormResultIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FormResultsApi
     */
    apiV1FormresultsFormResultIdPut(requestParameters: FormResultsApiApiV1FormresultsFormResultIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<FormResultModel, any>>;
    /**
     *
     * @summary Get formResults
     * @param {FormResultsApiApiV1FormresultsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FormResultsApi
     */
    apiV1FormresultsGet(requestParameters?: FormResultsApiApiV1FormresultsGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<FormResultsModel, any>>;
}
//# sourceMappingURL=form-results-api.d.ts.map