/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { CreateGradeCommand } from '../models';
import { GradeModel } from '../models';
import { GradeTargets } from '../models';
import { GradesModel } from '../models';
import { UpdateGradeCommand } from '../models';
/**
 * GradesApi - axios parameter creator
 * @export
 */
export declare const GradesApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Get grades
     * @param {string} [id]
     * @param {string} [name]
     * @param {GradeTargets} [gradeTarget]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1GradesGet: (id?: string, name?: string, gradeTarget?: GradeTargets, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete grade
     * @param {string} gradeId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1GradesGradeIdDelete: (gradeId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get grade
     * @param {string} gradeId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1GradesGradeIdGet: (gradeId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update grade
     * @param {string} gradeId
     * @param {UpdateGradeCommand} [updateGradeCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1GradesGradeIdPut: (gradeId: string, updateGradeCommand?: UpdateGradeCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create grade
     * @param {CreateGradeCommand} [createGradeCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1GradesPost: (createGradeCommand?: CreateGradeCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * GradesApi - functional programming interface
 * @export
 */
export declare const GradesApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Get grades
     * @param {string} [id]
     * @param {string} [name]
     * @param {GradeTargets} [gradeTarget]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1GradesGet(id?: string, name?: string, gradeTarget?: GradeTargets, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<GradesModel>>;
    /**
     *
     * @summary Delete grade
     * @param {string} gradeId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1GradesGradeIdDelete(gradeId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get grade
     * @param {string} gradeId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1GradesGradeIdGet(gradeId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<GradeModel>>;
    /**
     *
     * @summary Update grade
     * @param {string} gradeId
     * @param {UpdateGradeCommand} [updateGradeCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1GradesGradeIdPut(gradeId: string, updateGradeCommand?: UpdateGradeCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<GradeModel>>;
    /**
     *
     * @summary Create grade
     * @param {CreateGradeCommand} [createGradeCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1GradesPost(createGradeCommand?: CreateGradeCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<GradeModel>>;
};
/**
 * GradesApi - factory interface
 * @export
 */
export declare const GradesApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Get grades
     * @param {string} [id]
     * @param {string} [name]
     * @param {GradeTargets} [gradeTarget]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1GradesGet(id?: string, name?: string, gradeTarget?: GradeTargets, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<GradesModel>;
    /**
     *
     * @summary Delete grade
     * @param {string} gradeId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1GradesGradeIdDelete(gradeId: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get grade
     * @param {string} gradeId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1GradesGradeIdGet(gradeId: string, options?: any): AxiosPromise<GradeModel>;
    /**
     *
     * @summary Update grade
     * @param {string} gradeId
     * @param {UpdateGradeCommand} [updateGradeCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1GradesGradeIdPut(gradeId: string, updateGradeCommand?: UpdateGradeCommand, options?: any): AxiosPromise<GradeModel>;
    /**
     *
     * @summary Create grade
     * @param {CreateGradeCommand} [createGradeCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1GradesPost(createGradeCommand?: CreateGradeCommand, options?: any): AxiosPromise<GradeModel>;
};
/**
 * Request parameters for apiV1GradesGet operation in GradesApi.
 * @export
 * @interface GradesApiApiV1GradesGetRequest
 */
export interface GradesApiApiV1GradesGetRequest {
    /**
     *
     * @type {string}
     * @memberof GradesApiApiV1GradesGet
     */
    readonly id?: string;
    /**
     *
     * @type {string}
     * @memberof GradesApiApiV1GradesGet
     */
    readonly name?: string;
    /**
     *
     * @type {GradeTargets}
     * @memberof GradesApiApiV1GradesGet
     */
    readonly gradeTarget?: GradeTargets;
    /**
     *
     * @type {boolean}
     * @memberof GradesApiApiV1GradesGet
     */
    readonly showHidden?: boolean;
    /**
     *
     * @type {number}
     * @memberof GradesApiApiV1GradesGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof GradesApiApiV1GradesGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof GradesApiApiV1GradesGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1GradesGradeIdDelete operation in GradesApi.
 * @export
 * @interface GradesApiApiV1GradesGradeIdDeleteRequest
 */
export interface GradesApiApiV1GradesGradeIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof GradesApiApiV1GradesGradeIdDelete
     */
    readonly gradeId: string;
}
/**
 * Request parameters for apiV1GradesGradeIdGet operation in GradesApi.
 * @export
 * @interface GradesApiApiV1GradesGradeIdGetRequest
 */
export interface GradesApiApiV1GradesGradeIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof GradesApiApiV1GradesGradeIdGet
     */
    readonly gradeId: string;
}
/**
 * Request parameters for apiV1GradesGradeIdPut operation in GradesApi.
 * @export
 * @interface GradesApiApiV1GradesGradeIdPutRequest
 */
export interface GradesApiApiV1GradesGradeIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof GradesApiApiV1GradesGradeIdPut
     */
    readonly gradeId: string;
    /**
     *
     * @type {UpdateGradeCommand}
     * @memberof GradesApiApiV1GradesGradeIdPut
     */
    readonly updateGradeCommand?: UpdateGradeCommand;
}
/**
 * Request parameters for apiV1GradesPost operation in GradesApi.
 * @export
 * @interface GradesApiApiV1GradesPostRequest
 */
export interface GradesApiApiV1GradesPostRequest {
    /**
     *
     * @type {CreateGradeCommand}
     * @memberof GradesApiApiV1GradesPost
     */
    readonly createGradeCommand?: CreateGradeCommand;
}
/**
 * GradesApi - object-oriented interface
 * @export
 * @class GradesApi
 * @extends {BaseAPI}
 */
export declare class GradesApi extends BaseAPI {
    /**
     *
     * @summary Get grades
     * @param {GradesApiApiV1GradesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof GradesApi
     */
    apiV1GradesGet(requestParameters?: GradesApiApiV1GradesGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<GradesModel, any>>;
    /**
     *
     * @summary Delete grade
     * @param {GradesApiApiV1GradesGradeIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof GradesApi
     */
    apiV1GradesGradeIdDelete(requestParameters: GradesApiApiV1GradesGradeIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get grade
     * @param {GradesApiApiV1GradesGradeIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof GradesApi
     */
    apiV1GradesGradeIdGet(requestParameters: GradesApiApiV1GradesGradeIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<GradeModel, any>>;
    /**
     *
     * @summary Update grade
     * @param {GradesApiApiV1GradesGradeIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof GradesApi
     */
    apiV1GradesGradeIdPut(requestParameters: GradesApiApiV1GradesGradeIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<GradeModel, any>>;
    /**
     *
     * @summary Create grade
     * @param {GradesApiApiV1GradesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof GradesApi
     */
    apiV1GradesPost(requestParameters?: GradesApiApiV1GradesPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<GradeModel, any>>;
}
//# sourceMappingURL=grades-api.d.ts.map