/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { AddHospitalIntoBranchCommand } from '../models';
import { CreateHospitalBranchCommand } from '../models';
import { HospitalBranchModel } from '../models';
import { HospitalBranchesModel } from '../models';
import { UpdateHospitalBranchCommand } from '../models';
import { UpdateHospitalBranchItemCommand } from '../models';
/**
 * HospitalBranchesApi - axios parameter creator
 * @export
 */
export declare const HospitalBranchesApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Get hospitalBranches
     * @param {string} [id]
     * @param {string} [hospitalGroupId]
     * @param {string} [hospitalId]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalbranchesGet: (id?: string, hospitalGroupId?: string, hospitalId?: string, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete hospitalBranch
     * @param {string} hospitalBranchId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalbranchesHospitalBranchIdDelete: (hospitalBranchId: string, isPermanent?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get hospitalBranch
     * @param {string} hospitalBranchId
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalbranchesHospitalBranchIdGet: (hospitalBranchId: string, languageCode?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Remove hospital from HospitalBranch
     * @param {string} hospitalBranchId
     * @param {string} hospitalId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdDelete: (hospitalBranchId: string, hospitalId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Add hospital into HospitalBranch
     * @param {string} hospitalBranchId
     * @param {string} hospitalId
     * @param {AddHospitalIntoBranchCommand} [addHospitalIntoBranchCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPost: (hospitalBranchId: string, hospitalId: string, addHospitalIntoBranchCommand?: AddHospitalIntoBranchCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update hospitalBranchItem
     * @param {string} hospitalBranchId
     * @param {string} hospitalId
     * @param {UpdateHospitalBranchItemCommand} [updateHospitalBranchItemCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPut: (hospitalBranchId: string, hospitalId: string, updateHospitalBranchItemCommand?: UpdateHospitalBranchItemCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update hospitalBranch
     * @param {string} hospitalBranchId
     * @param {UpdateHospitalBranchCommand} [updateHospitalBranchCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalbranchesHospitalBranchIdPut: (hospitalBranchId: string, updateHospitalBranchCommand?: UpdateHospitalBranchCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Reactivate hospitalBranch
     * @param {string} hospitalBranchId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalbranchesHospitalBranchIdReactivatePut: (hospitalBranchId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create hospitalBranch
     * @param {CreateHospitalBranchCommand} [createHospitalBranchCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalbranchesPost: (createHospitalBranchCommand?: CreateHospitalBranchCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * HospitalBranchesApi - functional programming interface
 * @export
 */
export declare const HospitalBranchesApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Get hospitalBranches
     * @param {string} [id]
     * @param {string} [hospitalGroupId]
     * @param {string} [hospitalId]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalbranchesGet(id?: string, hospitalGroupId?: string, hospitalId?: string, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<HospitalBranchesModel>>;
    /**
     *
     * @summary Delete hospitalBranch
     * @param {string} hospitalBranchId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalbranchesHospitalBranchIdDelete(hospitalBranchId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get hospitalBranch
     * @param {string} hospitalBranchId
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalbranchesHospitalBranchIdGet(hospitalBranchId: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<HospitalBranchModel>>;
    /**
     *
     * @summary Remove hospital from HospitalBranch
     * @param {string} hospitalBranchId
     * @param {string} hospitalId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdDelete(hospitalBranchId: string, hospitalId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Add hospital into HospitalBranch
     * @param {string} hospitalBranchId
     * @param {string} hospitalId
     * @param {AddHospitalIntoBranchCommand} [addHospitalIntoBranchCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPost(hospitalBranchId: string, hospitalId: string, addHospitalIntoBranchCommand?: AddHospitalIntoBranchCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<HospitalBranchModel>>;
    /**
     *
     * @summary Update hospitalBranchItem
     * @param {string} hospitalBranchId
     * @param {string} hospitalId
     * @param {UpdateHospitalBranchItemCommand} [updateHospitalBranchItemCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPut(hospitalBranchId: string, hospitalId: string, updateHospitalBranchItemCommand?: UpdateHospitalBranchItemCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<HospitalBranchModel>>;
    /**
     *
     * @summary Update hospitalBranch
     * @param {string} hospitalBranchId
     * @param {UpdateHospitalBranchCommand} [updateHospitalBranchCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalbranchesHospitalBranchIdPut(hospitalBranchId: string, updateHospitalBranchCommand?: UpdateHospitalBranchCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<HospitalBranchModel>>;
    /**
     *
     * @summary Reactivate hospitalBranch
     * @param {string} hospitalBranchId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalbranchesHospitalBranchIdReactivatePut(hospitalBranchId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Create hospitalBranch
     * @param {CreateHospitalBranchCommand} [createHospitalBranchCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalbranchesPost(createHospitalBranchCommand?: CreateHospitalBranchCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<HospitalBranchModel>>;
};
/**
 * HospitalBranchesApi - factory interface
 * @export
 */
export declare const HospitalBranchesApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Get hospitalBranches
     * @param {string} [id]
     * @param {string} [hospitalGroupId]
     * @param {string} [hospitalId]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalbranchesGet(id?: string, hospitalGroupId?: string, hospitalId?: string, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<HospitalBranchesModel>;
    /**
     *
     * @summary Delete hospitalBranch
     * @param {string} hospitalBranchId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalbranchesHospitalBranchIdDelete(hospitalBranchId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get hospitalBranch
     * @param {string} hospitalBranchId
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalbranchesHospitalBranchIdGet(hospitalBranchId: string, languageCode?: string, options?: any): AxiosPromise<HospitalBranchModel>;
    /**
     *
     * @summary Remove hospital from HospitalBranch
     * @param {string} hospitalBranchId
     * @param {string} hospitalId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdDelete(hospitalBranchId: string, hospitalId: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Add hospital into HospitalBranch
     * @param {string} hospitalBranchId
     * @param {string} hospitalId
     * @param {AddHospitalIntoBranchCommand} [addHospitalIntoBranchCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPost(hospitalBranchId: string, hospitalId: string, addHospitalIntoBranchCommand?: AddHospitalIntoBranchCommand, options?: any): AxiosPromise<HospitalBranchModel>;
    /**
     *
     * @summary Update hospitalBranchItem
     * @param {string} hospitalBranchId
     * @param {string} hospitalId
     * @param {UpdateHospitalBranchItemCommand} [updateHospitalBranchItemCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPut(hospitalBranchId: string, hospitalId: string, updateHospitalBranchItemCommand?: UpdateHospitalBranchItemCommand, options?: any): AxiosPromise<HospitalBranchModel>;
    /**
     *
     * @summary Update hospitalBranch
     * @param {string} hospitalBranchId
     * @param {UpdateHospitalBranchCommand} [updateHospitalBranchCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalbranchesHospitalBranchIdPut(hospitalBranchId: string, updateHospitalBranchCommand?: UpdateHospitalBranchCommand, options?: any): AxiosPromise<HospitalBranchModel>;
    /**
     *
     * @summary Reactivate hospitalBranch
     * @param {string} hospitalBranchId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalbranchesHospitalBranchIdReactivatePut(hospitalBranchId: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Create hospitalBranch
     * @param {CreateHospitalBranchCommand} [createHospitalBranchCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalbranchesPost(createHospitalBranchCommand?: CreateHospitalBranchCommand, options?: any): AxiosPromise<HospitalBranchModel>;
};
/**
 * Request parameters for apiV1HospitalbranchesGet operation in HospitalBranchesApi.
 * @export
 * @interface HospitalBranchesApiApiV1HospitalbranchesGetRequest
 */
export interface HospitalBranchesApiApiV1HospitalbranchesGetRequest {
    /**
     *
     * @type {string}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesGet
     */
    readonly id?: string;
    /**
     *
     * @type {string}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesGet
     */
    readonly hospitalGroupId?: string;
    /**
     *
     * @type {string}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesGet
     */
    readonly hospitalId?: string;
    /**
     *
     * @type {string}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {boolean}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesGet
     */
    readonly showHidden?: boolean;
    /**
     *
     * @type {number}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1HospitalbranchesHospitalBranchIdDelete operation in HospitalBranchesApi.
 * @export
 * @interface HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdDeleteRequest
 */
export interface HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdDelete
     */
    readonly hospitalBranchId: string;
    /**
     *
     * @type {boolean}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdDelete
     */
    readonly isPermanent?: boolean;
}
/**
 * Request parameters for apiV1HospitalbranchesHospitalBranchIdGet operation in HospitalBranchesApi.
 * @export
 * @interface HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdGetRequest
 */
export interface HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdGet
     */
    readonly hospitalBranchId: string;
    /**
     *
     * @type {string}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdGet
     */
    readonly languageCode?: string;
}
/**
 * Request parameters for apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdDelete operation in HospitalBranchesApi.
 * @export
 * @interface HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdDeleteRequest
 */
export interface HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdDelete
     */
    readonly hospitalBranchId: string;
    /**
     *
     * @type {string}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdDelete
     */
    readonly hospitalId: string;
}
/**
 * Request parameters for apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPost operation in HospitalBranchesApi.
 * @export
 * @interface HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPostRequest
 */
export interface HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPostRequest {
    /**
     *
     * @type {string}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPost
     */
    readonly hospitalBranchId: string;
    /**
     *
     * @type {string}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPost
     */
    readonly hospitalId: string;
    /**
     *
     * @type {AddHospitalIntoBranchCommand}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPost
     */
    readonly addHospitalIntoBranchCommand?: AddHospitalIntoBranchCommand;
}
/**
 * Request parameters for apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPut operation in HospitalBranchesApi.
 * @export
 * @interface HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPutRequest
 */
export interface HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPut
     */
    readonly hospitalBranchId: string;
    /**
     *
     * @type {string}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPut
     */
    readonly hospitalId: string;
    /**
     *
     * @type {UpdateHospitalBranchItemCommand}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPut
     */
    readonly updateHospitalBranchItemCommand?: UpdateHospitalBranchItemCommand;
}
/**
 * Request parameters for apiV1HospitalbranchesHospitalBranchIdPut operation in HospitalBranchesApi.
 * @export
 * @interface HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdPutRequest
 */
export interface HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdPut
     */
    readonly hospitalBranchId: string;
    /**
     *
     * @type {UpdateHospitalBranchCommand}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdPut
     */
    readonly updateHospitalBranchCommand?: UpdateHospitalBranchCommand;
}
/**
 * Request parameters for apiV1HospitalbranchesHospitalBranchIdReactivatePut operation in HospitalBranchesApi.
 * @export
 * @interface HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdReactivatePutRequest
 */
export interface HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdReactivatePutRequest {
    /**
     *
     * @type {string}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdReactivatePut
     */
    readonly hospitalBranchId: string;
}
/**
 * Request parameters for apiV1HospitalbranchesPost operation in HospitalBranchesApi.
 * @export
 * @interface HospitalBranchesApiApiV1HospitalbranchesPostRequest
 */
export interface HospitalBranchesApiApiV1HospitalbranchesPostRequest {
    /**
     *
     * @type {CreateHospitalBranchCommand}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesPost
     */
    readonly createHospitalBranchCommand?: CreateHospitalBranchCommand;
}
/**
 * HospitalBranchesApi - object-oriented interface
 * @export
 * @class HospitalBranchesApi
 * @extends {BaseAPI}
 */
export declare class HospitalBranchesApi extends BaseAPI {
    /**
     *
     * @summary Get hospitalBranches
     * @param {HospitalBranchesApiApiV1HospitalbranchesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HospitalBranchesApi
     */
    apiV1HospitalbranchesGet(requestParameters?: HospitalBranchesApiApiV1HospitalbranchesGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<HospitalBranchesModel, any>>;
    /**
     *
     * @summary Delete hospitalBranch
     * @param {HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HospitalBranchesApi
     */
    apiV1HospitalbranchesHospitalBranchIdDelete(requestParameters: HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get hospitalBranch
     * @param {HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HospitalBranchesApi
     */
    apiV1HospitalbranchesHospitalBranchIdGet(requestParameters: HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<HospitalBranchModel, any>>;
    /**
     *
     * @summary Remove hospital from HospitalBranch
     * @param {HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HospitalBranchesApi
     */
    apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdDelete(requestParameters: HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Add hospital into HospitalBranch
     * @param {HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HospitalBranchesApi
     */
    apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPost(requestParameters: HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<HospitalBranchModel, any>>;
    /**
     *
     * @summary Update hospitalBranchItem
     * @param {HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HospitalBranchesApi
     */
    apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPut(requestParameters: HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<HospitalBranchModel, any>>;
    /**
     *
     * @summary Update hospitalBranch
     * @param {HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HospitalBranchesApi
     */
    apiV1HospitalbranchesHospitalBranchIdPut(requestParameters: HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<HospitalBranchModel, any>>;
    /**
     *
     * @summary Reactivate hospitalBranch
     * @param {HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdReactivatePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HospitalBranchesApi
     */
    apiV1HospitalbranchesHospitalBranchIdReactivatePut(requestParameters: HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdReactivatePutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Create hospitalBranch
     * @param {HospitalBranchesApiApiV1HospitalbranchesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HospitalBranchesApi
     */
    apiV1HospitalbranchesPost(requestParameters?: HospitalBranchesApiApiV1HospitalbranchesPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<HospitalBranchModel, any>>;
}
//# sourceMappingURL=hospital-branches-api.d.ts.map