/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { MediaModel } from '../models';
import { UploadMediaFromUriCommand } from '../models';
import { UploadedMediasModel } from '../models';
/**
 * ImagesApi - axios parameter creator
 * @export
 */
export declare const ImagesApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @param {Array<File>} [files]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ImagesPost: (files?: Array<File>, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Upload media from uri
     * @param {UploadMediaFromUriCommand} [uploadMediaFromUriCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ImagesUriPost: (uploadMediaFromUriCommand?: UploadMediaFromUriCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * ImagesApi - functional programming interface
 * @export
 */
export declare const ImagesApiFp: (configuration?: Configuration) => {
    /**
     *
     * @param {Array<File>} [files]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ImagesPost(files?: Array<File>, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<MediaModel>>>;
    /**
     *
     * @summary Upload media from uri
     * @param {UploadMediaFromUriCommand} [uploadMediaFromUriCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ImagesUriPost(uploadMediaFromUriCommand?: UploadMediaFromUriCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<UploadedMediasModel>>;
};
/**
 * ImagesApi - factory interface
 * @export
 */
export declare const ImagesApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @param {Array<File>} [files]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ImagesPost(files?: Array<File>, options?: any): AxiosPromise<Array<MediaModel>>;
    /**
     *
     * @summary Upload media from uri
     * @param {UploadMediaFromUriCommand} [uploadMediaFromUriCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ImagesUriPost(uploadMediaFromUriCommand?: UploadMediaFromUriCommand, options?: any): AxiosPromise<UploadedMediasModel>;
};
/**
 * Request parameters for apiV1ImagesPost operation in ImagesApi.
 * @export
 * @interface ImagesApiApiV1ImagesPostRequest
 */
export interface ImagesApiApiV1ImagesPostRequest {
    /**
     *
     * @type {Array<File>}
     * @memberof ImagesApiApiV1ImagesPost
     */
    readonly files?: Array<File>;
}
/**
 * Request parameters for apiV1ImagesUriPost operation in ImagesApi.
 * @export
 * @interface ImagesApiApiV1ImagesUriPostRequest
 */
export interface ImagesApiApiV1ImagesUriPostRequest {
    /**
     *
     * @type {UploadMediaFromUriCommand}
     * @memberof ImagesApiApiV1ImagesUriPost
     */
    readonly uploadMediaFromUriCommand?: UploadMediaFromUriCommand;
}
/**
 * ImagesApi - object-oriented interface
 * @export
 * @class ImagesApi
 * @extends {BaseAPI}
 */
export declare class ImagesApi extends BaseAPI {
    /**
     *
     * @param {ImagesApiApiV1ImagesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ImagesApi
     */
    apiV1ImagesPost(requestParameters?: ImagesApiApiV1ImagesPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<MediaModel[], any>>;
    /**
     *
     * @summary Upload media from uri
     * @param {ImagesApiApiV1ImagesUriPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ImagesApi
     */
    apiV1ImagesUriPost(requestParameters?: ImagesApiApiV1ImagesUriPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<UploadedMediasModel, any>>;
}
//# sourceMappingURL=images-api.d.ts.map