/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { CreateMediaCommand } from '../models';
import { CreateSpecialtyCommand } from '../models';
import { MarketingType } from '../models';
import { MediaModel } from '../models';
import { MediaType } from '../models';
import { MediasModel } from '../models';
import { SpecialtiesModel } from '../models';
import { SpecialtiesSimpleModel } from '../models';
import { SpecialtyModel } from '../models';
import { TranslateSpecialtyCommand } from '../models';
import { UpdateMediaCommand } from '../models';
import { UpdateSpecialtyCommand } from '../models';
/**
 * SpecialtiesApi - axios parameter creator
 * @export
 */
export declare const SpecialtiesApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Get all Specialties.
     * @param {string} [id]
     * @param {string} [name]
     * @param {string} [description]
     * @param {string} [specialtyTypeId]
     * @param {MarketingType} [marketingType]
     * @param {string} [hospitalId]
     * @param {Date} [created]
     * @param {string} [languageCode]
     * @param {Array<string>} [ids]
     * @param {boolean} [showHidden]
     * @param {boolean} [returnDefaultValue]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesGet: (id?: string, name?: string, description?: string, specialtyTypeId?: string, marketingType?: MarketingType, hospitalId?: string, created?: Date, languageCode?: string, ids?: Array<string>, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create a Specialty.
     * @param {CreateSpecialtyCommand} [createSpecialtyCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesPost: (createSpecialtyCommand?: CreateSpecialtyCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get all Specialties Simple.
     * @param {string} [id]
     * @param {string} [name]
     * @param {string} [description]
     * @param {string} [specialtyTypeId]
     * @param {MarketingType} [marketingType]
     * @param {string} [hospitalId]
     * @param {Date} [created]
     * @param {string} [languageCode]
     * @param {Array<string>} [ids]
     * @param {boolean} [showHidden]
     * @param {boolean} [returnDefaultValue]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSimpleGet: (id?: string, name?: string, description?: string, specialtyTypeId?: string, marketingType?: MarketingType, hospitalId?: string, created?: Date, languageCode?: string, ids?: Array<string>, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary
     * @param {string} slug
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSlugGet: (slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete Specialty.
     * @param {string} specialtyId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdDelete: (specialtyId: string, isPermanent?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get Specialty.
     * @param {string} specialtyId
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdGet: (specialtyId: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get all SpecialtyMedias.
     * @param {string} specialtyId
     * @param {string} [id]
     * @param {MediaType} [mediaType]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdMediasGet: (specialtyId: string, id?: string, mediaType?: MediaType, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete SpecialtyMedia
     * @param {string} specialtyId
     * @param {string} mediaId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdMediasMediaIdDelete: (specialtyId: string, mediaId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get SpecialtyMedia.
     * @param {string} specialtyId
     * @param {string} mediaId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdMediasMediaIdGet: (specialtyId: string, mediaId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update SpecialtyMedia.
     * @param {string} specialtyId
     * @param {string} mediaId
     * @param {UpdateMediaCommand} [updateMediaCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdMediasMediaIdPut: (specialtyId: string, mediaId: string, updateMediaCommand?: UpdateMediaCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create SpecialtyMedia.
     * @param {string} specialtyId
     * @param {CreateMediaCommand} [createMediaCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdMediasPost: (specialtyId: string, createMediaCommand?: CreateMediaCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update Specialty.
     * @param {string} specialtyId
     * @param {UpdateSpecialtyCommand} [updateSpecialtyCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdPut: (specialtyId: string, updateSpecialtyCommand?: UpdateSpecialtyCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Reactivate Specialty.
     * @param {string} specialtyId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdReactivatePut: (specialtyId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Revalidate specialty
     * @param {string} specialtyId
     * @param {boolean} [includeCurrent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdRevalidatePost: (specialtyId: string, includeCurrent?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Translate specialty
     * @param {string} specialtyId
     * @param {TranslateSpecialtyCommand} [translateSpecialtyCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdTranslatePost: (specialtyId: string, translateSpecialtyCommand?: TranslateSpecialtyCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * SpecialtiesApi - functional programming interface
 * @export
 */
export declare const SpecialtiesApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Get all Specialties.
     * @param {string} [id]
     * @param {string} [name]
     * @param {string} [description]
     * @param {string} [specialtyTypeId]
     * @param {MarketingType} [marketingType]
     * @param {string} [hospitalId]
     * @param {Date} [created]
     * @param {string} [languageCode]
     * @param {Array<string>} [ids]
     * @param {boolean} [showHidden]
     * @param {boolean} [returnDefaultValue]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesGet(id?: string, name?: string, description?: string, specialtyTypeId?: string, marketingType?: MarketingType, hospitalId?: string, created?: Date, languageCode?: string, ids?: Array<string>, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SpecialtiesModel>>;
    /**
     *
     * @summary Create a Specialty.
     * @param {CreateSpecialtyCommand} [createSpecialtyCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesPost(createSpecialtyCommand?: CreateSpecialtyCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SpecialtyModel>>;
    /**
     *
     * @summary Get all Specialties Simple.
     * @param {string} [id]
     * @param {string} [name]
     * @param {string} [description]
     * @param {string} [specialtyTypeId]
     * @param {MarketingType} [marketingType]
     * @param {string} [hospitalId]
     * @param {Date} [created]
     * @param {string} [languageCode]
     * @param {Array<string>} [ids]
     * @param {boolean} [showHidden]
     * @param {boolean} [returnDefaultValue]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSimpleGet(id?: string, name?: string, description?: string, specialtyTypeId?: string, marketingType?: MarketingType, hospitalId?: string, created?: Date, languageCode?: string, ids?: Array<string>, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SpecialtiesSimpleModel>>;
    /**
     *
     * @summary
     * @param {string} slug
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSlugGet(slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SpecialtyModel>>;
    /**
     *
     * @summary Delete Specialty.
     * @param {string} specialtyId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdDelete(specialtyId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get Specialty.
     * @param {string} specialtyId
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdGet(specialtyId: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SpecialtyModel>>;
    /**
     *
     * @summary Get all SpecialtyMedias.
     * @param {string} specialtyId
     * @param {string} [id]
     * @param {MediaType} [mediaType]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdMediasGet(specialtyId: string, id?: string, mediaType?: MediaType, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediasModel>>;
    /**
     *
     * @summary Delete SpecialtyMedia
     * @param {string} specialtyId
     * @param {string} mediaId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdMediasMediaIdDelete(specialtyId: string, mediaId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get SpecialtyMedia.
     * @param {string} specialtyId
     * @param {string} mediaId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdMediasMediaIdGet(specialtyId: string, mediaId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediaModel>>;
    /**
     *
     * @summary Update SpecialtyMedia.
     * @param {string} specialtyId
     * @param {string} mediaId
     * @param {UpdateMediaCommand} [updateMediaCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdMediasMediaIdPut(specialtyId: string, mediaId: string, updateMediaCommand?: UpdateMediaCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediaModel>>;
    /**
     *
     * @summary Create SpecialtyMedia.
     * @param {string} specialtyId
     * @param {CreateMediaCommand} [createMediaCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdMediasPost(specialtyId: string, createMediaCommand?: CreateMediaCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediaModel>>;
    /**
     *
     * @summary Update Specialty.
     * @param {string} specialtyId
     * @param {UpdateSpecialtyCommand} [updateSpecialtyCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdPut(specialtyId: string, updateSpecialtyCommand?: UpdateSpecialtyCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SpecialtyModel>>;
    /**
     *
     * @summary Reactivate Specialty.
     * @param {string} specialtyId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdReactivatePut(specialtyId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Revalidate specialty
     * @param {string} specialtyId
     * @param {boolean} [includeCurrent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdRevalidatePost(specialtyId: string, includeCurrent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Translate specialty
     * @param {string} specialtyId
     * @param {TranslateSpecialtyCommand} [translateSpecialtyCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdTranslatePost(specialtyId: string, translateSpecialtyCommand?: TranslateSpecialtyCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
};
/**
 * SpecialtiesApi - factory interface
 * @export
 */
export declare const SpecialtiesApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Get all Specialties.
     * @param {string} [id]
     * @param {string} [name]
     * @param {string} [description]
     * @param {string} [specialtyTypeId]
     * @param {MarketingType} [marketingType]
     * @param {string} [hospitalId]
     * @param {Date} [created]
     * @param {string} [languageCode]
     * @param {Array<string>} [ids]
     * @param {boolean} [showHidden]
     * @param {boolean} [returnDefaultValue]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesGet(id?: string, name?: string, description?: string, specialtyTypeId?: string, marketingType?: MarketingType, hospitalId?: string, created?: Date, languageCode?: string, ids?: Array<string>, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<SpecialtiesModel>;
    /**
     *
     * @summary Create a Specialty.
     * @param {CreateSpecialtyCommand} [createSpecialtyCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesPost(createSpecialtyCommand?: CreateSpecialtyCommand, options?: any): AxiosPromise<SpecialtyModel>;
    /**
     *
     * @summary Get all Specialties Simple.
     * @param {string} [id]
     * @param {string} [name]
     * @param {string} [description]
     * @param {string} [specialtyTypeId]
     * @param {MarketingType} [marketingType]
     * @param {string} [hospitalId]
     * @param {Date} [created]
     * @param {string} [languageCode]
     * @param {Array<string>} [ids]
     * @param {boolean} [showHidden]
     * @param {boolean} [returnDefaultValue]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSimpleGet(id?: string, name?: string, description?: string, specialtyTypeId?: string, marketingType?: MarketingType, hospitalId?: string, created?: Date, languageCode?: string, ids?: Array<string>, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<SpecialtiesSimpleModel>;
    /**
     *
     * @summary
     * @param {string} slug
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSlugGet(slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: any): AxiosPromise<SpecialtyModel>;
    /**
     *
     * @summary Delete Specialty.
     * @param {string} specialtyId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdDelete(specialtyId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get Specialty.
     * @param {string} specialtyId
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdGet(specialtyId: string, languageCode?: string, returnDefaultValue?: boolean, options?: any): AxiosPromise<SpecialtyModel>;
    /**
     *
     * @summary Get all SpecialtyMedias.
     * @param {string} specialtyId
     * @param {string} [id]
     * @param {MediaType} [mediaType]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdMediasGet(specialtyId: string, id?: string, mediaType?: MediaType, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<MediasModel>;
    /**
     *
     * @summary Delete SpecialtyMedia
     * @param {string} specialtyId
     * @param {string} mediaId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdMediasMediaIdDelete(specialtyId: string, mediaId: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get SpecialtyMedia.
     * @param {string} specialtyId
     * @param {string} mediaId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdMediasMediaIdGet(specialtyId: string, mediaId: string, options?: any): AxiosPromise<MediaModel>;
    /**
     *
     * @summary Update SpecialtyMedia.
     * @param {string} specialtyId
     * @param {string} mediaId
     * @param {UpdateMediaCommand} [updateMediaCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdMediasMediaIdPut(specialtyId: string, mediaId: string, updateMediaCommand?: UpdateMediaCommand, options?: any): AxiosPromise<MediaModel>;
    /**
     *
     * @summary Create SpecialtyMedia.
     * @param {string} specialtyId
     * @param {CreateMediaCommand} [createMediaCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdMediasPost(specialtyId: string, createMediaCommand?: CreateMediaCommand, options?: any): AxiosPromise<MediaModel>;
    /**
     *
     * @summary Update Specialty.
     * @param {string} specialtyId
     * @param {UpdateSpecialtyCommand} [updateSpecialtyCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdPut(specialtyId: string, updateSpecialtyCommand?: UpdateSpecialtyCommand, options?: any): AxiosPromise<SpecialtyModel>;
    /**
     *
     * @summary Reactivate Specialty.
     * @param {string} specialtyId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdReactivatePut(specialtyId: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Revalidate specialty
     * @param {string} specialtyId
     * @param {boolean} [includeCurrent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdRevalidatePost(specialtyId: string, includeCurrent?: boolean, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Translate specialty
     * @param {string} specialtyId
     * @param {TranslateSpecialtyCommand} [translateSpecialtyCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SpecialtiesSpecialtyIdTranslatePost(specialtyId: string, translateSpecialtyCommand?: TranslateSpecialtyCommand, options?: any): AxiosPromise<boolean>;
};
/**
 * Request parameters for apiV1SpecialtiesGet operation in SpecialtiesApi.
 * @export
 * @interface SpecialtiesApiApiV1SpecialtiesGetRequest
 */
export interface SpecialtiesApiApiV1SpecialtiesGetRequest {
    /**
     *
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesGet
     */
    readonly id?: string;
    /**
     *
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesGet
     */
    readonly name?: string;
    /**
     *
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesGet
     */
    readonly description?: string;
    /**
     *
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesGet
     */
    readonly specialtyTypeId?: string;
    /**
     *
     * @type {MarketingType}
     * @memberof SpecialtiesApiApiV1SpecialtiesGet
     */
    readonly marketingType?: MarketingType;
    /**
     *
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesGet
     */
    readonly hospitalId?: string;
    /**
     *
     * @type {Date}
     * @memberof SpecialtiesApiApiV1SpecialtiesGet
     */
    readonly created?: Date;
    /**
     *
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {Array<string>}
     * @memberof SpecialtiesApiApiV1SpecialtiesGet
     */
    readonly ids?: Array<string>;
    /**
     *
     * @type {boolean}
     * @memberof SpecialtiesApiApiV1SpecialtiesGet
     */
    readonly showHidden?: boolean;
    /**
     *
     * @type {boolean}
     * @memberof SpecialtiesApiApiV1SpecialtiesGet
     */
    readonly returnDefaultValue?: boolean;
    /**
     *
     * @type {number}
     * @memberof SpecialtiesApiApiV1SpecialtiesGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof SpecialtiesApiApiV1SpecialtiesGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof SpecialtiesApiApiV1SpecialtiesGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1SpecialtiesPost operation in SpecialtiesApi.
 * @export
 * @interface SpecialtiesApiApiV1SpecialtiesPostRequest
 */
export interface SpecialtiesApiApiV1SpecialtiesPostRequest {
    /**
     *
     * @type {CreateSpecialtyCommand}
     * @memberof SpecialtiesApiApiV1SpecialtiesPost
     */
    readonly createSpecialtyCommand?: CreateSpecialtyCommand;
}
/**
 * Request parameters for apiV1SpecialtiesSimpleGet operation in SpecialtiesApi.
 * @export
 * @interface SpecialtiesApiApiV1SpecialtiesSimpleGetRequest
 */
export interface SpecialtiesApiApiV1SpecialtiesSimpleGetRequest {
    /**
     *
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSimpleGet
     */
    readonly id?: string;
    /**
     *
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSimpleGet
     */
    readonly name?: string;
    /**
     *
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSimpleGet
     */
    readonly description?: string;
    /**
     *
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSimpleGet
     */
    readonly specialtyTypeId?: string;
    /**
     *
     * @type {MarketingType}
     * @memberof SpecialtiesApiApiV1SpecialtiesSimpleGet
     */
    readonly marketingType?: MarketingType;
    /**
     *
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSimpleGet
     */
    readonly hospitalId?: string;
    /**
     *
     * @type {Date}
     * @memberof SpecialtiesApiApiV1SpecialtiesSimpleGet
     */
    readonly created?: Date;
    /**
     *
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSimpleGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {Array<string>}
     * @memberof SpecialtiesApiApiV1SpecialtiesSimpleGet
     */
    readonly ids?: Array<string>;
    /**
     *
     * @type {boolean}
     * @memberof SpecialtiesApiApiV1SpecialtiesSimpleGet
     */
    readonly showHidden?: boolean;
    /**
     *
     * @type {boolean}
     * @memberof SpecialtiesApiApiV1SpecialtiesSimpleGet
     */
    readonly returnDefaultValue?: boolean;
    /**
     *
     * @type {number}
     * @memberof SpecialtiesApiApiV1SpecialtiesSimpleGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof SpecialtiesApiApiV1SpecialtiesSimpleGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof SpecialtiesApiApiV1SpecialtiesSimpleGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1SpecialtiesSlugGet operation in SpecialtiesApi.
 * @export
 * @interface SpecialtiesApiApiV1SpecialtiesSlugGetRequest
 */
export interface SpecialtiesApiApiV1SpecialtiesSlugGetRequest {
    /**
     *
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSlugGet
     */
    readonly slug: string;
    /**
     *
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSlugGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {boolean}
     * @memberof SpecialtiesApiApiV1SpecialtiesSlugGet
     */
    readonly returnDefaultValue?: boolean;
}
/**
 * Request parameters for apiV1SpecialtiesSpecialtyIdDelete operation in SpecialtiesApi.
 * @export
 * @interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdDeleteRequest
 */
export interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdDelete
     */
    readonly specialtyId: string;
    /**
     *
     * @type {boolean}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdDelete
     */
    readonly isPermanent?: boolean;
}
/**
 * Request parameters for apiV1SpecialtiesSpecialtyIdGet operation in SpecialtiesApi.
 * @export
 * @interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdGetRequest
 */
export interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdGet
     */
    readonly specialtyId: string;
    /**
     *
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {boolean}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdGet
     */
    readonly returnDefaultValue?: boolean;
}
/**
 * Request parameters for apiV1SpecialtiesSpecialtyIdMediasGet operation in SpecialtiesApi.
 * @export
 * @interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasGetRequest
 */
export interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasGetRequest {
    /**
     *
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasGet
     */
    readonly specialtyId: string;
    /**
     *
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasGet
     */
    readonly id?: string;
    /**
     *
     * @type {MediaType}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasGet
     */
    readonly mediaType?: MediaType;
    /**
     *
     * @type {number}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1SpecialtiesSpecialtyIdMediasMediaIdDelete operation in SpecialtiesApi.
 * @export
 * @interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdDeleteRequest
 */
export interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdDelete
     */
    readonly specialtyId: string;
    /**
     *
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdDelete
     */
    readonly mediaId: string;
}
/**
 * Request parameters for apiV1SpecialtiesSpecialtyIdMediasMediaIdGet operation in SpecialtiesApi.
 * @export
 * @interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdGetRequest
 */
export interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdGet
     */
    readonly specialtyId: string;
    /**
     *
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdGet
     */
    readonly mediaId: string;
}
/**
 * Request parameters for apiV1SpecialtiesSpecialtyIdMediasMediaIdPut operation in SpecialtiesApi.
 * @export
 * @interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdPutRequest
 */
export interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdPut
     */
    readonly specialtyId: string;
    /**
     *
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdPut
     */
    readonly mediaId: string;
    /**
     *
     * @type {UpdateMediaCommand}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdPut
     */
    readonly updateMediaCommand?: UpdateMediaCommand;
}
/**
 * Request parameters for apiV1SpecialtiesSpecialtyIdMediasPost operation in SpecialtiesApi.
 * @export
 * @interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasPostRequest
 */
export interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasPostRequest {
    /**
     *
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasPost
     */
    readonly specialtyId: string;
    /**
     *
     * @type {CreateMediaCommand}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasPost
     */
    readonly createMediaCommand?: CreateMediaCommand;
}
/**
 * Request parameters for apiV1SpecialtiesSpecialtyIdPut operation in SpecialtiesApi.
 * @export
 * @interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdPutRequest
 */
export interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdPut
     */
    readonly specialtyId: string;
    /**
     *
     * @type {UpdateSpecialtyCommand}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdPut
     */
    readonly updateSpecialtyCommand?: UpdateSpecialtyCommand;
}
/**
 * Request parameters for apiV1SpecialtiesSpecialtyIdReactivatePut operation in SpecialtiesApi.
 * @export
 * @interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdReactivatePutRequest
 */
export interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdReactivatePutRequest {
    /**
     *
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdReactivatePut
     */
    readonly specialtyId: string;
}
/**
 * Request parameters for apiV1SpecialtiesSpecialtyIdRevalidatePost operation in SpecialtiesApi.
 * @export
 * @interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdRevalidatePostRequest
 */
export interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdRevalidatePostRequest {
    /**
     *
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdRevalidatePost
     */
    readonly specialtyId: string;
    /**
     *
     * @type {boolean}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdRevalidatePost
     */
    readonly includeCurrent?: boolean;
}
/**
 * Request parameters for apiV1SpecialtiesSpecialtyIdTranslatePost operation in SpecialtiesApi.
 * @export
 * @interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdTranslatePostRequest
 */
export interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdTranslatePostRequest {
    /**
     *
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdTranslatePost
     */
    readonly specialtyId: string;
    /**
     *
     * @type {TranslateSpecialtyCommand}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdTranslatePost
     */
    readonly translateSpecialtyCommand?: TranslateSpecialtyCommand;
}
/**
 * SpecialtiesApi - object-oriented interface
 * @export
 * @class SpecialtiesApi
 * @extends {BaseAPI}
 */
export declare class SpecialtiesApi extends BaseAPI {
    /**
     *
     * @summary Get all Specialties.
     * @param {SpecialtiesApiApiV1SpecialtiesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtiesApi
     */
    apiV1SpecialtiesGet(requestParameters?: SpecialtiesApiApiV1SpecialtiesGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SpecialtiesModel, any>>;
    /**
     *
     * @summary Create a Specialty.
     * @param {SpecialtiesApiApiV1SpecialtiesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtiesApi
     */
    apiV1SpecialtiesPost(requestParameters?: SpecialtiesApiApiV1SpecialtiesPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SpecialtyModel, any>>;
    /**
     *
     * @summary Get all Specialties Simple.
     * @param {SpecialtiesApiApiV1SpecialtiesSimpleGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtiesApi
     */
    apiV1SpecialtiesSimpleGet(requestParameters?: SpecialtiesApiApiV1SpecialtiesSimpleGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SpecialtiesSimpleModel, any>>;
    /**
     *
     * @summary
     * @param {SpecialtiesApiApiV1SpecialtiesSlugGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtiesApi
     */
    apiV1SpecialtiesSlugGet(requestParameters: SpecialtiesApiApiV1SpecialtiesSlugGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SpecialtyModel, any>>;
    /**
     *
     * @summary Delete Specialty.
     * @param {SpecialtiesApiApiV1SpecialtiesSpecialtyIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtiesApi
     */
    apiV1SpecialtiesSpecialtyIdDelete(requestParameters: SpecialtiesApiApiV1SpecialtiesSpecialtyIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get Specialty.
     * @param {SpecialtiesApiApiV1SpecialtiesSpecialtyIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtiesApi
     */
    apiV1SpecialtiesSpecialtyIdGet(requestParameters: SpecialtiesApiApiV1SpecialtiesSpecialtyIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SpecialtyModel, any>>;
    /**
     *
     * @summary Get all SpecialtyMedias.
     * @param {SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtiesApi
     */
    apiV1SpecialtiesSpecialtyIdMediasGet(requestParameters: SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<MediasModel, any>>;
    /**
     *
     * @summary Delete SpecialtyMedia
     * @param {SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtiesApi
     */
    apiV1SpecialtiesSpecialtyIdMediasMediaIdDelete(requestParameters: SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get SpecialtyMedia.
     * @param {SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtiesApi
     */
    apiV1SpecialtiesSpecialtyIdMediasMediaIdGet(requestParameters: SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<MediaModel, any>>;
    /**
     *
     * @summary Update SpecialtyMedia.
     * @param {SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtiesApi
     */
    apiV1SpecialtiesSpecialtyIdMediasMediaIdPut(requestParameters: SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<MediaModel, any>>;
    /**
     *
     * @summary Create SpecialtyMedia.
     * @param {SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtiesApi
     */
    apiV1SpecialtiesSpecialtyIdMediasPost(requestParameters: SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<MediaModel, any>>;
    /**
     *
     * @summary Update Specialty.
     * @param {SpecialtiesApiApiV1SpecialtiesSpecialtyIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtiesApi
     */
    apiV1SpecialtiesSpecialtyIdPut(requestParameters: SpecialtiesApiApiV1SpecialtiesSpecialtyIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SpecialtyModel, any>>;
    /**
     *
     * @summary Reactivate Specialty.
     * @param {SpecialtiesApiApiV1SpecialtiesSpecialtyIdReactivatePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtiesApi
     */
    apiV1SpecialtiesSpecialtyIdReactivatePut(requestParameters: SpecialtiesApiApiV1SpecialtiesSpecialtyIdReactivatePutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Revalidate specialty
     * @param {SpecialtiesApiApiV1SpecialtiesSpecialtyIdRevalidatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtiesApi
     */
    apiV1SpecialtiesSpecialtyIdRevalidatePost(requestParameters: SpecialtiesApiApiV1SpecialtiesSpecialtyIdRevalidatePostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Translate specialty
     * @param {SpecialtiesApiApiV1SpecialtiesSpecialtyIdTranslatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtiesApi
     */
    apiV1SpecialtiesSpecialtyIdTranslatePost(requestParameters: SpecialtiesApiApiV1SpecialtiesSpecialtyIdTranslatePostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
}
//# sourceMappingURL=specialties-api.d.ts.map