/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { CountriesModel } from '../models';
// @ts-ignore
import { CountryModel } from '../models';
// @ts-ignore
import { CountrySortingCommand } from '../models';
// @ts-ignore
import { CreateCountryCommand } from '../models';
// @ts-ignore
import { CreateMediaCommand } from '../models';
// @ts-ignore
import { MediaModel } from '../models';
// @ts-ignore
import { MediaType } from '../models';
// @ts-ignore
import { MediasModel } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { SortingResultModel } from '../models';
// @ts-ignore
import { TranslateCountryCommand } from '../models';
// @ts-ignore
import { UpdateCountryCommand } from '../models';
// @ts-ignore
import { UpdateMediaCommand } from '../models';
/**
 * CountriesApi - axios parameter creator
 * @export
 */
export const CountriesApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Delete country.
         * @param {string} countryId 
         * @param {boolean} [isPermanent] Admin only
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CountriesCountryIdDelete: async (countryId: string, isPermanent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'countryId' is not null or undefined
            assertParamExists('apiV1CountriesCountryIdDelete', 'countryId', countryId)
            const localVarPath = `/api/v1/countries/{countryId}`
                .replace(`{${"countryId"}}`, encodeURIComponent(String(countryId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (isPermanent !== undefined) {
                localVarQueryParameter['isPermanent'] = isPermanent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get country.
         * @param {string} countryId 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CountriesCountryIdGet: async (countryId: string, languageCode?: string, returnDefaultValue?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'countryId' is not null or undefined
            assertParamExists('apiV1CountriesCountryIdGet', 'countryId', countryId)
            const localVarPath = `/api/v1/countries/{countryId}`
                .replace(`{${"countryId"}}`, encodeURIComponent(String(countryId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }

            if (returnDefaultValue !== undefined) {
                localVarQueryParameter['returnDefaultValue'] = returnDefaultValue;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all CountryMedias.
         * @param {string} countryId 
         * @param {string} [id] 
         * @param {MediaType} [mediaType] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CountriesCountryIdMediasGet: async (countryId: string, id?: string, mediaType?: MediaType, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'countryId' is not null or undefined
            assertParamExists('apiV1CountriesCountryIdMediasGet', 'countryId', countryId)
            const localVarPath = `/api/v1/countries/{countryId}/medias`
                .replace(`{${"countryId"}}`, encodeURIComponent(String(countryId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (mediaType !== undefined) {
                localVarQueryParameter['MediaType'] = mediaType;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete CountryMedia
         * @param {string} countryId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CountriesCountryIdMediasMediaIdDelete: async (countryId: string, mediaId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'countryId' is not null or undefined
            assertParamExists('apiV1CountriesCountryIdMediasMediaIdDelete', 'countryId', countryId)
            // verify required parameter 'mediaId' is not null or undefined
            assertParamExists('apiV1CountriesCountryIdMediasMediaIdDelete', 'mediaId', mediaId)
            const localVarPath = `/api/v1/countries/{countryId}/medias/{mediaId}`
                .replace(`{${"countryId"}}`, encodeURIComponent(String(countryId)))
                .replace(`{${"mediaId"}}`, encodeURIComponent(String(mediaId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get CountryMedia.
         * @param {string} countryId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CountriesCountryIdMediasMediaIdGet: async (countryId: string, mediaId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'countryId' is not null or undefined
            assertParamExists('apiV1CountriesCountryIdMediasMediaIdGet', 'countryId', countryId)
            // verify required parameter 'mediaId' is not null or undefined
            assertParamExists('apiV1CountriesCountryIdMediasMediaIdGet', 'mediaId', mediaId)
            const localVarPath = `/api/v1/countries/{countryId}/medias/{mediaId}`
                .replace(`{${"countryId"}}`, encodeURIComponent(String(countryId)))
                .replace(`{${"mediaId"}}`, encodeURIComponent(String(mediaId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update CountryMedia.
         * @param {string} countryId 
         * @param {string} mediaId 
         * @param {UpdateMediaCommand} [updateMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CountriesCountryIdMediasMediaIdPut: async (countryId: string, mediaId: string, updateMediaCommand?: UpdateMediaCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'countryId' is not null or undefined
            assertParamExists('apiV1CountriesCountryIdMediasMediaIdPut', 'countryId', countryId)
            // verify required parameter 'mediaId' is not null or undefined
            assertParamExists('apiV1CountriesCountryIdMediasMediaIdPut', 'mediaId', mediaId)
            const localVarPath = `/api/v1/countries/{countryId}/medias/{mediaId}`
                .replace(`{${"countryId"}}`, encodeURIComponent(String(countryId)))
                .replace(`{${"mediaId"}}`, encodeURIComponent(String(mediaId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateMediaCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create CountryMedia.
         * @param {string} countryId 
         * @param {CreateMediaCommand} [createMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CountriesCountryIdMediasPost: async (countryId: string, createMediaCommand?: CreateMediaCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'countryId' is not null or undefined
            assertParamExists('apiV1CountriesCountryIdMediasPost', 'countryId', countryId)
            const localVarPath = `/api/v1/countries/{countryId}/medias`
                .replace(`{${"countryId"}}`, encodeURIComponent(String(countryId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createMediaCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update country.
         * @param {string} countryId 
         * @param {UpdateCountryCommand} [updateCountryCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CountriesCountryIdPut: async (countryId: string, updateCountryCommand?: UpdateCountryCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'countryId' is not null or undefined
            assertParamExists('apiV1CountriesCountryIdPut', 'countryId', countryId)
            const localVarPath = `/api/v1/countries/{countryId}`
                .replace(`{${"countryId"}}`, encodeURIComponent(String(countryId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateCountryCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Reactivate country.
         * @param {string} countryId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CountriesCountryIdReactivatePut: async (countryId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'countryId' is not null or undefined
            assertParamExists('apiV1CountriesCountryIdReactivatePut', 'countryId', countryId)
            const localVarPath = `/api/v1/countries/{countryId}/reactivate`
                .replace(`{${"countryId"}}`, encodeURIComponent(String(countryId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Revalidate country
         * @param {string} countryId 
         * @param {boolean} [includeCurrent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CountriesCountryIdRevalidatePost: async (countryId: string, includeCurrent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'countryId' is not null or undefined
            assertParamExists('apiV1CountriesCountryIdRevalidatePost', 'countryId', countryId)
            const localVarPath = `/api/v1/countries/{countryId}/revalidate`
                .replace(`{${"countryId"}}`, encodeURIComponent(String(countryId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (includeCurrent !== undefined) {
                localVarQueryParameter['includeCurrent'] = includeCurrent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Translate country
         * @param {string} countryId 
         * @param {TranslateCountryCommand} [translateCountryCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CountriesCountryIdTranslatePost: async (countryId: string, translateCountryCommand?: TranslateCountryCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'countryId' is not null or undefined
            assertParamExists('apiV1CountriesCountryIdTranslatePost', 'countryId', countryId)
            const localVarPath = `/api/v1/countries/{countryId}/translate`
                .replace(`{${"countryId"}}`, encodeURIComponent(String(countryId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(translateCountryCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all countries.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {string} [description] 
         * @param {Date} [createdDate] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CountriesGet: async (id?: string, name?: string, description?: string, createdDate?: Date, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/countries`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (name !== undefined) {
                localVarQueryParameter['Name'] = name;
            }

            if (description !== undefined) {
                localVarQueryParameter['Description'] = description;
            }

            if (createdDate !== undefined) {
                localVarQueryParameter['CreatedDate'] = (createdDate as any instanceof Date) ?
                    (createdDate as any).toISOString() :
                    createdDate;
            }

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }

            if (showHidden !== undefined) {
                localVarQueryParameter['ShowHidden'] = showHidden;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create a country.
         * @param {CreateCountryCommand} [createCountryCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CountriesPost: async (createCountryCommand?: CreateCountryCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/countries`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createCountryCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get country by slug
         * @param {string} slug 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CountriesSlugGet: async (slug: string, languageCode?: string, returnDefaultValue?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'slug' is not null or undefined
            assertParamExists('apiV1CountriesSlugGet', 'slug', slug)
            const localVarPath = `/api/v1/countries/{slug}`
                .replace(`{${"slug"}}`, encodeURIComponent(String(slug)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }

            if (returnDefaultValue !== undefined) {
                localVarQueryParameter['returnDefaultValue'] = returnDefaultValue;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Batch for countries sorting
         * @param {CountrySortingCommand} [countrySortingCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CountriesSortPut: async (countrySortingCommand?: CountrySortingCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/countries/sort`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(countrySortingCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * CountriesApi - functional programming interface
 * @export
 */
export const CountriesApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = CountriesApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Delete country.
         * @param {string} countryId 
         * @param {boolean} [isPermanent] Admin only
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CountriesCountryIdDelete(countryId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CountriesCountryIdDelete(countryId, isPermanent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get country.
         * @param {string} countryId 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CountriesCountryIdGet(countryId: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CountryModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CountriesCountryIdGet(countryId, languageCode, returnDefaultValue, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all CountryMedias.
         * @param {string} countryId 
         * @param {string} [id] 
         * @param {MediaType} [mediaType] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CountriesCountryIdMediasGet(countryId: string, id?: string, mediaType?: MediaType, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediasModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CountriesCountryIdMediasGet(countryId, id, mediaType, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete CountryMedia
         * @param {string} countryId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CountriesCountryIdMediasMediaIdDelete(countryId: string, mediaId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CountriesCountryIdMediasMediaIdDelete(countryId, mediaId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get CountryMedia.
         * @param {string} countryId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CountriesCountryIdMediasMediaIdGet(countryId: string, mediaId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediaModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CountriesCountryIdMediasMediaIdGet(countryId, mediaId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update CountryMedia.
         * @param {string} countryId 
         * @param {string} mediaId 
         * @param {UpdateMediaCommand} [updateMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CountriesCountryIdMediasMediaIdPut(countryId: string, mediaId: string, updateMediaCommand?: UpdateMediaCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediaModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CountriesCountryIdMediasMediaIdPut(countryId, mediaId, updateMediaCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create CountryMedia.
         * @param {string} countryId 
         * @param {CreateMediaCommand} [createMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CountriesCountryIdMediasPost(countryId: string, createMediaCommand?: CreateMediaCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediaModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CountriesCountryIdMediasPost(countryId, createMediaCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update country.
         * @param {string} countryId 
         * @param {UpdateCountryCommand} [updateCountryCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CountriesCountryIdPut(countryId: string, updateCountryCommand?: UpdateCountryCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CountryModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CountriesCountryIdPut(countryId, updateCountryCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Reactivate country.
         * @param {string} countryId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CountriesCountryIdReactivatePut(countryId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CountriesCountryIdReactivatePut(countryId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Revalidate country
         * @param {string} countryId 
         * @param {boolean} [includeCurrent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CountriesCountryIdRevalidatePost(countryId: string, includeCurrent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CountriesCountryIdRevalidatePost(countryId, includeCurrent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Translate country
         * @param {string} countryId 
         * @param {TranslateCountryCommand} [translateCountryCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CountriesCountryIdTranslatePost(countryId: string, translateCountryCommand?: TranslateCountryCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CountriesCountryIdTranslatePost(countryId, translateCountryCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all countries.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {string} [description] 
         * @param {Date} [createdDate] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CountriesGet(id?: string, name?: string, description?: string, createdDate?: Date, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CountriesModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CountriesGet(id, name, description, createdDate, languageCode, showHidden, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create a country.
         * @param {CreateCountryCommand} [createCountryCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CountriesPost(createCountryCommand?: CreateCountryCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CountryModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CountriesPost(createCountryCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get country by slug
         * @param {string} slug 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CountriesSlugGet(slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CountryModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CountriesSlugGet(slug, languageCode, returnDefaultValue, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Batch for countries sorting
         * @param {CountrySortingCommand} [countrySortingCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CountriesSortPut(countrySortingCommand?: CountrySortingCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SortingResultModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CountriesSortPut(countrySortingCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * CountriesApi - factory interface
 * @export
 */
export const CountriesApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = CountriesApiFp(configuration)
    return {
        /**
         * 
         * @summary Delete country.
         * @param {string} countryId 
         * @param {boolean} [isPermanent] Admin only
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CountriesCountryIdDelete(countryId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1CountriesCountryIdDelete(countryId, isPermanent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get country.
         * @param {string} countryId 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CountriesCountryIdGet(countryId: string, languageCode?: string, returnDefaultValue?: boolean, options?: any): AxiosPromise<CountryModel> {
            return localVarFp.apiV1CountriesCountryIdGet(countryId, languageCode, returnDefaultValue, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all CountryMedias.
         * @param {string} countryId 
         * @param {string} [id] 
         * @param {MediaType} [mediaType] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CountriesCountryIdMediasGet(countryId: string, id?: string, mediaType?: MediaType, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<MediasModel> {
            return localVarFp.apiV1CountriesCountryIdMediasGet(countryId, id, mediaType, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete CountryMedia
         * @param {string} countryId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CountriesCountryIdMediasMediaIdDelete(countryId: string, mediaId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1CountriesCountryIdMediasMediaIdDelete(countryId, mediaId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get CountryMedia.
         * @param {string} countryId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CountriesCountryIdMediasMediaIdGet(countryId: string, mediaId: string, options?: any): AxiosPromise<MediaModel> {
            return localVarFp.apiV1CountriesCountryIdMediasMediaIdGet(countryId, mediaId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update CountryMedia.
         * @param {string} countryId 
         * @param {string} mediaId 
         * @param {UpdateMediaCommand} [updateMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CountriesCountryIdMediasMediaIdPut(countryId: string, mediaId: string, updateMediaCommand?: UpdateMediaCommand, options?: any): AxiosPromise<MediaModel> {
            return localVarFp.apiV1CountriesCountryIdMediasMediaIdPut(countryId, mediaId, updateMediaCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create CountryMedia.
         * @param {string} countryId 
         * @param {CreateMediaCommand} [createMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CountriesCountryIdMediasPost(countryId: string, createMediaCommand?: CreateMediaCommand, options?: any): AxiosPromise<MediaModel> {
            return localVarFp.apiV1CountriesCountryIdMediasPost(countryId, createMediaCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update country.
         * @param {string} countryId 
         * @param {UpdateCountryCommand} [updateCountryCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CountriesCountryIdPut(countryId: string, updateCountryCommand?: UpdateCountryCommand, options?: any): AxiosPromise<CountryModel> {
            return localVarFp.apiV1CountriesCountryIdPut(countryId, updateCountryCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Reactivate country.
         * @param {string} countryId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CountriesCountryIdReactivatePut(countryId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1CountriesCountryIdReactivatePut(countryId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Revalidate country
         * @param {string} countryId 
         * @param {boolean} [includeCurrent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CountriesCountryIdRevalidatePost(countryId: string, includeCurrent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1CountriesCountryIdRevalidatePost(countryId, includeCurrent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Translate country
         * @param {string} countryId 
         * @param {TranslateCountryCommand} [translateCountryCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CountriesCountryIdTranslatePost(countryId: string, translateCountryCommand?: TranslateCountryCommand, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1CountriesCountryIdTranslatePost(countryId, translateCountryCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all countries.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {string} [description] 
         * @param {Date} [createdDate] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CountriesGet(id?: string, name?: string, description?: string, createdDate?: Date, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<CountriesModel> {
            return localVarFp.apiV1CountriesGet(id, name, description, createdDate, languageCode, showHidden, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create a country.
         * @param {CreateCountryCommand} [createCountryCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CountriesPost(createCountryCommand?: CreateCountryCommand, options?: any): AxiosPromise<CountryModel> {
            return localVarFp.apiV1CountriesPost(createCountryCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get country by slug
         * @param {string} slug 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CountriesSlugGet(slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: any): AxiosPromise<CountryModel> {
            return localVarFp.apiV1CountriesSlugGet(slug, languageCode, returnDefaultValue, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Batch for countries sorting
         * @param {CountrySortingCommand} [countrySortingCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CountriesSortPut(countrySortingCommand?: CountrySortingCommand, options?: any): AxiosPromise<SortingResultModel> {
            return localVarFp.apiV1CountriesSortPut(countrySortingCommand, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1CountriesCountryIdDelete operation in CountriesApi.
 * @export
 * @interface CountriesApiApiV1CountriesCountryIdDeleteRequest
 */
export interface CountriesApiApiV1CountriesCountryIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdDelete
     */
    readonly countryId: string

    /**
     * Admin only
     * @type {boolean}
     * @memberof CountriesApiApiV1CountriesCountryIdDelete
     */
    readonly isPermanent?: boolean
}

/**
 * Request parameters for apiV1CountriesCountryIdGet operation in CountriesApi.
 * @export
 * @interface CountriesApiApiV1CountriesCountryIdGetRequest
 */
export interface CountriesApiApiV1CountriesCountryIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdGet
     */
    readonly countryId: string

    /**
     * 
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof CountriesApiApiV1CountriesCountryIdGet
     */
    readonly returnDefaultValue?: boolean
}

/**
 * Request parameters for apiV1CountriesCountryIdMediasGet operation in CountriesApi.
 * @export
 * @interface CountriesApiApiV1CountriesCountryIdMediasGetRequest
 */
export interface CountriesApiApiV1CountriesCountryIdMediasGetRequest {
    /**
     * 
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdMediasGet
     */
    readonly countryId: string

    /**
     * 
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdMediasGet
     */
    readonly id?: string

    /**
     * 
     * @type {MediaType}
     * @memberof CountriesApiApiV1CountriesCountryIdMediasGet
     */
    readonly mediaType?: MediaType

    /**
     * 
     * @type {number}
     * @memberof CountriesApiApiV1CountriesCountryIdMediasGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof CountriesApiApiV1CountriesCountryIdMediasGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof CountriesApiApiV1CountriesCountryIdMediasGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1CountriesCountryIdMediasMediaIdDelete operation in CountriesApi.
 * @export
 * @interface CountriesApiApiV1CountriesCountryIdMediasMediaIdDeleteRequest
 */
export interface CountriesApiApiV1CountriesCountryIdMediasMediaIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdMediasMediaIdDelete
     */
    readonly countryId: string

    /**
     * 
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdMediasMediaIdDelete
     */
    readonly mediaId: string
}

/**
 * Request parameters for apiV1CountriesCountryIdMediasMediaIdGet operation in CountriesApi.
 * @export
 * @interface CountriesApiApiV1CountriesCountryIdMediasMediaIdGetRequest
 */
export interface CountriesApiApiV1CountriesCountryIdMediasMediaIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdMediasMediaIdGet
     */
    readonly countryId: string

    /**
     * 
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdMediasMediaIdGet
     */
    readonly mediaId: string
}

/**
 * Request parameters for apiV1CountriesCountryIdMediasMediaIdPut operation in CountriesApi.
 * @export
 * @interface CountriesApiApiV1CountriesCountryIdMediasMediaIdPutRequest
 */
export interface CountriesApiApiV1CountriesCountryIdMediasMediaIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdMediasMediaIdPut
     */
    readonly countryId: string

    /**
     * 
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdMediasMediaIdPut
     */
    readonly mediaId: string

    /**
     * 
     * @type {UpdateMediaCommand}
     * @memberof CountriesApiApiV1CountriesCountryIdMediasMediaIdPut
     */
    readonly updateMediaCommand?: UpdateMediaCommand
}

/**
 * Request parameters for apiV1CountriesCountryIdMediasPost operation in CountriesApi.
 * @export
 * @interface CountriesApiApiV1CountriesCountryIdMediasPostRequest
 */
export interface CountriesApiApiV1CountriesCountryIdMediasPostRequest {
    /**
     * 
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdMediasPost
     */
    readonly countryId: string

    /**
     * 
     * @type {CreateMediaCommand}
     * @memberof CountriesApiApiV1CountriesCountryIdMediasPost
     */
    readonly createMediaCommand?: CreateMediaCommand
}

/**
 * Request parameters for apiV1CountriesCountryIdPut operation in CountriesApi.
 * @export
 * @interface CountriesApiApiV1CountriesCountryIdPutRequest
 */
export interface CountriesApiApiV1CountriesCountryIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdPut
     */
    readonly countryId: string

    /**
     * 
     * @type {UpdateCountryCommand}
     * @memberof CountriesApiApiV1CountriesCountryIdPut
     */
    readonly updateCountryCommand?: UpdateCountryCommand
}

/**
 * Request parameters for apiV1CountriesCountryIdReactivatePut operation in CountriesApi.
 * @export
 * @interface CountriesApiApiV1CountriesCountryIdReactivatePutRequest
 */
export interface CountriesApiApiV1CountriesCountryIdReactivatePutRequest {
    /**
     * 
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdReactivatePut
     */
    readonly countryId: string
}

/**
 * Request parameters for apiV1CountriesCountryIdRevalidatePost operation in CountriesApi.
 * @export
 * @interface CountriesApiApiV1CountriesCountryIdRevalidatePostRequest
 */
export interface CountriesApiApiV1CountriesCountryIdRevalidatePostRequest {
    /**
     * 
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdRevalidatePost
     */
    readonly countryId: string

    /**
     * 
     * @type {boolean}
     * @memberof CountriesApiApiV1CountriesCountryIdRevalidatePost
     */
    readonly includeCurrent?: boolean
}

/**
 * Request parameters for apiV1CountriesCountryIdTranslatePost operation in CountriesApi.
 * @export
 * @interface CountriesApiApiV1CountriesCountryIdTranslatePostRequest
 */
export interface CountriesApiApiV1CountriesCountryIdTranslatePostRequest {
    /**
     * 
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdTranslatePost
     */
    readonly countryId: string

    /**
     * 
     * @type {TranslateCountryCommand}
     * @memberof CountriesApiApiV1CountriesCountryIdTranslatePost
     */
    readonly translateCountryCommand?: TranslateCountryCommand
}

/**
 * Request parameters for apiV1CountriesGet operation in CountriesApi.
 * @export
 * @interface CountriesApiApiV1CountriesGetRequest
 */
export interface CountriesApiApiV1CountriesGetRequest {
    /**
     * 
     * @type {string}
     * @memberof CountriesApiApiV1CountriesGet
     */
    readonly id?: string

    /**
     * 
     * @type {string}
     * @memberof CountriesApiApiV1CountriesGet
     */
    readonly name?: string

    /**
     * 
     * @type {string}
     * @memberof CountriesApiApiV1CountriesGet
     */
    readonly description?: string

    /**
     * 
     * @type {Date}
     * @memberof CountriesApiApiV1CountriesGet
     */
    readonly createdDate?: Date

    /**
     * 
     * @type {string}
     * @memberof CountriesApiApiV1CountriesGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof CountriesApiApiV1CountriesGet
     */
    readonly showHidden?: boolean

    /**
     * 
     * @type {number}
     * @memberof CountriesApiApiV1CountriesGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof CountriesApiApiV1CountriesGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof CountriesApiApiV1CountriesGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1CountriesPost operation in CountriesApi.
 * @export
 * @interface CountriesApiApiV1CountriesPostRequest
 */
export interface CountriesApiApiV1CountriesPostRequest {
    /**
     * 
     * @type {CreateCountryCommand}
     * @memberof CountriesApiApiV1CountriesPost
     */
    readonly createCountryCommand?: CreateCountryCommand
}

/**
 * Request parameters for apiV1CountriesSlugGet operation in CountriesApi.
 * @export
 * @interface CountriesApiApiV1CountriesSlugGetRequest
 */
export interface CountriesApiApiV1CountriesSlugGetRequest {
    /**
     * 
     * @type {string}
     * @memberof CountriesApiApiV1CountriesSlugGet
     */
    readonly slug: string

    /**
     * 
     * @type {string}
     * @memberof CountriesApiApiV1CountriesSlugGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof CountriesApiApiV1CountriesSlugGet
     */
    readonly returnDefaultValue?: boolean
}

/**
 * Request parameters for apiV1CountriesSortPut operation in CountriesApi.
 * @export
 * @interface CountriesApiApiV1CountriesSortPutRequest
 */
export interface CountriesApiApiV1CountriesSortPutRequest {
    /**
     * 
     * @type {CountrySortingCommand}
     * @memberof CountriesApiApiV1CountriesSortPut
     */
    readonly countrySortingCommand?: CountrySortingCommand
}

/**
 * CountriesApi - object-oriented interface
 * @export
 * @class CountriesApi
 * @extends {BaseAPI}
 */
export class CountriesApi extends BaseAPI {
    /**
     * 
     * @summary Delete country.
     * @param {CountriesApiApiV1CountriesCountryIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CountriesApi
     */
    public apiV1CountriesCountryIdDelete(requestParameters: CountriesApiApiV1CountriesCountryIdDeleteRequest, options?: AxiosRequestConfig) {
        return CountriesApiFp(this.configuration).apiV1CountriesCountryIdDelete(requestParameters.countryId, requestParameters.isPermanent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get country.
     * @param {CountriesApiApiV1CountriesCountryIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CountriesApi
     */
    public apiV1CountriesCountryIdGet(requestParameters: CountriesApiApiV1CountriesCountryIdGetRequest, options?: AxiosRequestConfig) {
        return CountriesApiFp(this.configuration).apiV1CountriesCountryIdGet(requestParameters.countryId, requestParameters.languageCode, requestParameters.returnDefaultValue, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all CountryMedias.
     * @param {CountriesApiApiV1CountriesCountryIdMediasGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CountriesApi
     */
    public apiV1CountriesCountryIdMediasGet(requestParameters: CountriesApiApiV1CountriesCountryIdMediasGetRequest, options?: AxiosRequestConfig) {
        return CountriesApiFp(this.configuration).apiV1CountriesCountryIdMediasGet(requestParameters.countryId, requestParameters.id, requestParameters.mediaType, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete CountryMedia
     * @param {CountriesApiApiV1CountriesCountryIdMediasMediaIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CountriesApi
     */
    public apiV1CountriesCountryIdMediasMediaIdDelete(requestParameters: CountriesApiApiV1CountriesCountryIdMediasMediaIdDeleteRequest, options?: AxiosRequestConfig) {
        return CountriesApiFp(this.configuration).apiV1CountriesCountryIdMediasMediaIdDelete(requestParameters.countryId, requestParameters.mediaId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get CountryMedia.
     * @param {CountriesApiApiV1CountriesCountryIdMediasMediaIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CountriesApi
     */
    public apiV1CountriesCountryIdMediasMediaIdGet(requestParameters: CountriesApiApiV1CountriesCountryIdMediasMediaIdGetRequest, options?: AxiosRequestConfig) {
        return CountriesApiFp(this.configuration).apiV1CountriesCountryIdMediasMediaIdGet(requestParameters.countryId, requestParameters.mediaId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update CountryMedia.
     * @param {CountriesApiApiV1CountriesCountryIdMediasMediaIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CountriesApi
     */
    public apiV1CountriesCountryIdMediasMediaIdPut(requestParameters: CountriesApiApiV1CountriesCountryIdMediasMediaIdPutRequest, options?: AxiosRequestConfig) {
        return CountriesApiFp(this.configuration).apiV1CountriesCountryIdMediasMediaIdPut(requestParameters.countryId, requestParameters.mediaId, requestParameters.updateMediaCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create CountryMedia.
     * @param {CountriesApiApiV1CountriesCountryIdMediasPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CountriesApi
     */
    public apiV1CountriesCountryIdMediasPost(requestParameters: CountriesApiApiV1CountriesCountryIdMediasPostRequest, options?: AxiosRequestConfig) {
        return CountriesApiFp(this.configuration).apiV1CountriesCountryIdMediasPost(requestParameters.countryId, requestParameters.createMediaCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update country.
     * @param {CountriesApiApiV1CountriesCountryIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CountriesApi
     */
    public apiV1CountriesCountryIdPut(requestParameters: CountriesApiApiV1CountriesCountryIdPutRequest, options?: AxiosRequestConfig) {
        return CountriesApiFp(this.configuration).apiV1CountriesCountryIdPut(requestParameters.countryId, requestParameters.updateCountryCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Reactivate country.
     * @param {CountriesApiApiV1CountriesCountryIdReactivatePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CountriesApi
     */
    public apiV1CountriesCountryIdReactivatePut(requestParameters: CountriesApiApiV1CountriesCountryIdReactivatePutRequest, options?: AxiosRequestConfig) {
        return CountriesApiFp(this.configuration).apiV1CountriesCountryIdReactivatePut(requestParameters.countryId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Revalidate country
     * @param {CountriesApiApiV1CountriesCountryIdRevalidatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CountriesApi
     */
    public apiV1CountriesCountryIdRevalidatePost(requestParameters: CountriesApiApiV1CountriesCountryIdRevalidatePostRequest, options?: AxiosRequestConfig) {
        return CountriesApiFp(this.configuration).apiV1CountriesCountryIdRevalidatePost(requestParameters.countryId, requestParameters.includeCurrent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Translate country
     * @param {CountriesApiApiV1CountriesCountryIdTranslatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CountriesApi
     */
    public apiV1CountriesCountryIdTranslatePost(requestParameters: CountriesApiApiV1CountriesCountryIdTranslatePostRequest, options?: AxiosRequestConfig) {
        return CountriesApiFp(this.configuration).apiV1CountriesCountryIdTranslatePost(requestParameters.countryId, requestParameters.translateCountryCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all countries.
     * @param {CountriesApiApiV1CountriesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CountriesApi
     */
    public apiV1CountriesGet(requestParameters: CountriesApiApiV1CountriesGetRequest = {}, options?: AxiosRequestConfig) {
        return CountriesApiFp(this.configuration).apiV1CountriesGet(requestParameters.id, requestParameters.name, requestParameters.description, requestParameters.createdDate, requestParameters.languageCode, requestParameters.showHidden, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create a country.
     * @param {CountriesApiApiV1CountriesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CountriesApi
     */
    public apiV1CountriesPost(requestParameters: CountriesApiApiV1CountriesPostRequest = {}, options?: AxiosRequestConfig) {
        return CountriesApiFp(this.configuration).apiV1CountriesPost(requestParameters.createCountryCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get country by slug
     * @param {CountriesApiApiV1CountriesSlugGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CountriesApi
     */
    public apiV1CountriesSlugGet(requestParameters: CountriesApiApiV1CountriesSlugGetRequest, options?: AxiosRequestConfig) {
        return CountriesApiFp(this.configuration).apiV1CountriesSlugGet(requestParameters.slug, requestParameters.languageCode, requestParameters.returnDefaultValue, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Batch for countries sorting
     * @param {CountriesApiApiV1CountriesSortPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CountriesApi
     */
    public apiV1CountriesSortPut(requestParameters: CountriesApiApiV1CountriesSortPutRequest = {}, options?: AxiosRequestConfig) {
        return CountriesApiFp(this.configuration).apiV1CountriesSortPut(requestParameters.countrySortingCommand, options).then((request) => request(this.axios, this.basePath));
    }
}
