/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { AppointmentStatisticsModel } from '../models';
// @ts-ignore
import { CallStatisticsModel } from '../models';
// @ts-ignore
import { DashBoardModel } from '../models';
// @ts-ignore
import { Duration } from '../models';
// @ts-ignore
import { GeneralStatisticsModel } from '../models';
// @ts-ignore
import { SurveyFormStatisticsModel } from '../models';
/**
 * DashBoardApi - axios parameter creator
 * @export
 */
export const DashBoardApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get appointment statistics data
         * @param {Duration} duration 
         * @param {string} [hospitalId] 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DashboardAppointmentGet: async (duration: Duration, hospitalId?: string, languageCode?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'duration' is not null or undefined
            assertParamExists('apiV1DashboardAppointmentGet', 'duration', duration)
            const localVarPath = `/api/v1/dashboard/appointment`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (duration !== undefined) {
                localVarQueryParameter['Duration'] = duration;
            }

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get call statisticss data
         * @param {Duration} duration 
         * @param {string} [hospitalId] 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DashboardCallGet: async (duration: Duration, hospitalId?: string, languageCode?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'duration' is not null or undefined
            assertParamExists('apiV1DashboardCallGet', 'duration', duration)
            const localVarPath = `/api/v1/dashboard/call`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (duration !== undefined) {
                localVarQueryParameter['Duration'] = duration;
            }

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get general statistics data
         * @param {Duration} duration 
         * @param {string} [hospitalId] 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DashboardGeneralGet: async (duration: Duration, hospitalId?: string, languageCode?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'duration' is not null or undefined
            assertParamExists('apiV1DashboardGeneralGet', 'duration', duration)
            const localVarPath = `/api/v1/dashboard/general`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (duration !== undefined) {
                localVarQueryParameter['Duration'] = duration;
            }

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get intergrated dashboard data
         * @param {Duration} duration 
         * @param {string} [hospitalId] 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DashboardGet: async (duration: Duration, hospitalId?: string, languageCode?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'duration' is not null or undefined
            assertParamExists('apiV1DashboardGet', 'duration', duration)
            const localVarPath = `/api/v1/dashboard`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (duration !== undefined) {
                localVarQueryParameter['Duration'] = duration;
            }

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get survey form statisticss data
         * @param {Duration} duration 
         * @param {string} [hospitalId] 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DashboardSurveyformGet: async (duration: Duration, hospitalId?: string, languageCode?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'duration' is not null or undefined
            assertParamExists('apiV1DashboardSurveyformGet', 'duration', duration)
            const localVarPath = `/api/v1/dashboard/surveyform`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (duration !== undefined) {
                localVarQueryParameter['Duration'] = duration;
            }

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * DashBoardApi - functional programming interface
 * @export
 */
export const DashBoardApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = DashBoardApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Get appointment statistics data
         * @param {Duration} duration 
         * @param {string} [hospitalId] 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DashboardAppointmentGet(duration: Duration, hospitalId?: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AppointmentStatisticsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DashboardAppointmentGet(duration, hospitalId, languageCode, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get call statisticss data
         * @param {Duration} duration 
         * @param {string} [hospitalId] 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DashboardCallGet(duration: Duration, hospitalId?: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CallStatisticsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DashboardCallGet(duration, hospitalId, languageCode, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get general statistics data
         * @param {Duration} duration 
         * @param {string} [hospitalId] 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DashboardGeneralGet(duration: Duration, hospitalId?: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<GeneralStatisticsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DashboardGeneralGet(duration, hospitalId, languageCode, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get intergrated dashboard data
         * @param {Duration} duration 
         * @param {string} [hospitalId] 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DashboardGet(duration: Duration, hospitalId?: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DashBoardModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DashboardGet(duration, hospitalId, languageCode, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get survey form statisticss data
         * @param {Duration} duration 
         * @param {string} [hospitalId] 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DashboardSurveyformGet(duration: Duration, hospitalId?: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SurveyFormStatisticsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DashboardSurveyformGet(duration, hospitalId, languageCode, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * DashBoardApi - factory interface
 * @export
 */
export const DashBoardApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = DashBoardApiFp(configuration)
    return {
        /**
         * 
         * @summary Get appointment statistics data
         * @param {Duration} duration 
         * @param {string} [hospitalId] 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DashboardAppointmentGet(duration: Duration, hospitalId?: string, languageCode?: string, options?: any): AxiosPromise<AppointmentStatisticsModel> {
            return localVarFp.apiV1DashboardAppointmentGet(duration, hospitalId, languageCode, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get call statisticss data
         * @param {Duration} duration 
         * @param {string} [hospitalId] 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DashboardCallGet(duration: Duration, hospitalId?: string, languageCode?: string, options?: any): AxiosPromise<CallStatisticsModel> {
            return localVarFp.apiV1DashboardCallGet(duration, hospitalId, languageCode, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get general statistics data
         * @param {Duration} duration 
         * @param {string} [hospitalId] 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DashboardGeneralGet(duration: Duration, hospitalId?: string, languageCode?: string, options?: any): AxiosPromise<GeneralStatisticsModel> {
            return localVarFp.apiV1DashboardGeneralGet(duration, hospitalId, languageCode, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get intergrated dashboard data
         * @param {Duration} duration 
         * @param {string} [hospitalId] 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DashboardGet(duration: Duration, hospitalId?: string, languageCode?: string, options?: any): AxiosPromise<DashBoardModel> {
            return localVarFp.apiV1DashboardGet(duration, hospitalId, languageCode, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get survey form statisticss data
         * @param {Duration} duration 
         * @param {string} [hospitalId] 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DashboardSurveyformGet(duration: Duration, hospitalId?: string, languageCode?: string, options?: any): AxiosPromise<SurveyFormStatisticsModel> {
            return localVarFp.apiV1DashboardSurveyformGet(duration, hospitalId, languageCode, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1DashboardAppointmentGet operation in DashBoardApi.
 * @export
 * @interface DashBoardApiApiV1DashboardAppointmentGetRequest
 */
export interface DashBoardApiApiV1DashboardAppointmentGetRequest {
    /**
     * 
     * @type {Duration}
     * @memberof DashBoardApiApiV1DashboardAppointmentGet
     */
    readonly duration: Duration

    /**
     * 
     * @type {string}
     * @memberof DashBoardApiApiV1DashboardAppointmentGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {string}
     * @memberof DashBoardApiApiV1DashboardAppointmentGet
     */
    readonly languageCode?: string
}

/**
 * Request parameters for apiV1DashboardCallGet operation in DashBoardApi.
 * @export
 * @interface DashBoardApiApiV1DashboardCallGetRequest
 */
export interface DashBoardApiApiV1DashboardCallGetRequest {
    /**
     * 
     * @type {Duration}
     * @memberof DashBoardApiApiV1DashboardCallGet
     */
    readonly duration: Duration

    /**
     * 
     * @type {string}
     * @memberof DashBoardApiApiV1DashboardCallGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {string}
     * @memberof DashBoardApiApiV1DashboardCallGet
     */
    readonly languageCode?: string
}

/**
 * Request parameters for apiV1DashboardGeneralGet operation in DashBoardApi.
 * @export
 * @interface DashBoardApiApiV1DashboardGeneralGetRequest
 */
export interface DashBoardApiApiV1DashboardGeneralGetRequest {
    /**
     * 
     * @type {Duration}
     * @memberof DashBoardApiApiV1DashboardGeneralGet
     */
    readonly duration: Duration

    /**
     * 
     * @type {string}
     * @memberof DashBoardApiApiV1DashboardGeneralGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {string}
     * @memberof DashBoardApiApiV1DashboardGeneralGet
     */
    readonly languageCode?: string
}

/**
 * Request parameters for apiV1DashboardGet operation in DashBoardApi.
 * @export
 * @interface DashBoardApiApiV1DashboardGetRequest
 */
export interface DashBoardApiApiV1DashboardGetRequest {
    /**
     * 
     * @type {Duration}
     * @memberof DashBoardApiApiV1DashboardGet
     */
    readonly duration: Duration

    /**
     * 
     * @type {string}
     * @memberof DashBoardApiApiV1DashboardGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {string}
     * @memberof DashBoardApiApiV1DashboardGet
     */
    readonly languageCode?: string
}

/**
 * Request parameters for apiV1DashboardSurveyformGet operation in DashBoardApi.
 * @export
 * @interface DashBoardApiApiV1DashboardSurveyformGetRequest
 */
export interface DashBoardApiApiV1DashboardSurveyformGetRequest {
    /**
     * 
     * @type {Duration}
     * @memberof DashBoardApiApiV1DashboardSurveyformGet
     */
    readonly duration: Duration

    /**
     * 
     * @type {string}
     * @memberof DashBoardApiApiV1DashboardSurveyformGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {string}
     * @memberof DashBoardApiApiV1DashboardSurveyformGet
     */
    readonly languageCode?: string
}

/**
 * DashBoardApi - object-oriented interface
 * @export
 * @class DashBoardApi
 * @extends {BaseAPI}
 */
export class DashBoardApi extends BaseAPI {
    /**
     * 
     * @summary Get appointment statistics data
     * @param {DashBoardApiApiV1DashboardAppointmentGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DashBoardApi
     */
    public apiV1DashboardAppointmentGet(requestParameters: DashBoardApiApiV1DashboardAppointmentGetRequest, options?: AxiosRequestConfig) {
        return DashBoardApiFp(this.configuration).apiV1DashboardAppointmentGet(requestParameters.duration, requestParameters.hospitalId, requestParameters.languageCode, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get call statisticss data
     * @param {DashBoardApiApiV1DashboardCallGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DashBoardApi
     */
    public apiV1DashboardCallGet(requestParameters: DashBoardApiApiV1DashboardCallGetRequest, options?: AxiosRequestConfig) {
        return DashBoardApiFp(this.configuration).apiV1DashboardCallGet(requestParameters.duration, requestParameters.hospitalId, requestParameters.languageCode, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get general statistics data
     * @param {DashBoardApiApiV1DashboardGeneralGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DashBoardApi
     */
    public apiV1DashboardGeneralGet(requestParameters: DashBoardApiApiV1DashboardGeneralGetRequest, options?: AxiosRequestConfig) {
        return DashBoardApiFp(this.configuration).apiV1DashboardGeneralGet(requestParameters.duration, requestParameters.hospitalId, requestParameters.languageCode, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get intergrated dashboard data
     * @param {DashBoardApiApiV1DashboardGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DashBoardApi
     */
    public apiV1DashboardGet(requestParameters: DashBoardApiApiV1DashboardGetRequest, options?: AxiosRequestConfig) {
        return DashBoardApiFp(this.configuration).apiV1DashboardGet(requestParameters.duration, requestParameters.hospitalId, requestParameters.languageCode, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get survey form statisticss data
     * @param {DashBoardApiApiV1DashboardSurveyformGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DashBoardApi
     */
    public apiV1DashboardSurveyformGet(requestParameters: DashBoardApiApiV1DashboardSurveyformGetRequest, options?: AxiosRequestConfig) {
        return DashBoardApiFp(this.configuration).apiV1DashboardSurveyformGet(requestParameters.duration, requestParameters.hospitalId, requestParameters.languageCode, options).then((request) => request(this.axios, this.basePath));
    }
}
