/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { AppointmentTimetableOverridesModel } from '../models';
// @ts-ignore
import { AppointmentTimetablesModel } from '../models';
// @ts-ignore
import { BatchAppointmentTimetablesResultModel } from '../models';
// @ts-ignore
import { BatchDealPackageAppointmentTimetablesCommand } from '../models';
// @ts-ignore
import { CreateDealCommand } from '../models';
// @ts-ignore
import { CreateDealPackageCommand } from '../models';
// @ts-ignore
import { CreateDealServiceCommand } from '../models';
// @ts-ignore
import { DayOfWeek } from '../models';
// @ts-ignore
import { DealModel } from '../models';
// @ts-ignore
import { DealPackageModel } from '../models';
// @ts-ignore
import { DealPackagesModel } from '../models';
// @ts-ignore
import { DealServiceModel } from '../models';
// @ts-ignore
import { DealServicesModel } from '../models';
// @ts-ignore
import { DealsModel } from '../models';
// @ts-ignore
import { DealsSimpleModel } from '../models';
// @ts-ignore
import { DeleteDealPackageAppointmentTimetableOverridesCommand } from '../models';
// @ts-ignore
import { GetAppointmentTimetablesResponseModel } from '../models';
// @ts-ignore
import { MarketingType } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { SaveAppointmentTimetableOverridesResultModel } from '../models';
// @ts-ignore
import { SaveDealPackageAppointmentTimetableOverridesCommand } from '../models';
// @ts-ignore
import { TranslateDealCommand } from '../models';
// @ts-ignore
import { UpdateDealCommand } from '../models';
// @ts-ignore
import { UpdateDealPackageCommand } from '../models';
// @ts-ignore
import { UpdateDealServiceCommand } from '../models';
/**
 * DealsApi - axios parameter creator
 * @export
 */
export const DealsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Delete deal.
         * @param {string} dealId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdDelete: async (dealId: string, isPermanent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'dealId' is not null or undefined
            assertParamExists('apiV1DealsDealIdDelete', 'dealId', dealId)
            const localVarPath = `/api/v1/deals/{dealId}`
                .replace(`{${"dealId"}}`, encodeURIComponent(String(dealId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (isPermanent !== undefined) {
                localVarQueryParameter['isPermanent'] = isPermanent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get deal.
         * @param {string} dealId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdGet: async (dealId: string, languageCode?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'dealId' is not null or undefined
            assertParamExists('apiV1DealsDealIdGet', 'dealId', dealId)
            const localVarPath = `/api/v1/deals/{dealId}`
                .replace(`{${"dealId"}}`, encodeURIComponent(String(dealId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all DealPackage.
         * @param {string} dealId 
         * @param {string} [relatedDealPackageId] 
         * @param {string} [dealName] 
         * @param {string} [name] 
         * @param {string} [countryId] 
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdPackagesGet: async (dealId: string, relatedDealPackageId?: string, dealName?: string, name?: string, countryId?: string, hospitalId?: string, hospitalName?: string, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'dealId' is not null or undefined
            assertParamExists('apiV1DealsDealIdPackagesGet', 'dealId', dealId)
            const localVarPath = `/api/v1/deals/{dealId}/packages`
                .replace(`{${"dealId"}}`, encodeURIComponent(String(dealId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (relatedDealPackageId !== undefined) {
                localVarQueryParameter['RelatedDealPackageId'] = relatedDealPackageId;
            }

            if (dealName !== undefined) {
                localVarQueryParameter['DealName'] = dealName;
            }

            if (name !== undefined) {
                localVarQueryParameter['Name'] = name;
            }

            if (countryId !== undefined) {
                localVarQueryParameter['CountryId'] = countryId;
            }

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (hospitalName !== undefined) {
                localVarQueryParameter['HospitalName'] = hospitalName;
            }

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }

            if (showHidden !== undefined) {
                localVarQueryParameter['ShowHidden'] = showHidden;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get DealPackage appointment timetable overrides
         * @param {string} dealId 
         * @param {string} packageId 
         * @param {boolean} [includesPreviousItems] 
         * @param {Date} [startDate] 
         * @param {Date} [endDate] 
         * @param {DayOfWeek} [dayOfWeek] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet: async (dealId: string, packageId: string, includesPreviousItems?: boolean, startDate?: Date, endDate?: Date, dayOfWeek?: DayOfWeek, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'dealId' is not null or undefined
            assertParamExists('apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet', 'dealId', dealId)
            // verify required parameter 'packageId' is not null or undefined
            assertParamExists('apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet', 'packageId', packageId)
            const localVarPath = `/api/v1/deals/{dealId}/packages/{packageId}/appointmenttimetableoverrides`
                .replace(`{${"dealId"}}`, encodeURIComponent(String(dealId)))
                .replace(`{${"packageId"}}`, encodeURIComponent(String(packageId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (includesPreviousItems !== undefined) {
                localVarQueryParameter['IncludesPreviousItems'] = includesPreviousItems;
            }

            if (startDate !== undefined) {
                localVarQueryParameter['StartDate'] = (startDate as any instanceof Date) ?
                    (startDate as any).toISOString() :
                    startDate;
            }

            if (endDate !== undefined) {
                localVarQueryParameter['EndDate'] = (endDate as any instanceof Date) ?
                    (endDate as any).toISOString() :
                    endDate;
            }

            if (dayOfWeek !== undefined) {
                localVarQueryParameter['DayOfWeek'] = dayOfWeek;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete DealPackage appointment timetable overrides
         * @param {string} dealId 
         * @param {string} packageId 
         * @param {DeleteDealPackageAppointmentTimetableOverridesCommand} [deleteDealPackageAppointmentTimetableOverridesCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPatch: async (dealId: string, packageId: string, deleteDealPackageAppointmentTimetableOverridesCommand?: DeleteDealPackageAppointmentTimetableOverridesCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'dealId' is not null or undefined
            assertParamExists('apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPatch', 'dealId', dealId)
            // verify required parameter 'packageId' is not null or undefined
            assertParamExists('apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPatch', 'packageId', packageId)
            const localVarPath = `/api/v1/deals/{dealId}/packages/{packageId}/appointmenttimetableoverrides`
                .replace(`{${"dealId"}}`, encodeURIComponent(String(dealId)))
                .replace(`{${"packageId"}}`, encodeURIComponent(String(packageId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PATCH', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(deleteDealPackageAppointmentTimetableOverridesCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Save DealPackage appointment timetable overrides
         * @param {string} dealId 
         * @param {string} packageId 
         * @param {SaveDealPackageAppointmentTimetableOverridesCommand} [saveDealPackageAppointmentTimetableOverridesCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPost: async (dealId: string, packageId: string, saveDealPackageAppointmentTimetableOverridesCommand?: SaveDealPackageAppointmentTimetableOverridesCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'dealId' is not null or undefined
            assertParamExists('apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPost', 'dealId', dealId)
            // verify required parameter 'packageId' is not null or undefined
            assertParamExists('apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPost', 'packageId', packageId)
            const localVarPath = `/api/v1/deals/{dealId}/packages/{packageId}/appointmenttimetableoverrides`
                .replace(`{${"dealId"}}`, encodeURIComponent(String(dealId)))
                .replace(`{${"packageId"}}`, encodeURIComponent(String(packageId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(saveDealPackageAppointmentTimetableOverridesCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get DealPackage appointment timetables for application
         * @param {string} dealId 
         * @param {string} packageId 
         * @param {number} [year] 
         * @param {number} [month] 
         * @param {string} [timeZone] 
         * @param {boolean} [isExternal] 
         * @param {boolean} [isOnline] 
         * @param {string} [appointmentIdExcluded] 
         * @param {boolean} [excludeUnavailableTimeSlots] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet: async (dealId: string, packageId: string, year?: number, month?: number, timeZone?: string, isExternal?: boolean, isOnline?: boolean, appointmentIdExcluded?: string, excludeUnavailableTimeSlots?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'dealId' is not null or undefined
            assertParamExists('apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet', 'dealId', dealId)
            // verify required parameter 'packageId' is not null or undefined
            assertParamExists('apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet', 'packageId', packageId)
            const localVarPath = `/api/v1/deals/{dealId}/packages/{packageId}/appointmenttimetables/application`
                .replace(`{${"dealId"}}`, encodeURIComponent(String(dealId)))
                .replace(`{${"packageId"}}`, encodeURIComponent(String(packageId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (year !== undefined) {
                localVarQueryParameter['Year'] = year;
            }

            if (month !== undefined) {
                localVarQueryParameter['Month'] = month;
            }

            if (timeZone !== undefined) {
                localVarQueryParameter['TimeZone'] = timeZone;
            }

            if (isExternal !== undefined) {
                localVarQueryParameter['IsExternal'] = isExternal;
            }

            if (isOnline !== undefined) {
                localVarQueryParameter['IsOnline'] = isOnline;
            }

            if (appointmentIdExcluded !== undefined) {
                localVarQueryParameter['AppointmentIdExcluded'] = appointmentIdExcluded;
            }

            if (excludeUnavailableTimeSlots !== undefined) {
                localVarQueryParameter['ExcludeUnavailableTimeSlots'] = excludeUnavailableTimeSlots;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Add, update and delete DealPackage appointment timetable
         * @param {string} dealId 
         * @param {string} packageId 
         * @param {BatchDealPackageAppointmentTimetablesCommand} [batchDealPackageAppointmentTimetablesCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesBatchPost: async (dealId: string, packageId: string, batchDealPackageAppointmentTimetablesCommand?: BatchDealPackageAppointmentTimetablesCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'dealId' is not null or undefined
            assertParamExists('apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesBatchPost', 'dealId', dealId)
            // verify required parameter 'packageId' is not null or undefined
            assertParamExists('apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesBatchPost', 'packageId', packageId)
            const localVarPath = `/api/v1/deals/{dealId}/packages/{packageId}/appointmenttimetables/batch`
                .replace(`{${"dealId"}}`, encodeURIComponent(String(dealId)))
                .replace(`{${"packageId"}}`, encodeURIComponent(String(packageId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(batchDealPackageAppointmentTimetablesCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get DealPackage appointment timetables
         * @param {string} dealId 
         * @param {string} packageId 
         * @param {DayOfWeek} [dayOfWeek] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGet: async (dealId: string, packageId: string, dayOfWeek?: DayOfWeek, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'dealId' is not null or undefined
            assertParamExists('apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGet', 'dealId', dealId)
            // verify required parameter 'packageId' is not null or undefined
            assertParamExists('apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGet', 'packageId', packageId)
            const localVarPath = `/api/v1/deals/{dealId}/packages/{packageId}/appointmenttimetables`
                .replace(`{${"dealId"}}`, encodeURIComponent(String(dealId)))
                .replace(`{${"packageId"}}`, encodeURIComponent(String(packageId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (dayOfWeek !== undefined) {
                localVarQueryParameter['DayOfWeek'] = dayOfWeek;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete DealPackage.
         * @param {string} dealId 
         * @param {string} packageId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdPackagesPackageIdDelete: async (dealId: string, packageId: string, isPermanent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'dealId' is not null or undefined
            assertParamExists('apiV1DealsDealIdPackagesPackageIdDelete', 'dealId', dealId)
            // verify required parameter 'packageId' is not null or undefined
            assertParamExists('apiV1DealsDealIdPackagesPackageIdDelete', 'packageId', packageId)
            const localVarPath = `/api/v1/deals/{dealId}/packages/{packageId}`
                .replace(`{${"dealId"}}`, encodeURIComponent(String(dealId)))
                .replace(`{${"packageId"}}`, encodeURIComponent(String(packageId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (isPermanent !== undefined) {
                localVarQueryParameter['isPermanent'] = isPermanent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get DealPackage.
         * @param {string} dealId 
         * @param {string} packageId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdPackagesPackageIdGet: async (dealId: string, packageId: string, languageCode?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'dealId' is not null or undefined
            assertParamExists('apiV1DealsDealIdPackagesPackageIdGet', 'dealId', dealId)
            // verify required parameter 'packageId' is not null or undefined
            assertParamExists('apiV1DealsDealIdPackagesPackageIdGet', 'packageId', packageId)
            const localVarPath = `/api/v1/deals/{dealId}/packages/{packageId}`
                .replace(`{${"dealId"}}`, encodeURIComponent(String(dealId)))
                .replace(`{${"packageId"}}`, encodeURIComponent(String(packageId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update DealPackage.
         * @param {string} dealId 
         * @param {string} packageId 
         * @param {UpdateDealPackageCommand} [updateDealPackageCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdPackagesPackageIdPut: async (dealId: string, packageId: string, updateDealPackageCommand?: UpdateDealPackageCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'dealId' is not null or undefined
            assertParamExists('apiV1DealsDealIdPackagesPackageIdPut', 'dealId', dealId)
            // verify required parameter 'packageId' is not null or undefined
            assertParamExists('apiV1DealsDealIdPackagesPackageIdPut', 'packageId', packageId)
            const localVarPath = `/api/v1/deals/{dealId}/packages/{packageId}`
                .replace(`{${"dealId"}}`, encodeURIComponent(String(dealId)))
                .replace(`{${"packageId"}}`, encodeURIComponent(String(packageId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateDealPackageCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create DealPackage.
         * @param {string} dealId 
         * @param {CreateDealPackageCommand} [createDealPackageCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdPackagesPost: async (dealId: string, createDealPackageCommand?: CreateDealPackageCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'dealId' is not null or undefined
            assertParamExists('apiV1DealsDealIdPackagesPost', 'dealId', dealId)
            const localVarPath = `/api/v1/deals/{dealId}/packages`
                .replace(`{${"dealId"}}`, encodeURIComponent(String(dealId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createDealPackageCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update deal.
         * @param {string} dealId 
         * @param {UpdateDealCommand} [updateDealCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdPut: async (dealId: string, updateDealCommand?: UpdateDealCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'dealId' is not null or undefined
            assertParamExists('apiV1DealsDealIdPut', 'dealId', dealId)
            const localVarPath = `/api/v1/deals/{dealId}`
                .replace(`{${"dealId"}}`, encodeURIComponent(String(dealId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateDealCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Revalidate deal
         * @param {string} dealId 
         * @param {boolean} [includeCurrent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdRevalidatePost: async (dealId: string, includeCurrent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'dealId' is not null or undefined
            assertParamExists('apiV1DealsDealIdRevalidatePost', 'dealId', dealId)
            const localVarPath = `/api/v1/deals/{dealId}/revalidate`
                .replace(`{${"dealId"}}`, encodeURIComponent(String(dealId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (includeCurrent !== undefined) {
                localVarQueryParameter['includeCurrent'] = includeCurrent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all DealService.
         * @param {string} dealId 
         * @param {string} [languageCode] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdServicesGet: async (dealId: string, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'dealId' is not null or undefined
            assertParamExists('apiV1DealsDealIdServicesGet', 'dealId', dealId)
            const localVarPath = `/api/v1/deals/{dealId}/services`
                .replace(`{${"dealId"}}`, encodeURIComponent(String(dealId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create DealService.
         * @param {string} dealId 
         * @param {CreateDealServiceCommand} [createDealServiceCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdServicesPost: async (dealId: string, createDealServiceCommand?: CreateDealServiceCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'dealId' is not null or undefined
            assertParamExists('apiV1DealsDealIdServicesPost', 'dealId', dealId)
            const localVarPath = `/api/v1/deals/{dealId}/services`
                .replace(`{${"dealId"}}`, encodeURIComponent(String(dealId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createDealServiceCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete DealService.
         * @param {string} dealId 
         * @param {string} serviceId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdServicesServiceIdDelete: async (dealId: string, serviceId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'dealId' is not null or undefined
            assertParamExists('apiV1DealsDealIdServicesServiceIdDelete', 'dealId', dealId)
            // verify required parameter 'serviceId' is not null or undefined
            assertParamExists('apiV1DealsDealIdServicesServiceIdDelete', 'serviceId', serviceId)
            const localVarPath = `/api/v1/deals/{dealId}/services/{serviceId}`
                .replace(`{${"dealId"}}`, encodeURIComponent(String(dealId)))
                .replace(`{${"serviceId"}}`, encodeURIComponent(String(serviceId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get DealService.
         * @param {string} dealId 
         * @param {string} serviceId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdServicesServiceIdGet: async (dealId: string, serviceId: string, languageCode?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'dealId' is not null or undefined
            assertParamExists('apiV1DealsDealIdServicesServiceIdGet', 'dealId', dealId)
            // verify required parameter 'serviceId' is not null or undefined
            assertParamExists('apiV1DealsDealIdServicesServiceIdGet', 'serviceId', serviceId)
            const localVarPath = `/api/v1/deals/{dealId}/services/{serviceId}`
                .replace(`{${"dealId"}}`, encodeURIComponent(String(dealId)))
                .replace(`{${"serviceId"}}`, encodeURIComponent(String(serviceId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update DealService.
         * @param {string} dealId 
         * @param {string} serviceId 
         * @param {UpdateDealServiceCommand} [updateDealServiceCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdServicesServiceIdPut: async (dealId: string, serviceId: string, updateDealServiceCommand?: UpdateDealServiceCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'dealId' is not null or undefined
            assertParamExists('apiV1DealsDealIdServicesServiceIdPut', 'dealId', dealId)
            // verify required parameter 'serviceId' is not null or undefined
            assertParamExists('apiV1DealsDealIdServicesServiceIdPut', 'serviceId', serviceId)
            const localVarPath = `/api/v1/deals/{dealId}/services/{serviceId}`
                .replace(`{${"dealId"}}`, encodeURIComponent(String(dealId)))
                .replace(`{${"serviceId"}}`, encodeURIComponent(String(serviceId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateDealServiceCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Translate deal
         * @param {string} dealId 
         * @param {TranslateDealCommand} [translateDealCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdTranslatePost: async (dealId: string, translateDealCommand?: TranslateDealCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'dealId' is not null or undefined
            assertParamExists('apiV1DealsDealIdTranslatePost', 'dealId', dealId)
            const localVarPath = `/api/v1/deals/{dealId}/translate`
                .replace(`{${"dealId"}}`, encodeURIComponent(String(dealId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(translateDealCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all deals.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {MarketingType} [marketingType] 
         * @param {string} [countryId] 
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [specialtyId] 
         * @param {string} [specialtyName] 
         * @param {string} [specialtyTypeId] 
         * @param {string} [specialtyTypeName] 
         * @param {string} [serviceId] 
         * @param {string} [serviceName] 
         * @param {string} [exceptHospitalId] 
         * @param {string} [exceptDealId] 
         * @param {Array<string>} [ids] 
         * @param {number} [serviceDuration] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {boolean} [returnDefaultValue] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsGet: async (id?: string, name?: string, marketingType?: MarketingType, countryId?: string, hospitalId?: string, hospitalName?: string, specialtyId?: string, specialtyName?: string, specialtyTypeId?: string, specialtyTypeName?: string, serviceId?: string, serviceName?: string, exceptHospitalId?: string, exceptDealId?: string, ids?: Array<string>, serviceDuration?: number, languageCode?: string, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/deals`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (name !== undefined) {
                localVarQueryParameter['Name'] = name;
            }

            if (marketingType !== undefined) {
                localVarQueryParameter['MarketingType'] = marketingType;
            }

            if (countryId !== undefined) {
                localVarQueryParameter['CountryId'] = countryId;
            }

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (hospitalName !== undefined) {
                localVarQueryParameter['HospitalName'] = hospitalName;
            }

            if (specialtyId !== undefined) {
                localVarQueryParameter['SpecialtyId'] = specialtyId;
            }

            if (specialtyName !== undefined) {
                localVarQueryParameter['SpecialtyName'] = specialtyName;
            }

            if (specialtyTypeId !== undefined) {
                localVarQueryParameter['SpecialtyTypeId'] = specialtyTypeId;
            }

            if (specialtyTypeName !== undefined) {
                localVarQueryParameter['SpecialtyTypeName'] = specialtyTypeName;
            }

            if (serviceId !== undefined) {
                localVarQueryParameter['ServiceId'] = serviceId;
            }

            if (serviceName !== undefined) {
                localVarQueryParameter['ServiceName'] = serviceName;
            }

            if (exceptHospitalId !== undefined) {
                localVarQueryParameter['ExceptHospitalId'] = exceptHospitalId;
            }

            if (exceptDealId !== undefined) {
                localVarQueryParameter['ExceptDealId'] = exceptDealId;
            }

            if (ids) {
                localVarQueryParameter['Ids'] = ids;
            }

            if (serviceDuration !== undefined) {
                localVarQueryParameter['ServiceDuration'] = serviceDuration;
            }

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }

            if (showHidden !== undefined) {
                localVarQueryParameter['ShowHidden'] = showHidden;
            }

            if (returnDefaultValue !== undefined) {
                localVarQueryParameter['ReturnDefaultValue'] = returnDefaultValue;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create a deal.
         * @param {CreateDealCommand} [createDealCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsPost: async (createDealCommand?: CreateDealCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/deals`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createDealCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all deals.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {MarketingType} [marketingType] 
         * @param {string} [countryId] 
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [specialtyId] 
         * @param {string} [specialtyName] 
         * @param {string} [specialtyTypeId] 
         * @param {string} [specialtyTypeName] 
         * @param {string} [serviceId] 
         * @param {string} [serviceName] 
         * @param {string} [exceptHospitalId] 
         * @param {string} [exceptDealId] 
         * @param {Array<string>} [ids] 
         * @param {number} [serviceDuration] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {boolean} [returnDefaultValue] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsSimpleGet: async (id?: string, name?: string, marketingType?: MarketingType, countryId?: string, hospitalId?: string, hospitalName?: string, specialtyId?: string, specialtyName?: string, specialtyTypeId?: string, specialtyTypeName?: string, serviceId?: string, serviceName?: string, exceptHospitalId?: string, exceptDealId?: string, ids?: Array<string>, serviceDuration?: number, languageCode?: string, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/deals/simple`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (name !== undefined) {
                localVarQueryParameter['Name'] = name;
            }

            if (marketingType !== undefined) {
                localVarQueryParameter['MarketingType'] = marketingType;
            }

            if (countryId !== undefined) {
                localVarQueryParameter['CountryId'] = countryId;
            }

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (hospitalName !== undefined) {
                localVarQueryParameter['HospitalName'] = hospitalName;
            }

            if (specialtyId !== undefined) {
                localVarQueryParameter['SpecialtyId'] = specialtyId;
            }

            if (specialtyName !== undefined) {
                localVarQueryParameter['SpecialtyName'] = specialtyName;
            }

            if (specialtyTypeId !== undefined) {
                localVarQueryParameter['SpecialtyTypeId'] = specialtyTypeId;
            }

            if (specialtyTypeName !== undefined) {
                localVarQueryParameter['SpecialtyTypeName'] = specialtyTypeName;
            }

            if (serviceId !== undefined) {
                localVarQueryParameter['ServiceId'] = serviceId;
            }

            if (serviceName !== undefined) {
                localVarQueryParameter['ServiceName'] = serviceName;
            }

            if (exceptHospitalId !== undefined) {
                localVarQueryParameter['ExceptHospitalId'] = exceptHospitalId;
            }

            if (exceptDealId !== undefined) {
                localVarQueryParameter['ExceptDealId'] = exceptDealId;
            }

            if (ids) {
                localVarQueryParameter['Ids'] = ids;
            }

            if (serviceDuration !== undefined) {
                localVarQueryParameter['ServiceDuration'] = serviceDuration;
            }

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }

            if (showHidden !== undefined) {
                localVarQueryParameter['ShowHidden'] = showHidden;
            }

            if (returnDefaultValue !== undefined) {
                localVarQueryParameter['ReturnDefaultValue'] = returnDefaultValue;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get deal by slug.
         * @param {string} slug 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsSlugGet: async (slug: string, languageCode?: string, returnDefaultValue?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'slug' is not null or undefined
            assertParamExists('apiV1DealsSlugGet', 'slug', slug)
            const localVarPath = `/api/v1/deals/{slug}`
                .replace(`{${"slug"}}`, encodeURIComponent(String(slug)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }

            if (returnDefaultValue !== undefined) {
                localVarQueryParameter['returnDefaultValue'] = returnDefaultValue;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * DealsApi - functional programming interface
 * @export
 */
export const DealsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = DealsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Delete deal.
         * @param {string} dealId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DealsDealIdDelete(dealId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DealsDealIdDelete(dealId, isPermanent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get deal.
         * @param {string} dealId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DealsDealIdGet(dealId: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DealModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DealsDealIdGet(dealId, languageCode, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all DealPackage.
         * @param {string} dealId 
         * @param {string} [relatedDealPackageId] 
         * @param {string} [dealName] 
         * @param {string} [name] 
         * @param {string} [countryId] 
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DealsDealIdPackagesGet(dealId: string, relatedDealPackageId?: string, dealName?: string, name?: string, countryId?: string, hospitalId?: string, hospitalName?: string, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DealPackagesModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DealsDealIdPackagesGet(dealId, relatedDealPackageId, dealName, name, countryId, hospitalId, hospitalName, languageCode, showHidden, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get DealPackage appointment timetable overrides
         * @param {string} dealId 
         * @param {string} packageId 
         * @param {boolean} [includesPreviousItems] 
         * @param {Date} [startDate] 
         * @param {Date} [endDate] 
         * @param {DayOfWeek} [dayOfWeek] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet(dealId: string, packageId: string, includesPreviousItems?: boolean, startDate?: Date, endDate?: Date, dayOfWeek?: DayOfWeek, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AppointmentTimetableOverridesModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet(dealId, packageId, includesPreviousItems, startDate, endDate, dayOfWeek, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete DealPackage appointment timetable overrides
         * @param {string} dealId 
         * @param {string} packageId 
         * @param {DeleteDealPackageAppointmentTimetableOverridesCommand} [deleteDealPackageAppointmentTimetableOverridesCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPatch(dealId: string, packageId: string, deleteDealPackageAppointmentTimetableOverridesCommand?: DeleteDealPackageAppointmentTimetableOverridesCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPatch(dealId, packageId, deleteDealPackageAppointmentTimetableOverridesCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Save DealPackage appointment timetable overrides
         * @param {string} dealId 
         * @param {string} packageId 
         * @param {SaveDealPackageAppointmentTimetableOverridesCommand} [saveDealPackageAppointmentTimetableOverridesCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPost(dealId: string, packageId: string, saveDealPackageAppointmentTimetableOverridesCommand?: SaveDealPackageAppointmentTimetableOverridesCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SaveAppointmentTimetableOverridesResultModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPost(dealId, packageId, saveDealPackageAppointmentTimetableOverridesCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get DealPackage appointment timetables for application
         * @param {string} dealId 
         * @param {string} packageId 
         * @param {number} [year] 
         * @param {number} [month] 
         * @param {string} [timeZone] 
         * @param {boolean} [isExternal] 
         * @param {boolean} [isOnline] 
         * @param {string} [appointmentIdExcluded] 
         * @param {boolean} [excludeUnavailableTimeSlots] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet(dealId: string, packageId: string, year?: number, month?: number, timeZone?: string, isExternal?: boolean, isOnline?: boolean, appointmentIdExcluded?: string, excludeUnavailableTimeSlots?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<GetAppointmentTimetablesResponseModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet(dealId, packageId, year, month, timeZone, isExternal, isOnline, appointmentIdExcluded, excludeUnavailableTimeSlots, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Add, update and delete DealPackage appointment timetable
         * @param {string} dealId 
         * @param {string} packageId 
         * @param {BatchDealPackageAppointmentTimetablesCommand} [batchDealPackageAppointmentTimetablesCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesBatchPost(dealId: string, packageId: string, batchDealPackageAppointmentTimetablesCommand?: BatchDealPackageAppointmentTimetablesCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<BatchAppointmentTimetablesResultModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesBatchPost(dealId, packageId, batchDealPackageAppointmentTimetablesCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get DealPackage appointment timetables
         * @param {string} dealId 
         * @param {string} packageId 
         * @param {DayOfWeek} [dayOfWeek] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGet(dealId: string, packageId: string, dayOfWeek?: DayOfWeek, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AppointmentTimetablesModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGet(dealId, packageId, dayOfWeek, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete DealPackage.
         * @param {string} dealId 
         * @param {string} packageId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DealsDealIdPackagesPackageIdDelete(dealId: string, packageId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DealsDealIdPackagesPackageIdDelete(dealId, packageId, isPermanent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get DealPackage.
         * @param {string} dealId 
         * @param {string} packageId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DealsDealIdPackagesPackageIdGet(dealId: string, packageId: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DealPackageModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DealsDealIdPackagesPackageIdGet(dealId, packageId, languageCode, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update DealPackage.
         * @param {string} dealId 
         * @param {string} packageId 
         * @param {UpdateDealPackageCommand} [updateDealPackageCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DealsDealIdPackagesPackageIdPut(dealId: string, packageId: string, updateDealPackageCommand?: UpdateDealPackageCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DealPackageModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DealsDealIdPackagesPackageIdPut(dealId, packageId, updateDealPackageCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create DealPackage.
         * @param {string} dealId 
         * @param {CreateDealPackageCommand} [createDealPackageCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DealsDealIdPackagesPost(dealId: string, createDealPackageCommand?: CreateDealPackageCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DealPackageModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DealsDealIdPackagesPost(dealId, createDealPackageCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update deal.
         * @param {string} dealId 
         * @param {UpdateDealCommand} [updateDealCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DealsDealIdPut(dealId: string, updateDealCommand?: UpdateDealCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DealModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DealsDealIdPut(dealId, updateDealCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Revalidate deal
         * @param {string} dealId 
         * @param {boolean} [includeCurrent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DealsDealIdRevalidatePost(dealId: string, includeCurrent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DealsDealIdRevalidatePost(dealId, includeCurrent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all DealService.
         * @param {string} dealId 
         * @param {string} [languageCode] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DealsDealIdServicesGet(dealId: string, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DealServicesModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DealsDealIdServicesGet(dealId, languageCode, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create DealService.
         * @param {string} dealId 
         * @param {CreateDealServiceCommand} [createDealServiceCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DealsDealIdServicesPost(dealId: string, createDealServiceCommand?: CreateDealServiceCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DealServiceModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DealsDealIdServicesPost(dealId, createDealServiceCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete DealService.
         * @param {string} dealId 
         * @param {string} serviceId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DealsDealIdServicesServiceIdDelete(dealId: string, serviceId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DealsDealIdServicesServiceIdDelete(dealId, serviceId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get DealService.
         * @param {string} dealId 
         * @param {string} serviceId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DealsDealIdServicesServiceIdGet(dealId: string, serviceId: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DealServiceModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DealsDealIdServicesServiceIdGet(dealId, serviceId, languageCode, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update DealService.
         * @param {string} dealId 
         * @param {string} serviceId 
         * @param {UpdateDealServiceCommand} [updateDealServiceCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DealsDealIdServicesServiceIdPut(dealId: string, serviceId: string, updateDealServiceCommand?: UpdateDealServiceCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DealServiceModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DealsDealIdServicesServiceIdPut(dealId, serviceId, updateDealServiceCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Translate deal
         * @param {string} dealId 
         * @param {TranslateDealCommand} [translateDealCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DealsDealIdTranslatePost(dealId: string, translateDealCommand?: TranslateDealCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DealsDealIdTranslatePost(dealId, translateDealCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all deals.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {MarketingType} [marketingType] 
         * @param {string} [countryId] 
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [specialtyId] 
         * @param {string} [specialtyName] 
         * @param {string} [specialtyTypeId] 
         * @param {string} [specialtyTypeName] 
         * @param {string} [serviceId] 
         * @param {string} [serviceName] 
         * @param {string} [exceptHospitalId] 
         * @param {string} [exceptDealId] 
         * @param {Array<string>} [ids] 
         * @param {number} [serviceDuration] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {boolean} [returnDefaultValue] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DealsGet(id?: string, name?: string, marketingType?: MarketingType, countryId?: string, hospitalId?: string, hospitalName?: string, specialtyId?: string, specialtyName?: string, specialtyTypeId?: string, specialtyTypeName?: string, serviceId?: string, serviceName?: string, exceptHospitalId?: string, exceptDealId?: string, ids?: Array<string>, serviceDuration?: number, languageCode?: string, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DealsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DealsGet(id, name, marketingType, countryId, hospitalId, hospitalName, specialtyId, specialtyName, specialtyTypeId, specialtyTypeName, serviceId, serviceName, exceptHospitalId, exceptDealId, ids, serviceDuration, languageCode, showHidden, returnDefaultValue, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create a deal.
         * @param {CreateDealCommand} [createDealCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DealsPost(createDealCommand?: CreateDealCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DealModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DealsPost(createDealCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all deals.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {MarketingType} [marketingType] 
         * @param {string} [countryId] 
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [specialtyId] 
         * @param {string} [specialtyName] 
         * @param {string} [specialtyTypeId] 
         * @param {string} [specialtyTypeName] 
         * @param {string} [serviceId] 
         * @param {string} [serviceName] 
         * @param {string} [exceptHospitalId] 
         * @param {string} [exceptDealId] 
         * @param {Array<string>} [ids] 
         * @param {number} [serviceDuration] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {boolean} [returnDefaultValue] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DealsSimpleGet(id?: string, name?: string, marketingType?: MarketingType, countryId?: string, hospitalId?: string, hospitalName?: string, specialtyId?: string, specialtyName?: string, specialtyTypeId?: string, specialtyTypeName?: string, serviceId?: string, serviceName?: string, exceptHospitalId?: string, exceptDealId?: string, ids?: Array<string>, serviceDuration?: number, languageCode?: string, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DealsSimpleModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DealsSimpleGet(id, name, marketingType, countryId, hospitalId, hospitalName, specialtyId, specialtyName, specialtyTypeId, specialtyTypeName, serviceId, serviceName, exceptHospitalId, exceptDealId, ids, serviceDuration, languageCode, showHidden, returnDefaultValue, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get deal by slug.
         * @param {string} slug 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DealsSlugGet(slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DealModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DealsSlugGet(slug, languageCode, returnDefaultValue, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * DealsApi - factory interface
 * @export
 */
export const DealsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = DealsApiFp(configuration)
    return {
        /**
         * 
         * @summary Delete deal.
         * @param {string} dealId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdDelete(dealId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1DealsDealIdDelete(dealId, isPermanent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get deal.
         * @param {string} dealId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdGet(dealId: string, languageCode?: string, options?: any): AxiosPromise<DealModel> {
            return localVarFp.apiV1DealsDealIdGet(dealId, languageCode, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all DealPackage.
         * @param {string} dealId 
         * @param {string} [relatedDealPackageId] 
         * @param {string} [dealName] 
         * @param {string} [name] 
         * @param {string} [countryId] 
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdPackagesGet(dealId: string, relatedDealPackageId?: string, dealName?: string, name?: string, countryId?: string, hospitalId?: string, hospitalName?: string, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<DealPackagesModel> {
            return localVarFp.apiV1DealsDealIdPackagesGet(dealId, relatedDealPackageId, dealName, name, countryId, hospitalId, hospitalName, languageCode, showHidden, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get DealPackage appointment timetable overrides
         * @param {string} dealId 
         * @param {string} packageId 
         * @param {boolean} [includesPreviousItems] 
         * @param {Date} [startDate] 
         * @param {Date} [endDate] 
         * @param {DayOfWeek} [dayOfWeek] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet(dealId: string, packageId: string, includesPreviousItems?: boolean, startDate?: Date, endDate?: Date, dayOfWeek?: DayOfWeek, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<AppointmentTimetableOverridesModel> {
            return localVarFp.apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet(dealId, packageId, includesPreviousItems, startDate, endDate, dayOfWeek, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete DealPackage appointment timetable overrides
         * @param {string} dealId 
         * @param {string} packageId 
         * @param {DeleteDealPackageAppointmentTimetableOverridesCommand} [deleteDealPackageAppointmentTimetableOverridesCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPatch(dealId: string, packageId: string, deleteDealPackageAppointmentTimetableOverridesCommand?: DeleteDealPackageAppointmentTimetableOverridesCommand, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPatch(dealId, packageId, deleteDealPackageAppointmentTimetableOverridesCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Save DealPackage appointment timetable overrides
         * @param {string} dealId 
         * @param {string} packageId 
         * @param {SaveDealPackageAppointmentTimetableOverridesCommand} [saveDealPackageAppointmentTimetableOverridesCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPost(dealId: string, packageId: string, saveDealPackageAppointmentTimetableOverridesCommand?: SaveDealPackageAppointmentTimetableOverridesCommand, options?: any): AxiosPromise<SaveAppointmentTimetableOverridesResultModel> {
            return localVarFp.apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPost(dealId, packageId, saveDealPackageAppointmentTimetableOverridesCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get DealPackage appointment timetables for application
         * @param {string} dealId 
         * @param {string} packageId 
         * @param {number} [year] 
         * @param {number} [month] 
         * @param {string} [timeZone] 
         * @param {boolean} [isExternal] 
         * @param {boolean} [isOnline] 
         * @param {string} [appointmentIdExcluded] 
         * @param {boolean} [excludeUnavailableTimeSlots] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet(dealId: string, packageId: string, year?: number, month?: number, timeZone?: string, isExternal?: boolean, isOnline?: boolean, appointmentIdExcluded?: string, excludeUnavailableTimeSlots?: boolean, options?: any): AxiosPromise<GetAppointmentTimetablesResponseModel> {
            return localVarFp.apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet(dealId, packageId, year, month, timeZone, isExternal, isOnline, appointmentIdExcluded, excludeUnavailableTimeSlots, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Add, update and delete DealPackage appointment timetable
         * @param {string} dealId 
         * @param {string} packageId 
         * @param {BatchDealPackageAppointmentTimetablesCommand} [batchDealPackageAppointmentTimetablesCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesBatchPost(dealId: string, packageId: string, batchDealPackageAppointmentTimetablesCommand?: BatchDealPackageAppointmentTimetablesCommand, options?: any): AxiosPromise<BatchAppointmentTimetablesResultModel> {
            return localVarFp.apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesBatchPost(dealId, packageId, batchDealPackageAppointmentTimetablesCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get DealPackage appointment timetables
         * @param {string} dealId 
         * @param {string} packageId 
         * @param {DayOfWeek} [dayOfWeek] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGet(dealId: string, packageId: string, dayOfWeek?: DayOfWeek, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<AppointmentTimetablesModel> {
            return localVarFp.apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGet(dealId, packageId, dayOfWeek, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete DealPackage.
         * @param {string} dealId 
         * @param {string} packageId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdPackagesPackageIdDelete(dealId: string, packageId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1DealsDealIdPackagesPackageIdDelete(dealId, packageId, isPermanent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get DealPackage.
         * @param {string} dealId 
         * @param {string} packageId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdPackagesPackageIdGet(dealId: string, packageId: string, languageCode?: string, options?: any): AxiosPromise<DealPackageModel> {
            return localVarFp.apiV1DealsDealIdPackagesPackageIdGet(dealId, packageId, languageCode, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update DealPackage.
         * @param {string} dealId 
         * @param {string} packageId 
         * @param {UpdateDealPackageCommand} [updateDealPackageCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdPackagesPackageIdPut(dealId: string, packageId: string, updateDealPackageCommand?: UpdateDealPackageCommand, options?: any): AxiosPromise<DealPackageModel> {
            return localVarFp.apiV1DealsDealIdPackagesPackageIdPut(dealId, packageId, updateDealPackageCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create DealPackage.
         * @param {string} dealId 
         * @param {CreateDealPackageCommand} [createDealPackageCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdPackagesPost(dealId: string, createDealPackageCommand?: CreateDealPackageCommand, options?: any): AxiosPromise<DealPackageModel> {
            return localVarFp.apiV1DealsDealIdPackagesPost(dealId, createDealPackageCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update deal.
         * @param {string} dealId 
         * @param {UpdateDealCommand} [updateDealCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdPut(dealId: string, updateDealCommand?: UpdateDealCommand, options?: any): AxiosPromise<DealModel> {
            return localVarFp.apiV1DealsDealIdPut(dealId, updateDealCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Revalidate deal
         * @param {string} dealId 
         * @param {boolean} [includeCurrent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdRevalidatePost(dealId: string, includeCurrent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1DealsDealIdRevalidatePost(dealId, includeCurrent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all DealService.
         * @param {string} dealId 
         * @param {string} [languageCode] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdServicesGet(dealId: string, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<DealServicesModel> {
            return localVarFp.apiV1DealsDealIdServicesGet(dealId, languageCode, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create DealService.
         * @param {string} dealId 
         * @param {CreateDealServiceCommand} [createDealServiceCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdServicesPost(dealId: string, createDealServiceCommand?: CreateDealServiceCommand, options?: any): AxiosPromise<DealServiceModel> {
            return localVarFp.apiV1DealsDealIdServicesPost(dealId, createDealServiceCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete DealService.
         * @param {string} dealId 
         * @param {string} serviceId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdServicesServiceIdDelete(dealId: string, serviceId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1DealsDealIdServicesServiceIdDelete(dealId, serviceId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get DealService.
         * @param {string} dealId 
         * @param {string} serviceId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdServicesServiceIdGet(dealId: string, serviceId: string, languageCode?: string, options?: any): AxiosPromise<DealServiceModel> {
            return localVarFp.apiV1DealsDealIdServicesServiceIdGet(dealId, serviceId, languageCode, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update DealService.
         * @param {string} dealId 
         * @param {string} serviceId 
         * @param {UpdateDealServiceCommand} [updateDealServiceCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdServicesServiceIdPut(dealId: string, serviceId: string, updateDealServiceCommand?: UpdateDealServiceCommand, options?: any): AxiosPromise<DealServiceModel> {
            return localVarFp.apiV1DealsDealIdServicesServiceIdPut(dealId, serviceId, updateDealServiceCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Translate deal
         * @param {string} dealId 
         * @param {TranslateDealCommand} [translateDealCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsDealIdTranslatePost(dealId: string, translateDealCommand?: TranslateDealCommand, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1DealsDealIdTranslatePost(dealId, translateDealCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all deals.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {MarketingType} [marketingType] 
         * @param {string} [countryId] 
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [specialtyId] 
         * @param {string} [specialtyName] 
         * @param {string} [specialtyTypeId] 
         * @param {string} [specialtyTypeName] 
         * @param {string} [serviceId] 
         * @param {string} [serviceName] 
         * @param {string} [exceptHospitalId] 
         * @param {string} [exceptDealId] 
         * @param {Array<string>} [ids] 
         * @param {number} [serviceDuration] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {boolean} [returnDefaultValue] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsGet(id?: string, name?: string, marketingType?: MarketingType, countryId?: string, hospitalId?: string, hospitalName?: string, specialtyId?: string, specialtyName?: string, specialtyTypeId?: string, specialtyTypeName?: string, serviceId?: string, serviceName?: string, exceptHospitalId?: string, exceptDealId?: string, ids?: Array<string>, serviceDuration?: number, languageCode?: string, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<DealsModel> {
            return localVarFp.apiV1DealsGet(id, name, marketingType, countryId, hospitalId, hospitalName, specialtyId, specialtyName, specialtyTypeId, specialtyTypeName, serviceId, serviceName, exceptHospitalId, exceptDealId, ids, serviceDuration, languageCode, showHidden, returnDefaultValue, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create a deal.
         * @param {CreateDealCommand} [createDealCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsPost(createDealCommand?: CreateDealCommand, options?: any): AxiosPromise<DealModel> {
            return localVarFp.apiV1DealsPost(createDealCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all deals.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {MarketingType} [marketingType] 
         * @param {string} [countryId] 
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [specialtyId] 
         * @param {string} [specialtyName] 
         * @param {string} [specialtyTypeId] 
         * @param {string} [specialtyTypeName] 
         * @param {string} [serviceId] 
         * @param {string} [serviceName] 
         * @param {string} [exceptHospitalId] 
         * @param {string} [exceptDealId] 
         * @param {Array<string>} [ids] 
         * @param {number} [serviceDuration] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {boolean} [returnDefaultValue] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsSimpleGet(id?: string, name?: string, marketingType?: MarketingType, countryId?: string, hospitalId?: string, hospitalName?: string, specialtyId?: string, specialtyName?: string, specialtyTypeId?: string, specialtyTypeName?: string, serviceId?: string, serviceName?: string, exceptHospitalId?: string, exceptDealId?: string, ids?: Array<string>, serviceDuration?: number, languageCode?: string, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<DealsSimpleModel> {
            return localVarFp.apiV1DealsSimpleGet(id, name, marketingType, countryId, hospitalId, hospitalName, specialtyId, specialtyName, specialtyTypeId, specialtyTypeName, serviceId, serviceName, exceptHospitalId, exceptDealId, ids, serviceDuration, languageCode, showHidden, returnDefaultValue, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get deal by slug.
         * @param {string} slug 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DealsSlugGet(slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: any): AxiosPromise<DealModel> {
            return localVarFp.apiV1DealsSlugGet(slug, languageCode, returnDefaultValue, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1DealsDealIdDelete operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdDeleteRequest
 */
export interface DealsApiApiV1DealsDealIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdDelete
     */
    readonly dealId: string

    /**
     * 
     * @type {boolean}
     * @memberof DealsApiApiV1DealsDealIdDelete
     */
    readonly isPermanent?: boolean
}

/**
 * Request parameters for apiV1DealsDealIdGet operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdGetRequest
 */
export interface DealsApiApiV1DealsDealIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdGet
     */
    readonly dealId: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdGet
     */
    readonly languageCode?: string
}

/**
 * Request parameters for apiV1DealsDealIdPackagesGet operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdPackagesGetRequest
 */
export interface DealsApiApiV1DealsDealIdPackagesGetRequest {
    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesGet
     */
    readonly dealId: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesGet
     */
    readonly relatedDealPackageId?: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesGet
     */
    readonly dealName?: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesGet
     */
    readonly name?: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesGet
     */
    readonly countryId?: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesGet
     */
    readonly hospitalName?: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof DealsApiApiV1DealsDealIdPackagesGet
     */
    readonly showHidden?: boolean

    /**
     * 
     * @type {number}
     * @memberof DealsApiApiV1DealsDealIdPackagesGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof DealsApiApiV1DealsDealIdPackagesGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof DealsApiApiV1DealsDealIdPackagesGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGetRequest
 */
export interface DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGetRequest {
    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet
     */
    readonly dealId: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet
     */
    readonly packageId: string

    /**
     * 
     * @type {boolean}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet
     */
    readonly includesPreviousItems?: boolean

    /**
     * 
     * @type {Date}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet
     */
    readonly startDate?: Date

    /**
     * 
     * @type {Date}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet
     */
    readonly endDate?: Date

    /**
     * 
     * @type {DayOfWeek}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet
     */
    readonly dayOfWeek?: DayOfWeek

    /**
     * 
     * @type {number}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPatch operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPatchRequest
 */
export interface DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPatchRequest {
    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPatch
     */
    readonly dealId: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPatch
     */
    readonly packageId: string

    /**
     * 
     * @type {DeleteDealPackageAppointmentTimetableOverridesCommand}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPatch
     */
    readonly deleteDealPackageAppointmentTimetableOverridesCommand?: DeleteDealPackageAppointmentTimetableOverridesCommand
}

/**
 * Request parameters for apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPost operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPostRequest
 */
export interface DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPostRequest {
    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPost
     */
    readonly dealId: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPost
     */
    readonly packageId: string

    /**
     * 
     * @type {SaveDealPackageAppointmentTimetableOverridesCommand}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPost
     */
    readonly saveDealPackageAppointmentTimetableOverridesCommand?: SaveDealPackageAppointmentTimetableOverridesCommand
}

/**
 * Request parameters for apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGetRequest
 */
export interface DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGetRequest {
    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet
     */
    readonly dealId: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet
     */
    readonly packageId: string

    /**
     * 
     * @type {number}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet
     */
    readonly year?: number

    /**
     * 
     * @type {number}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet
     */
    readonly month?: number

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet
     */
    readonly timeZone?: string

    /**
     * 
     * @type {boolean}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet
     */
    readonly isExternal?: boolean

    /**
     * 
     * @type {boolean}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet
     */
    readonly isOnline?: boolean

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet
     */
    readonly appointmentIdExcluded?: string

    /**
     * 
     * @type {boolean}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet
     */
    readonly excludeUnavailableTimeSlots?: boolean
}

/**
 * Request parameters for apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesBatchPost operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesBatchPostRequest
 */
export interface DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesBatchPostRequest {
    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesBatchPost
     */
    readonly dealId: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesBatchPost
     */
    readonly packageId: string

    /**
     * 
     * @type {BatchDealPackageAppointmentTimetablesCommand}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesBatchPost
     */
    readonly batchDealPackageAppointmentTimetablesCommand?: BatchDealPackageAppointmentTimetablesCommand
}

/**
 * Request parameters for apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGet operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGetRequest
 */
export interface DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGetRequest {
    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGet
     */
    readonly dealId: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGet
     */
    readonly packageId: string

    /**
     * 
     * @type {DayOfWeek}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGet
     */
    readonly dayOfWeek?: DayOfWeek

    /**
     * 
     * @type {number}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1DealsDealIdPackagesPackageIdDelete operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdPackagesPackageIdDeleteRequest
 */
export interface DealsApiApiV1DealsDealIdPackagesPackageIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdDelete
     */
    readonly dealId: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdDelete
     */
    readonly packageId: string

    /**
     * 
     * @type {boolean}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdDelete
     */
    readonly isPermanent?: boolean
}

/**
 * Request parameters for apiV1DealsDealIdPackagesPackageIdGet operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdPackagesPackageIdGetRequest
 */
export interface DealsApiApiV1DealsDealIdPackagesPackageIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdGet
     */
    readonly dealId: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdGet
     */
    readonly packageId: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdGet
     */
    readonly languageCode?: string
}

/**
 * Request parameters for apiV1DealsDealIdPackagesPackageIdPut operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdPackagesPackageIdPutRequest
 */
export interface DealsApiApiV1DealsDealIdPackagesPackageIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdPut
     */
    readonly dealId: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdPut
     */
    readonly packageId: string

    /**
     * 
     * @type {UpdateDealPackageCommand}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdPut
     */
    readonly updateDealPackageCommand?: UpdateDealPackageCommand
}

/**
 * Request parameters for apiV1DealsDealIdPackagesPost operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdPackagesPostRequest
 */
export interface DealsApiApiV1DealsDealIdPackagesPostRequest {
    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPost
     */
    readonly dealId: string

    /**
     * 
     * @type {CreateDealPackageCommand}
     * @memberof DealsApiApiV1DealsDealIdPackagesPost
     */
    readonly createDealPackageCommand?: CreateDealPackageCommand
}

/**
 * Request parameters for apiV1DealsDealIdPut operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdPutRequest
 */
export interface DealsApiApiV1DealsDealIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPut
     */
    readonly dealId: string

    /**
     * 
     * @type {UpdateDealCommand}
     * @memberof DealsApiApiV1DealsDealIdPut
     */
    readonly updateDealCommand?: UpdateDealCommand
}

/**
 * Request parameters for apiV1DealsDealIdRevalidatePost operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdRevalidatePostRequest
 */
export interface DealsApiApiV1DealsDealIdRevalidatePostRequest {
    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdRevalidatePost
     */
    readonly dealId: string

    /**
     * 
     * @type {boolean}
     * @memberof DealsApiApiV1DealsDealIdRevalidatePost
     */
    readonly includeCurrent?: boolean
}

/**
 * Request parameters for apiV1DealsDealIdServicesGet operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdServicesGetRequest
 */
export interface DealsApiApiV1DealsDealIdServicesGetRequest {
    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdServicesGet
     */
    readonly dealId: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdServicesGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {number}
     * @memberof DealsApiApiV1DealsDealIdServicesGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof DealsApiApiV1DealsDealIdServicesGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof DealsApiApiV1DealsDealIdServicesGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1DealsDealIdServicesPost operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdServicesPostRequest
 */
export interface DealsApiApiV1DealsDealIdServicesPostRequest {
    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdServicesPost
     */
    readonly dealId: string

    /**
     * 
     * @type {CreateDealServiceCommand}
     * @memberof DealsApiApiV1DealsDealIdServicesPost
     */
    readonly createDealServiceCommand?: CreateDealServiceCommand
}

/**
 * Request parameters for apiV1DealsDealIdServicesServiceIdDelete operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdServicesServiceIdDeleteRequest
 */
export interface DealsApiApiV1DealsDealIdServicesServiceIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdServicesServiceIdDelete
     */
    readonly dealId: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdServicesServiceIdDelete
     */
    readonly serviceId: string
}

/**
 * Request parameters for apiV1DealsDealIdServicesServiceIdGet operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdServicesServiceIdGetRequest
 */
export interface DealsApiApiV1DealsDealIdServicesServiceIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdServicesServiceIdGet
     */
    readonly dealId: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdServicesServiceIdGet
     */
    readonly serviceId: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdServicesServiceIdGet
     */
    readonly languageCode?: string
}

/**
 * Request parameters for apiV1DealsDealIdServicesServiceIdPut operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdServicesServiceIdPutRequest
 */
export interface DealsApiApiV1DealsDealIdServicesServiceIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdServicesServiceIdPut
     */
    readonly dealId: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdServicesServiceIdPut
     */
    readonly serviceId: string

    /**
     * 
     * @type {UpdateDealServiceCommand}
     * @memberof DealsApiApiV1DealsDealIdServicesServiceIdPut
     */
    readonly updateDealServiceCommand?: UpdateDealServiceCommand
}

/**
 * Request parameters for apiV1DealsDealIdTranslatePost operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdTranslatePostRequest
 */
export interface DealsApiApiV1DealsDealIdTranslatePostRequest {
    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdTranslatePost
     */
    readonly dealId: string

    /**
     * 
     * @type {TranslateDealCommand}
     * @memberof DealsApiApiV1DealsDealIdTranslatePost
     */
    readonly translateDealCommand?: TranslateDealCommand
}

/**
 * Request parameters for apiV1DealsGet operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsGetRequest
 */
export interface DealsApiApiV1DealsGetRequest {
    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly id?: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly name?: string

    /**
     * 
     * @type {MarketingType}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly marketingType?: MarketingType

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly countryId?: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly hospitalName?: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly specialtyId?: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly specialtyName?: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly specialtyTypeId?: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly specialtyTypeName?: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly serviceId?: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly serviceName?: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly exceptHospitalId?: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly exceptDealId?: string

    /**
     * 
     * @type {Array<string>}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly ids?: Array<string>

    /**
     * 
     * @type {number}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly serviceDuration?: number

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly showHidden?: boolean

    /**
     * 
     * @type {boolean}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly returnDefaultValue?: boolean

    /**
     * 
     * @type {number}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1DealsPost operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsPostRequest
 */
export interface DealsApiApiV1DealsPostRequest {
    /**
     * 
     * @type {CreateDealCommand}
     * @memberof DealsApiApiV1DealsPost
     */
    readonly createDealCommand?: CreateDealCommand
}

/**
 * Request parameters for apiV1DealsSimpleGet operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsSimpleGetRequest
 */
export interface DealsApiApiV1DealsSimpleGetRequest {
    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly id?: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly name?: string

    /**
     * 
     * @type {MarketingType}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly marketingType?: MarketingType

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly countryId?: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly hospitalName?: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly specialtyId?: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly specialtyName?: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly specialtyTypeId?: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly specialtyTypeName?: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly serviceId?: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly serviceName?: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly exceptHospitalId?: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly exceptDealId?: string

    /**
     * 
     * @type {Array<string>}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly ids?: Array<string>

    /**
     * 
     * @type {number}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly serviceDuration?: number

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly showHidden?: boolean

    /**
     * 
     * @type {boolean}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly returnDefaultValue?: boolean

    /**
     * 
     * @type {number}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1DealsSlugGet operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsSlugGetRequest
 */
export interface DealsApiApiV1DealsSlugGetRequest {
    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsSlugGet
     */
    readonly slug: string

    /**
     * 
     * @type {string}
     * @memberof DealsApiApiV1DealsSlugGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof DealsApiApiV1DealsSlugGet
     */
    readonly returnDefaultValue?: boolean
}

/**
 * DealsApi - object-oriented interface
 * @export
 * @class DealsApi
 * @extends {BaseAPI}
 */
export class DealsApi extends BaseAPI {
    /**
     * 
     * @summary Delete deal.
     * @param {DealsApiApiV1DealsDealIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    public apiV1DealsDealIdDelete(requestParameters: DealsApiApiV1DealsDealIdDeleteRequest, options?: AxiosRequestConfig) {
        return DealsApiFp(this.configuration).apiV1DealsDealIdDelete(requestParameters.dealId, requestParameters.isPermanent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get deal.
     * @param {DealsApiApiV1DealsDealIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    public apiV1DealsDealIdGet(requestParameters: DealsApiApiV1DealsDealIdGetRequest, options?: AxiosRequestConfig) {
        return DealsApiFp(this.configuration).apiV1DealsDealIdGet(requestParameters.dealId, requestParameters.languageCode, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all DealPackage.
     * @param {DealsApiApiV1DealsDealIdPackagesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    public apiV1DealsDealIdPackagesGet(requestParameters: DealsApiApiV1DealsDealIdPackagesGetRequest, options?: AxiosRequestConfig) {
        return DealsApiFp(this.configuration).apiV1DealsDealIdPackagesGet(requestParameters.dealId, requestParameters.relatedDealPackageId, requestParameters.dealName, requestParameters.name, requestParameters.countryId, requestParameters.hospitalId, requestParameters.hospitalName, requestParameters.languageCode, requestParameters.showHidden, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get DealPackage appointment timetable overrides
     * @param {DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    public apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet(requestParameters: DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGetRequest, options?: AxiosRequestConfig) {
        return DealsApiFp(this.configuration).apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet(requestParameters.dealId, requestParameters.packageId, requestParameters.includesPreviousItems, requestParameters.startDate, requestParameters.endDate, requestParameters.dayOfWeek, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete DealPackage appointment timetable overrides
     * @param {DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPatchRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    public apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPatch(requestParameters: DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPatchRequest, options?: AxiosRequestConfig) {
        return DealsApiFp(this.configuration).apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPatch(requestParameters.dealId, requestParameters.packageId, requestParameters.deleteDealPackageAppointmentTimetableOverridesCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Save DealPackage appointment timetable overrides
     * @param {DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    public apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPost(requestParameters: DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPostRequest, options?: AxiosRequestConfig) {
        return DealsApiFp(this.configuration).apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPost(requestParameters.dealId, requestParameters.packageId, requestParameters.saveDealPackageAppointmentTimetableOverridesCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get DealPackage appointment timetables for application
     * @param {DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    public apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet(requestParameters: DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGetRequest, options?: AxiosRequestConfig) {
        return DealsApiFp(this.configuration).apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet(requestParameters.dealId, requestParameters.packageId, requestParameters.year, requestParameters.month, requestParameters.timeZone, requestParameters.isExternal, requestParameters.isOnline, requestParameters.appointmentIdExcluded, requestParameters.excludeUnavailableTimeSlots, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Add, update and delete DealPackage appointment timetable
     * @param {DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesBatchPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    public apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesBatchPost(requestParameters: DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesBatchPostRequest, options?: AxiosRequestConfig) {
        return DealsApiFp(this.configuration).apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesBatchPost(requestParameters.dealId, requestParameters.packageId, requestParameters.batchDealPackageAppointmentTimetablesCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get DealPackage appointment timetables
     * @param {DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    public apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGet(requestParameters: DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGetRequest, options?: AxiosRequestConfig) {
        return DealsApiFp(this.configuration).apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGet(requestParameters.dealId, requestParameters.packageId, requestParameters.dayOfWeek, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete DealPackage.
     * @param {DealsApiApiV1DealsDealIdPackagesPackageIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    public apiV1DealsDealIdPackagesPackageIdDelete(requestParameters: DealsApiApiV1DealsDealIdPackagesPackageIdDeleteRequest, options?: AxiosRequestConfig) {
        return DealsApiFp(this.configuration).apiV1DealsDealIdPackagesPackageIdDelete(requestParameters.dealId, requestParameters.packageId, requestParameters.isPermanent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get DealPackage.
     * @param {DealsApiApiV1DealsDealIdPackagesPackageIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    public apiV1DealsDealIdPackagesPackageIdGet(requestParameters: DealsApiApiV1DealsDealIdPackagesPackageIdGetRequest, options?: AxiosRequestConfig) {
        return DealsApiFp(this.configuration).apiV1DealsDealIdPackagesPackageIdGet(requestParameters.dealId, requestParameters.packageId, requestParameters.languageCode, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update DealPackage.
     * @param {DealsApiApiV1DealsDealIdPackagesPackageIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    public apiV1DealsDealIdPackagesPackageIdPut(requestParameters: DealsApiApiV1DealsDealIdPackagesPackageIdPutRequest, options?: AxiosRequestConfig) {
        return DealsApiFp(this.configuration).apiV1DealsDealIdPackagesPackageIdPut(requestParameters.dealId, requestParameters.packageId, requestParameters.updateDealPackageCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create DealPackage.
     * @param {DealsApiApiV1DealsDealIdPackagesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    public apiV1DealsDealIdPackagesPost(requestParameters: DealsApiApiV1DealsDealIdPackagesPostRequest, options?: AxiosRequestConfig) {
        return DealsApiFp(this.configuration).apiV1DealsDealIdPackagesPost(requestParameters.dealId, requestParameters.createDealPackageCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update deal.
     * @param {DealsApiApiV1DealsDealIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    public apiV1DealsDealIdPut(requestParameters: DealsApiApiV1DealsDealIdPutRequest, options?: AxiosRequestConfig) {
        return DealsApiFp(this.configuration).apiV1DealsDealIdPut(requestParameters.dealId, requestParameters.updateDealCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Revalidate deal
     * @param {DealsApiApiV1DealsDealIdRevalidatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    public apiV1DealsDealIdRevalidatePost(requestParameters: DealsApiApiV1DealsDealIdRevalidatePostRequest, options?: AxiosRequestConfig) {
        return DealsApiFp(this.configuration).apiV1DealsDealIdRevalidatePost(requestParameters.dealId, requestParameters.includeCurrent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all DealService.
     * @param {DealsApiApiV1DealsDealIdServicesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    public apiV1DealsDealIdServicesGet(requestParameters: DealsApiApiV1DealsDealIdServicesGetRequest, options?: AxiosRequestConfig) {
        return DealsApiFp(this.configuration).apiV1DealsDealIdServicesGet(requestParameters.dealId, requestParameters.languageCode, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create DealService.
     * @param {DealsApiApiV1DealsDealIdServicesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    public apiV1DealsDealIdServicesPost(requestParameters: DealsApiApiV1DealsDealIdServicesPostRequest, options?: AxiosRequestConfig) {
        return DealsApiFp(this.configuration).apiV1DealsDealIdServicesPost(requestParameters.dealId, requestParameters.createDealServiceCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete DealService.
     * @param {DealsApiApiV1DealsDealIdServicesServiceIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    public apiV1DealsDealIdServicesServiceIdDelete(requestParameters: DealsApiApiV1DealsDealIdServicesServiceIdDeleteRequest, options?: AxiosRequestConfig) {
        return DealsApiFp(this.configuration).apiV1DealsDealIdServicesServiceIdDelete(requestParameters.dealId, requestParameters.serviceId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get DealService.
     * @param {DealsApiApiV1DealsDealIdServicesServiceIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    public apiV1DealsDealIdServicesServiceIdGet(requestParameters: DealsApiApiV1DealsDealIdServicesServiceIdGetRequest, options?: AxiosRequestConfig) {
        return DealsApiFp(this.configuration).apiV1DealsDealIdServicesServiceIdGet(requestParameters.dealId, requestParameters.serviceId, requestParameters.languageCode, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update DealService.
     * @param {DealsApiApiV1DealsDealIdServicesServiceIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    public apiV1DealsDealIdServicesServiceIdPut(requestParameters: DealsApiApiV1DealsDealIdServicesServiceIdPutRequest, options?: AxiosRequestConfig) {
        return DealsApiFp(this.configuration).apiV1DealsDealIdServicesServiceIdPut(requestParameters.dealId, requestParameters.serviceId, requestParameters.updateDealServiceCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Translate deal
     * @param {DealsApiApiV1DealsDealIdTranslatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    public apiV1DealsDealIdTranslatePost(requestParameters: DealsApiApiV1DealsDealIdTranslatePostRequest, options?: AxiosRequestConfig) {
        return DealsApiFp(this.configuration).apiV1DealsDealIdTranslatePost(requestParameters.dealId, requestParameters.translateDealCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all deals.
     * @param {DealsApiApiV1DealsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    public apiV1DealsGet(requestParameters: DealsApiApiV1DealsGetRequest = {}, options?: AxiosRequestConfig) {
        return DealsApiFp(this.configuration).apiV1DealsGet(requestParameters.id, requestParameters.name, requestParameters.marketingType, requestParameters.countryId, requestParameters.hospitalId, requestParameters.hospitalName, requestParameters.specialtyId, requestParameters.specialtyName, requestParameters.specialtyTypeId, requestParameters.specialtyTypeName, requestParameters.serviceId, requestParameters.serviceName, requestParameters.exceptHospitalId, requestParameters.exceptDealId, requestParameters.ids, requestParameters.serviceDuration, requestParameters.languageCode, requestParameters.showHidden, requestParameters.returnDefaultValue, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create a deal.
     * @param {DealsApiApiV1DealsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    public apiV1DealsPost(requestParameters: DealsApiApiV1DealsPostRequest = {}, options?: AxiosRequestConfig) {
        return DealsApiFp(this.configuration).apiV1DealsPost(requestParameters.createDealCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all deals.
     * @param {DealsApiApiV1DealsSimpleGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    public apiV1DealsSimpleGet(requestParameters: DealsApiApiV1DealsSimpleGetRequest = {}, options?: AxiosRequestConfig) {
        return DealsApiFp(this.configuration).apiV1DealsSimpleGet(requestParameters.id, requestParameters.name, requestParameters.marketingType, requestParameters.countryId, requestParameters.hospitalId, requestParameters.hospitalName, requestParameters.specialtyId, requestParameters.specialtyName, requestParameters.specialtyTypeId, requestParameters.specialtyTypeName, requestParameters.serviceId, requestParameters.serviceName, requestParameters.exceptHospitalId, requestParameters.exceptDealId, requestParameters.ids, requestParameters.serviceDuration, requestParameters.languageCode, requestParameters.showHidden, requestParameters.returnDefaultValue, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get deal by slug.
     * @param {DealsApiApiV1DealsSlugGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    public apiV1DealsSlugGet(requestParameters: DealsApiApiV1DealsSlugGetRequest, options?: AxiosRequestConfig) {
        return DealsApiFp(this.configuration).apiV1DealsSlugGet(requestParameters.slug, requestParameters.languageCode, requestParameters.returnDefaultValue, options).then((request) => request(this.axios, this.basePath));
    }
}
