/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { FormResultModel } from '../models';
// @ts-ignore
import { FormResultStatus } from '../models';
// @ts-ignore
import { FormResultsModel } from '../models';
// @ts-ignore
import { FormTemplatePlatform } from '../models';
// @ts-ignore
import { FormTemplateType } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { UpdateFormResultCommand } from '../models';
/**
 * FormResultsApi - axios parameter creator
 * @export
 */
export const FormResultsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Delete formResult
         * @param {string} formResultId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FormresultsFormResultIdDelete: async (formResultId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'formResultId' is not null or undefined
            assertParamExists('apiV1FormresultsFormResultIdDelete', 'formResultId', formResultId)
            const localVarPath = `/api/v1/formresults/{formResultId}`
                .replace(`{${"formResultId"}}`, encodeURIComponent(String(formResultId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get formResult
         * @param {string} formResultId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FormresultsFormResultIdGet: async (formResultId: string, languageCode?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'formResultId' is not null or undefined
            assertParamExists('apiV1FormresultsFormResultIdGet', 'formResultId', formResultId)
            const localVarPath = `/api/v1/formresults/{formResultId}`
                .replace(`{${"formResultId"}}`, encodeURIComponent(String(formResultId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update formResult
         * @param {string} formResultId 
         * @param {UpdateFormResultCommand} [updateFormResultCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FormresultsFormResultIdPut: async (formResultId: string, updateFormResultCommand?: UpdateFormResultCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'formResultId' is not null or undefined
            assertParamExists('apiV1FormresultsFormResultIdPut', 'formResultId', formResultId)
            const localVarPath = `/api/v1/formresults/{formResultId}`
                .replace(`{${"formResultId"}}`, encodeURIComponent(String(formResultId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateFormResultCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get formResults
         * @param {string} [languageCode] 
         * @param {Date} [startDate] 
         * @param {Date} [endDate] 
         * @param {string} [hospitalId] 
         * @param {boolean} [noHospitalOnly] 
         * @param {FormTemplatePlatform} [platform] 
         * @param {FormTemplateType} [formTemplateType] 
         * @param {FormResultStatus} [status] 
         * @param {string} [userId] 
         * @param {boolean} [noUserOnly] 
         * @param {string} [userName] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FormresultsGet: async (languageCode?: string, startDate?: Date, endDate?: Date, hospitalId?: string, noHospitalOnly?: boolean, platform?: FormTemplatePlatform, formTemplateType?: FormTemplateType, status?: FormResultStatus, userId?: string, noUserOnly?: boolean, userName?: string, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/formresults`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }

            if (startDate !== undefined) {
                localVarQueryParameter['StartDate'] = (startDate as any instanceof Date) ?
                    (startDate as any).toISOString() :
                    startDate;
            }

            if (endDate !== undefined) {
                localVarQueryParameter['EndDate'] = (endDate as any instanceof Date) ?
                    (endDate as any).toISOString() :
                    endDate;
            }

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (noHospitalOnly !== undefined) {
                localVarQueryParameter['NoHospitalOnly'] = noHospitalOnly;
            }

            if (platform !== undefined) {
                localVarQueryParameter['Platform'] = platform;
            }

            if (formTemplateType !== undefined) {
                localVarQueryParameter['FormTemplateType'] = formTemplateType;
            }

            if (status !== undefined) {
                localVarQueryParameter['Status'] = status;
            }

            if (userId !== undefined) {
                localVarQueryParameter['UserId'] = userId;
            }

            if (noUserOnly !== undefined) {
                localVarQueryParameter['NoUserOnly'] = noUserOnly;
            }

            if (userName !== undefined) {
                localVarQueryParameter['UserName'] = userName;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * FormResultsApi - functional programming interface
 * @export
 */
export const FormResultsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = FormResultsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Delete formResult
         * @param {string} formResultId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FormresultsFormResultIdDelete(formResultId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FormResultModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FormresultsFormResultIdDelete(formResultId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get formResult
         * @param {string} formResultId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FormresultsFormResultIdGet(formResultId: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FormResultModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FormresultsFormResultIdGet(formResultId, languageCode, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update formResult
         * @param {string} formResultId 
         * @param {UpdateFormResultCommand} [updateFormResultCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FormresultsFormResultIdPut(formResultId: string, updateFormResultCommand?: UpdateFormResultCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FormResultModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FormresultsFormResultIdPut(formResultId, updateFormResultCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get formResults
         * @param {string} [languageCode] 
         * @param {Date} [startDate] 
         * @param {Date} [endDate] 
         * @param {string} [hospitalId] 
         * @param {boolean} [noHospitalOnly] 
         * @param {FormTemplatePlatform} [platform] 
         * @param {FormTemplateType} [formTemplateType] 
         * @param {FormResultStatus} [status] 
         * @param {string} [userId] 
         * @param {boolean} [noUserOnly] 
         * @param {string} [userName] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FormresultsGet(languageCode?: string, startDate?: Date, endDate?: Date, hospitalId?: string, noHospitalOnly?: boolean, platform?: FormTemplatePlatform, formTemplateType?: FormTemplateType, status?: FormResultStatus, userId?: string, noUserOnly?: boolean, userName?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FormResultsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FormresultsGet(languageCode, startDate, endDate, hospitalId, noHospitalOnly, platform, formTemplateType, status, userId, noUserOnly, userName, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * FormResultsApi - factory interface
 * @export
 */
export const FormResultsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = FormResultsApiFp(configuration)
    return {
        /**
         * 
         * @summary Delete formResult
         * @param {string} formResultId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FormresultsFormResultIdDelete(formResultId: string, options?: any): AxiosPromise<FormResultModel> {
            return localVarFp.apiV1FormresultsFormResultIdDelete(formResultId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get formResult
         * @param {string} formResultId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FormresultsFormResultIdGet(formResultId: string, languageCode?: string, options?: any): AxiosPromise<FormResultModel> {
            return localVarFp.apiV1FormresultsFormResultIdGet(formResultId, languageCode, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update formResult
         * @param {string} formResultId 
         * @param {UpdateFormResultCommand} [updateFormResultCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FormresultsFormResultIdPut(formResultId: string, updateFormResultCommand?: UpdateFormResultCommand, options?: any): AxiosPromise<FormResultModel> {
            return localVarFp.apiV1FormresultsFormResultIdPut(formResultId, updateFormResultCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get formResults
         * @param {string} [languageCode] 
         * @param {Date} [startDate] 
         * @param {Date} [endDate] 
         * @param {string} [hospitalId] 
         * @param {boolean} [noHospitalOnly] 
         * @param {FormTemplatePlatform} [platform] 
         * @param {FormTemplateType} [formTemplateType] 
         * @param {FormResultStatus} [status] 
         * @param {string} [userId] 
         * @param {boolean} [noUserOnly] 
         * @param {string} [userName] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FormresultsGet(languageCode?: string, startDate?: Date, endDate?: Date, hospitalId?: string, noHospitalOnly?: boolean, platform?: FormTemplatePlatform, formTemplateType?: FormTemplateType, status?: FormResultStatus, userId?: string, noUserOnly?: boolean, userName?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<FormResultsModel> {
            return localVarFp.apiV1FormresultsGet(languageCode, startDate, endDate, hospitalId, noHospitalOnly, platform, formTemplateType, status, userId, noUserOnly, userName, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1FormresultsFormResultIdDelete operation in FormResultsApi.
 * @export
 * @interface FormResultsApiApiV1FormresultsFormResultIdDeleteRequest
 */
export interface FormResultsApiApiV1FormresultsFormResultIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof FormResultsApiApiV1FormresultsFormResultIdDelete
     */
    readonly formResultId: string
}

/**
 * Request parameters for apiV1FormresultsFormResultIdGet operation in FormResultsApi.
 * @export
 * @interface FormResultsApiApiV1FormresultsFormResultIdGetRequest
 */
export interface FormResultsApiApiV1FormresultsFormResultIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof FormResultsApiApiV1FormresultsFormResultIdGet
     */
    readonly formResultId: string

    /**
     * 
     * @type {string}
     * @memberof FormResultsApiApiV1FormresultsFormResultIdGet
     */
    readonly languageCode?: string
}

/**
 * Request parameters for apiV1FormresultsFormResultIdPut operation in FormResultsApi.
 * @export
 * @interface FormResultsApiApiV1FormresultsFormResultIdPutRequest
 */
export interface FormResultsApiApiV1FormresultsFormResultIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof FormResultsApiApiV1FormresultsFormResultIdPut
     */
    readonly formResultId: string

    /**
     * 
     * @type {UpdateFormResultCommand}
     * @memberof FormResultsApiApiV1FormresultsFormResultIdPut
     */
    readonly updateFormResultCommand?: UpdateFormResultCommand
}

/**
 * Request parameters for apiV1FormresultsGet operation in FormResultsApi.
 * @export
 * @interface FormResultsApiApiV1FormresultsGetRequest
 */
export interface FormResultsApiApiV1FormresultsGetRequest {
    /**
     * 
     * @type {string}
     * @memberof FormResultsApiApiV1FormresultsGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {Date}
     * @memberof FormResultsApiApiV1FormresultsGet
     */
    readonly startDate?: Date

    /**
     * 
     * @type {Date}
     * @memberof FormResultsApiApiV1FormresultsGet
     */
    readonly endDate?: Date

    /**
     * 
     * @type {string}
     * @memberof FormResultsApiApiV1FormresultsGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {boolean}
     * @memberof FormResultsApiApiV1FormresultsGet
     */
    readonly noHospitalOnly?: boolean

    /**
     * 
     * @type {FormTemplatePlatform}
     * @memberof FormResultsApiApiV1FormresultsGet
     */
    readonly platform?: FormTemplatePlatform

    /**
     * 
     * @type {FormTemplateType}
     * @memberof FormResultsApiApiV1FormresultsGet
     */
    readonly formTemplateType?: FormTemplateType

    /**
     * 
     * @type {FormResultStatus}
     * @memberof FormResultsApiApiV1FormresultsGet
     */
    readonly status?: FormResultStatus

    /**
     * 
     * @type {string}
     * @memberof FormResultsApiApiV1FormresultsGet
     */
    readonly userId?: string

    /**
     * 
     * @type {boolean}
     * @memberof FormResultsApiApiV1FormresultsGet
     */
    readonly noUserOnly?: boolean

    /**
     * 
     * @type {string}
     * @memberof FormResultsApiApiV1FormresultsGet
     */
    readonly userName?: string

    /**
     * 
     * @type {number}
     * @memberof FormResultsApiApiV1FormresultsGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof FormResultsApiApiV1FormresultsGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof FormResultsApiApiV1FormresultsGet
     */
    readonly lastRetrieved?: Date
}

/**
 * FormResultsApi - object-oriented interface
 * @export
 * @class FormResultsApi
 * @extends {BaseAPI}
 */
export class FormResultsApi extends BaseAPI {
    /**
     * 
     * @summary Delete formResult
     * @param {FormResultsApiApiV1FormresultsFormResultIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FormResultsApi
     */
    public apiV1FormresultsFormResultIdDelete(requestParameters: FormResultsApiApiV1FormresultsFormResultIdDeleteRequest, options?: AxiosRequestConfig) {
        return FormResultsApiFp(this.configuration).apiV1FormresultsFormResultIdDelete(requestParameters.formResultId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get formResult
     * @param {FormResultsApiApiV1FormresultsFormResultIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FormResultsApi
     */
    public apiV1FormresultsFormResultIdGet(requestParameters: FormResultsApiApiV1FormresultsFormResultIdGetRequest, options?: AxiosRequestConfig) {
        return FormResultsApiFp(this.configuration).apiV1FormresultsFormResultIdGet(requestParameters.formResultId, requestParameters.languageCode, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update formResult
     * @param {FormResultsApiApiV1FormresultsFormResultIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FormResultsApi
     */
    public apiV1FormresultsFormResultIdPut(requestParameters: FormResultsApiApiV1FormresultsFormResultIdPutRequest, options?: AxiosRequestConfig) {
        return FormResultsApiFp(this.configuration).apiV1FormresultsFormResultIdPut(requestParameters.formResultId, requestParameters.updateFormResultCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get formResults
     * @param {FormResultsApiApiV1FormresultsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FormResultsApi
     */
    public apiV1FormresultsGet(requestParameters: FormResultsApiApiV1FormresultsGetRequest = {}, options?: AxiosRequestConfig) {
        return FormResultsApiFp(this.configuration).apiV1FormresultsGet(requestParameters.languageCode, requestParameters.startDate, requestParameters.endDate, requestParameters.hospitalId, requestParameters.noHospitalOnly, requestParameters.platform, requestParameters.formTemplateType, requestParameters.status, requestParameters.userId, requestParameters.noUserOnly, requestParameters.userName, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }
}
