/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { GroupChannelList } from '../models';
// @ts-ignore
import { InviteSendBirdGroupChannelCommand } from '../models';
// @ts-ignore
import { SendBirdGroupChannelModel } from '../models';
/**
 * GroupChannelsApi - axios parameter creator
 * @export
 */
export const GroupChannelsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary invite user to group channel
         * @param {string} channelUrl 
         * @param {InviteSendBirdGroupChannelCommand} [inviteSendBirdGroupChannelCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1GroupchannelsChannelUrlInvitePost: async (channelUrl: string, inviteSendBirdGroupChannelCommand?: InviteSendBirdGroupChannelCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'channelUrl' is not null or undefined
            assertParamExists('apiV1GroupchannelsChannelUrlInvitePost', 'channelUrl', channelUrl)
            const localVarPath = `/api/v1/groupchannels/{channelUrl}/invite`
                .replace(`{${"channelUrl"}}`, encodeURIComponent(String(channelUrl)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(inviteSendBirdGroupChannelCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get group channel list
         * @param {string} [nextToken] 
         * @param {string} [userId] 
         * @param {string} [customType] 
         * @param {number} [limit] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1GroupchannelsGet: async (nextToken?: string, userId?: string, customType?: string, limit?: number, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/groupchannels`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (nextToken !== undefined) {
                localVarQueryParameter['NextToken'] = nextToken;
            }

            if (userId !== undefined) {
                localVarQueryParameter['UserId'] = userId;
            }

            if (customType !== undefined) {
                localVarQueryParameter['CustomType'] = customType;
            }

            if (limit !== undefined) {
                localVarQueryParameter['Limit'] = limit;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * GroupChannelsApi - functional programming interface
 * @export
 */
export const GroupChannelsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = GroupChannelsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary invite user to group channel
         * @param {string} channelUrl 
         * @param {InviteSendBirdGroupChannelCommand} [inviteSendBirdGroupChannelCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1GroupchannelsChannelUrlInvitePost(channelUrl: string, inviteSendBirdGroupChannelCommand?: InviteSendBirdGroupChannelCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SendBirdGroupChannelModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1GroupchannelsChannelUrlInvitePost(channelUrl, inviteSendBirdGroupChannelCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get group channel list
         * @param {string} [nextToken] 
         * @param {string} [userId] 
         * @param {string} [customType] 
         * @param {number} [limit] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1GroupchannelsGet(nextToken?: string, userId?: string, customType?: string, limit?: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<GroupChannelList>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1GroupchannelsGet(nextToken, userId, customType, limit, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * GroupChannelsApi - factory interface
 * @export
 */
export const GroupChannelsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = GroupChannelsApiFp(configuration)
    return {
        /**
         * 
         * @summary invite user to group channel
         * @param {string} channelUrl 
         * @param {InviteSendBirdGroupChannelCommand} [inviteSendBirdGroupChannelCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1GroupchannelsChannelUrlInvitePost(channelUrl: string, inviteSendBirdGroupChannelCommand?: InviteSendBirdGroupChannelCommand, options?: any): AxiosPromise<SendBirdGroupChannelModel> {
            return localVarFp.apiV1GroupchannelsChannelUrlInvitePost(channelUrl, inviteSendBirdGroupChannelCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get group channel list
         * @param {string} [nextToken] 
         * @param {string} [userId] 
         * @param {string} [customType] 
         * @param {number} [limit] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1GroupchannelsGet(nextToken?: string, userId?: string, customType?: string, limit?: number, options?: any): AxiosPromise<GroupChannelList> {
            return localVarFp.apiV1GroupchannelsGet(nextToken, userId, customType, limit, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1GroupchannelsChannelUrlInvitePost operation in GroupChannelsApi.
 * @export
 * @interface GroupChannelsApiApiV1GroupchannelsChannelUrlInvitePostRequest
 */
export interface GroupChannelsApiApiV1GroupchannelsChannelUrlInvitePostRequest {
    /**
     * 
     * @type {string}
     * @memberof GroupChannelsApiApiV1GroupchannelsChannelUrlInvitePost
     */
    readonly channelUrl: string

    /**
     * 
     * @type {InviteSendBirdGroupChannelCommand}
     * @memberof GroupChannelsApiApiV1GroupchannelsChannelUrlInvitePost
     */
    readonly inviteSendBirdGroupChannelCommand?: InviteSendBirdGroupChannelCommand
}

/**
 * Request parameters for apiV1GroupchannelsGet operation in GroupChannelsApi.
 * @export
 * @interface GroupChannelsApiApiV1GroupchannelsGetRequest
 */
export interface GroupChannelsApiApiV1GroupchannelsGetRequest {
    /**
     * 
     * @type {string}
     * @memberof GroupChannelsApiApiV1GroupchannelsGet
     */
    readonly nextToken?: string

    /**
     * 
     * @type {string}
     * @memberof GroupChannelsApiApiV1GroupchannelsGet
     */
    readonly userId?: string

    /**
     * 
     * @type {string}
     * @memberof GroupChannelsApiApiV1GroupchannelsGet
     */
    readonly customType?: string

    /**
     * 
     * @type {number}
     * @memberof GroupChannelsApiApiV1GroupchannelsGet
     */
    readonly limit?: number
}

/**
 * GroupChannelsApi - object-oriented interface
 * @export
 * @class GroupChannelsApi
 * @extends {BaseAPI}
 */
export class GroupChannelsApi extends BaseAPI {
    /**
     * 
     * @summary invite user to group channel
     * @param {GroupChannelsApiApiV1GroupchannelsChannelUrlInvitePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof GroupChannelsApi
     */
    public apiV1GroupchannelsChannelUrlInvitePost(requestParameters: GroupChannelsApiApiV1GroupchannelsChannelUrlInvitePostRequest, options?: AxiosRequestConfig) {
        return GroupChannelsApiFp(this.configuration).apiV1GroupchannelsChannelUrlInvitePost(requestParameters.channelUrl, requestParameters.inviteSendBirdGroupChannelCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get group channel list
     * @param {GroupChannelsApiApiV1GroupchannelsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof GroupChannelsApi
     */
    public apiV1GroupchannelsGet(requestParameters: GroupChannelsApiApiV1GroupchannelsGetRequest = {}, options?: AxiosRequestConfig) {
        return GroupChannelsApiFp(this.configuration).apiV1GroupchannelsGet(requestParameters.nextToken, requestParameters.userId, requestParameters.customType, requestParameters.limit, options).then((request) => request(this.axios, this.basePath));
    }
}
