/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { CheckNotificationsCommand } from '../models';
// @ts-ignore
import { NotificationCode } from '../models';
// @ts-ignore
import { NotificationsModel } from '../models';
/**
 * NotificationsApi - axios parameter creator
 * @export
 */
export const NotificationsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Check notification.
         * @param {CheckNotificationsCommand} [checkNotificationsCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1NotificationsCheckPost: async (checkNotificationsCommand?: CheckNotificationsCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/notifications/check`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(checkNotificationsCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all notifications.
         * @param {NotificationCode} [notificationCode] 
         * @param {boolean} [unreadCountOnly] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1NotificationsGet: async (notificationCode?: NotificationCode, unreadCountOnly?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/notifications`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (notificationCode !== undefined) {
                localVarQueryParameter['NotificationCode'] = notificationCode;
            }

            if (unreadCountOnly !== undefined) {
                localVarQueryParameter['UnreadCountOnly'] = unreadCountOnly;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * NotificationsApi - functional programming interface
 * @export
 */
export const NotificationsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = NotificationsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Check notification.
         * @param {CheckNotificationsCommand} [checkNotificationsCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1NotificationsCheckPost(checkNotificationsCommand?: CheckNotificationsCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1NotificationsCheckPost(checkNotificationsCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all notifications.
         * @param {NotificationCode} [notificationCode] 
         * @param {boolean} [unreadCountOnly] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1NotificationsGet(notificationCode?: NotificationCode, unreadCountOnly?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<NotificationsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1NotificationsGet(notificationCode, unreadCountOnly, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * NotificationsApi - factory interface
 * @export
 */
export const NotificationsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = NotificationsApiFp(configuration)
    return {
        /**
         * 
         * @summary Check notification.
         * @param {CheckNotificationsCommand} [checkNotificationsCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1NotificationsCheckPost(checkNotificationsCommand?: CheckNotificationsCommand, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1NotificationsCheckPost(checkNotificationsCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all notifications.
         * @param {NotificationCode} [notificationCode] 
         * @param {boolean} [unreadCountOnly] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1NotificationsGet(notificationCode?: NotificationCode, unreadCountOnly?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<NotificationsModel> {
            return localVarFp.apiV1NotificationsGet(notificationCode, unreadCountOnly, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1NotificationsCheckPost operation in NotificationsApi.
 * @export
 * @interface NotificationsApiApiV1NotificationsCheckPostRequest
 */
export interface NotificationsApiApiV1NotificationsCheckPostRequest {
    /**
     * 
     * @type {CheckNotificationsCommand}
     * @memberof NotificationsApiApiV1NotificationsCheckPost
     */
    readonly checkNotificationsCommand?: CheckNotificationsCommand
}

/**
 * Request parameters for apiV1NotificationsGet operation in NotificationsApi.
 * @export
 * @interface NotificationsApiApiV1NotificationsGetRequest
 */
export interface NotificationsApiApiV1NotificationsGetRequest {
    /**
     * 
     * @type {NotificationCode}
     * @memberof NotificationsApiApiV1NotificationsGet
     */
    readonly notificationCode?: NotificationCode

    /**
     * 
     * @type {boolean}
     * @memberof NotificationsApiApiV1NotificationsGet
     */
    readonly unreadCountOnly?: boolean

    /**
     * 
     * @type {number}
     * @memberof NotificationsApiApiV1NotificationsGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof NotificationsApiApiV1NotificationsGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof NotificationsApiApiV1NotificationsGet
     */
    readonly lastRetrieved?: Date
}

/**
 * NotificationsApi - object-oriented interface
 * @export
 * @class NotificationsApi
 * @extends {BaseAPI}
 */
export class NotificationsApi extends BaseAPI {
    /**
     * 
     * @summary Check notification.
     * @param {NotificationsApiApiV1NotificationsCheckPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof NotificationsApi
     */
    public apiV1NotificationsCheckPost(requestParameters: NotificationsApiApiV1NotificationsCheckPostRequest = {}, options?: AxiosRequestConfig) {
        return NotificationsApiFp(this.configuration).apiV1NotificationsCheckPost(requestParameters.checkNotificationsCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all notifications.
     * @param {NotificationsApiApiV1NotificationsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof NotificationsApi
     */
    public apiV1NotificationsGet(requestParameters: NotificationsApiApiV1NotificationsGetRequest = {}, options?: AxiosRequestConfig) {
        return NotificationsApiFp(this.configuration).apiV1NotificationsGet(requestParameters.notificationCode, requestParameters.unreadCountOnly, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }
}
