/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { CreatePlanCommand } from '../models';
// @ts-ignore
import { CreatePlanHospitalCommand } from '../models';
// @ts-ignore
import { PlanHospitalModel } from '../models';
// @ts-ignore
import { PlanHospitalsModel } from '../models';
// @ts-ignore
import { PlanModel } from '../models';
// @ts-ignore
import { PlansModel } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { UpdatePlanCommand } from '../models';
// @ts-ignore
import { UpdatePlanHospitalCommand } from '../models';
/**
 * PlansApi - axios parameter creator
 * @export
 */
export const PlansApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get all plans.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PlansGet: async (id?: string, name?: string, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/plans`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (name !== undefined) {
                localVarQueryParameter['Name'] = name;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete plan.
         * @param {string} planId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PlansPlanIdDelete: async (planId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'planId' is not null or undefined
            assertParamExists('apiV1PlansPlanIdDelete', 'planId', planId)
            const localVarPath = `/api/v1/plans/{planId}`
                .replace(`{${"planId"}}`, encodeURIComponent(String(planId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get plan.
         * @param {string} planId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PlansPlanIdGet: async (planId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'planId' is not null or undefined
            assertParamExists('apiV1PlansPlanIdGet', 'planId', planId)
            const localVarPath = `/api/v1/plans/{planId}`
                .replace(`{${"planId"}}`, encodeURIComponent(String(planId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all plan hospital.
         * @param {string} planId 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PlansPlanIdHospitalsGet: async (planId: string, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'planId' is not null or undefined
            assertParamExists('apiV1PlansPlanIdHospitalsGet', 'planId', planId)
            const localVarPath = `/api/v1/plans/{planId}/hospitals`
                .replace(`{${"planId"}}`, encodeURIComponent(String(planId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete plan hospital.
         * @param {string} planId 
         * @param {string} hospitalId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PlansPlanIdHospitalsHospitalIdDelete: async (planId: string, hospitalId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'planId' is not null or undefined
            assertParamExists('apiV1PlansPlanIdHospitalsHospitalIdDelete', 'planId', planId)
            // verify required parameter 'hospitalId' is not null or undefined
            assertParamExists('apiV1PlansPlanIdHospitalsHospitalIdDelete', 'hospitalId', hospitalId)
            const localVarPath = `/api/v1/plans/{planId}/hospitals/{hospitalId}`
                .replace(`{${"planId"}}`, encodeURIComponent(String(planId)))
                .replace(`{${"hospitalId"}}`, encodeURIComponent(String(hospitalId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get plan hospital.
         * @param {string} planId 
         * @param {string} hospitalId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PlansPlanIdHospitalsHospitalIdGet: async (planId: string, hospitalId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'planId' is not null or undefined
            assertParamExists('apiV1PlansPlanIdHospitalsHospitalIdGet', 'planId', planId)
            // verify required parameter 'hospitalId' is not null or undefined
            assertParamExists('apiV1PlansPlanIdHospitalsHospitalIdGet', 'hospitalId', hospitalId)
            const localVarPath = `/api/v1/plans/{planId}/hospitals/{hospitalId}`
                .replace(`{${"planId"}}`, encodeURIComponent(String(planId)))
                .replace(`{${"hospitalId"}}`, encodeURIComponent(String(hospitalId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update plan hospital.
         * @param {string} planId 
         * @param {string} hospitalId 
         * @param {UpdatePlanHospitalCommand} [updatePlanHospitalCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PlansPlanIdHospitalsHospitalIdPut: async (planId: string, hospitalId: string, updatePlanHospitalCommand?: UpdatePlanHospitalCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'planId' is not null or undefined
            assertParamExists('apiV1PlansPlanIdHospitalsHospitalIdPut', 'planId', planId)
            // verify required parameter 'hospitalId' is not null or undefined
            assertParamExists('apiV1PlansPlanIdHospitalsHospitalIdPut', 'hospitalId', hospitalId)
            const localVarPath = `/api/v1/plans/{planId}/hospitals/{hospitalId}`
                .replace(`{${"planId"}}`, encodeURIComponent(String(planId)))
                .replace(`{${"hospitalId"}}`, encodeURIComponent(String(hospitalId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updatePlanHospitalCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create plan hospital.
         * @param {string} planId 
         * @param {CreatePlanHospitalCommand} [createPlanHospitalCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PlansPlanIdHospitalsPost: async (planId: string, createPlanHospitalCommand?: CreatePlanHospitalCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'planId' is not null or undefined
            assertParamExists('apiV1PlansPlanIdHospitalsPost', 'planId', planId)
            const localVarPath = `/api/v1/plans/{planId}/hospitals`
                .replace(`{${"planId"}}`, encodeURIComponent(String(planId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createPlanHospitalCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update plan.
         * @param {string} planId 
         * @param {UpdatePlanCommand} [updatePlanCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PlansPlanIdPut: async (planId: string, updatePlanCommand?: UpdatePlanCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'planId' is not null or undefined
            assertParamExists('apiV1PlansPlanIdPut', 'planId', planId)
            const localVarPath = `/api/v1/plans/{planId}`
                .replace(`{${"planId"}}`, encodeURIComponent(String(planId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updatePlanCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create a plan.
         * @param {CreatePlanCommand} [createPlanCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PlansPost: async (createPlanCommand?: CreatePlanCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/plans`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createPlanCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * PlansApi - functional programming interface
 * @export
 */
export const PlansApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = PlansApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Get all plans.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PlansGet(id?: string, name?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PlansModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PlansGet(id, name, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete plan.
         * @param {string} planId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PlansPlanIdDelete(planId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PlansPlanIdDelete(planId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get plan.
         * @param {string} planId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PlansPlanIdGet(planId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PlanModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PlansPlanIdGet(planId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all plan hospital.
         * @param {string} planId 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PlansPlanIdHospitalsGet(planId: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PlanHospitalsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PlansPlanIdHospitalsGet(planId, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete plan hospital.
         * @param {string} planId 
         * @param {string} hospitalId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PlansPlanIdHospitalsHospitalIdDelete(planId: string, hospitalId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PlansPlanIdHospitalsHospitalIdDelete(planId, hospitalId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get plan hospital.
         * @param {string} planId 
         * @param {string} hospitalId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PlansPlanIdHospitalsHospitalIdGet(planId: string, hospitalId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PlanHospitalModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PlansPlanIdHospitalsHospitalIdGet(planId, hospitalId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update plan hospital.
         * @param {string} planId 
         * @param {string} hospitalId 
         * @param {UpdatePlanHospitalCommand} [updatePlanHospitalCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PlansPlanIdHospitalsHospitalIdPut(planId: string, hospitalId: string, updatePlanHospitalCommand?: UpdatePlanHospitalCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PlanHospitalModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PlansPlanIdHospitalsHospitalIdPut(planId, hospitalId, updatePlanHospitalCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create plan hospital.
         * @param {string} planId 
         * @param {CreatePlanHospitalCommand} [createPlanHospitalCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PlansPlanIdHospitalsPost(planId: string, createPlanHospitalCommand?: CreatePlanHospitalCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PlanHospitalModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PlansPlanIdHospitalsPost(planId, createPlanHospitalCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update plan.
         * @param {string} planId 
         * @param {UpdatePlanCommand} [updatePlanCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PlansPlanIdPut(planId: string, updatePlanCommand?: UpdatePlanCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PlanModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PlansPlanIdPut(planId, updatePlanCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create a plan.
         * @param {CreatePlanCommand} [createPlanCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PlansPost(createPlanCommand?: CreatePlanCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PlanModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PlansPost(createPlanCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * PlansApi - factory interface
 * @export
 */
export const PlansApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = PlansApiFp(configuration)
    return {
        /**
         * 
         * @summary Get all plans.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PlansGet(id?: string, name?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<PlansModel> {
            return localVarFp.apiV1PlansGet(id, name, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete plan.
         * @param {string} planId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PlansPlanIdDelete(planId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1PlansPlanIdDelete(planId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get plan.
         * @param {string} planId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PlansPlanIdGet(planId: string, options?: any): AxiosPromise<PlanModel> {
            return localVarFp.apiV1PlansPlanIdGet(planId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all plan hospital.
         * @param {string} planId 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PlansPlanIdHospitalsGet(planId: string, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<PlanHospitalsModel> {
            return localVarFp.apiV1PlansPlanIdHospitalsGet(planId, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete plan hospital.
         * @param {string} planId 
         * @param {string} hospitalId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PlansPlanIdHospitalsHospitalIdDelete(planId: string, hospitalId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1PlansPlanIdHospitalsHospitalIdDelete(planId, hospitalId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get plan hospital.
         * @param {string} planId 
         * @param {string} hospitalId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PlansPlanIdHospitalsHospitalIdGet(planId: string, hospitalId: string, options?: any): AxiosPromise<PlanHospitalModel> {
            return localVarFp.apiV1PlansPlanIdHospitalsHospitalIdGet(planId, hospitalId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update plan hospital.
         * @param {string} planId 
         * @param {string} hospitalId 
         * @param {UpdatePlanHospitalCommand} [updatePlanHospitalCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PlansPlanIdHospitalsHospitalIdPut(planId: string, hospitalId: string, updatePlanHospitalCommand?: UpdatePlanHospitalCommand, options?: any): AxiosPromise<PlanHospitalModel> {
            return localVarFp.apiV1PlansPlanIdHospitalsHospitalIdPut(planId, hospitalId, updatePlanHospitalCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create plan hospital.
         * @param {string} planId 
         * @param {CreatePlanHospitalCommand} [createPlanHospitalCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PlansPlanIdHospitalsPost(planId: string, createPlanHospitalCommand?: CreatePlanHospitalCommand, options?: any): AxiosPromise<PlanHospitalModel> {
            return localVarFp.apiV1PlansPlanIdHospitalsPost(planId, createPlanHospitalCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update plan.
         * @param {string} planId 
         * @param {UpdatePlanCommand} [updatePlanCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PlansPlanIdPut(planId: string, updatePlanCommand?: UpdatePlanCommand, options?: any): AxiosPromise<PlanModel> {
            return localVarFp.apiV1PlansPlanIdPut(planId, updatePlanCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create a plan.
         * @param {CreatePlanCommand} [createPlanCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PlansPost(createPlanCommand?: CreatePlanCommand, options?: any): AxiosPromise<PlanModel> {
            return localVarFp.apiV1PlansPost(createPlanCommand, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1PlansGet operation in PlansApi.
 * @export
 * @interface PlansApiApiV1PlansGetRequest
 */
export interface PlansApiApiV1PlansGetRequest {
    /**
     * 
     * @type {string}
     * @memberof PlansApiApiV1PlansGet
     */
    readonly id?: string

    /**
     * 
     * @type {string}
     * @memberof PlansApiApiV1PlansGet
     */
    readonly name?: string

    /**
     * 
     * @type {number}
     * @memberof PlansApiApiV1PlansGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof PlansApiApiV1PlansGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof PlansApiApiV1PlansGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1PlansPlanIdDelete operation in PlansApi.
 * @export
 * @interface PlansApiApiV1PlansPlanIdDeleteRequest
 */
export interface PlansApiApiV1PlansPlanIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof PlansApiApiV1PlansPlanIdDelete
     */
    readonly planId: string
}

/**
 * Request parameters for apiV1PlansPlanIdGet operation in PlansApi.
 * @export
 * @interface PlansApiApiV1PlansPlanIdGetRequest
 */
export interface PlansApiApiV1PlansPlanIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof PlansApiApiV1PlansPlanIdGet
     */
    readonly planId: string
}

/**
 * Request parameters for apiV1PlansPlanIdHospitalsGet operation in PlansApi.
 * @export
 * @interface PlansApiApiV1PlansPlanIdHospitalsGetRequest
 */
export interface PlansApiApiV1PlansPlanIdHospitalsGetRequest {
    /**
     * 
     * @type {string}
     * @memberof PlansApiApiV1PlansPlanIdHospitalsGet
     */
    readonly planId: string

    /**
     * 
     * @type {number}
     * @memberof PlansApiApiV1PlansPlanIdHospitalsGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof PlansApiApiV1PlansPlanIdHospitalsGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof PlansApiApiV1PlansPlanIdHospitalsGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1PlansPlanIdHospitalsHospitalIdDelete operation in PlansApi.
 * @export
 * @interface PlansApiApiV1PlansPlanIdHospitalsHospitalIdDeleteRequest
 */
export interface PlansApiApiV1PlansPlanIdHospitalsHospitalIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof PlansApiApiV1PlansPlanIdHospitalsHospitalIdDelete
     */
    readonly planId: string

    /**
     * 
     * @type {string}
     * @memberof PlansApiApiV1PlansPlanIdHospitalsHospitalIdDelete
     */
    readonly hospitalId: string
}

/**
 * Request parameters for apiV1PlansPlanIdHospitalsHospitalIdGet operation in PlansApi.
 * @export
 * @interface PlansApiApiV1PlansPlanIdHospitalsHospitalIdGetRequest
 */
export interface PlansApiApiV1PlansPlanIdHospitalsHospitalIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof PlansApiApiV1PlansPlanIdHospitalsHospitalIdGet
     */
    readonly planId: string

    /**
     * 
     * @type {string}
     * @memberof PlansApiApiV1PlansPlanIdHospitalsHospitalIdGet
     */
    readonly hospitalId: string
}

/**
 * Request parameters for apiV1PlansPlanIdHospitalsHospitalIdPut operation in PlansApi.
 * @export
 * @interface PlansApiApiV1PlansPlanIdHospitalsHospitalIdPutRequest
 */
export interface PlansApiApiV1PlansPlanIdHospitalsHospitalIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof PlansApiApiV1PlansPlanIdHospitalsHospitalIdPut
     */
    readonly planId: string

    /**
     * 
     * @type {string}
     * @memberof PlansApiApiV1PlansPlanIdHospitalsHospitalIdPut
     */
    readonly hospitalId: string

    /**
     * 
     * @type {UpdatePlanHospitalCommand}
     * @memberof PlansApiApiV1PlansPlanIdHospitalsHospitalIdPut
     */
    readonly updatePlanHospitalCommand?: UpdatePlanHospitalCommand
}

/**
 * Request parameters for apiV1PlansPlanIdHospitalsPost operation in PlansApi.
 * @export
 * @interface PlansApiApiV1PlansPlanIdHospitalsPostRequest
 */
export interface PlansApiApiV1PlansPlanIdHospitalsPostRequest {
    /**
     * 
     * @type {string}
     * @memberof PlansApiApiV1PlansPlanIdHospitalsPost
     */
    readonly planId: string

    /**
     * 
     * @type {CreatePlanHospitalCommand}
     * @memberof PlansApiApiV1PlansPlanIdHospitalsPost
     */
    readonly createPlanHospitalCommand?: CreatePlanHospitalCommand
}

/**
 * Request parameters for apiV1PlansPlanIdPut operation in PlansApi.
 * @export
 * @interface PlansApiApiV1PlansPlanIdPutRequest
 */
export interface PlansApiApiV1PlansPlanIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof PlansApiApiV1PlansPlanIdPut
     */
    readonly planId: string

    /**
     * 
     * @type {UpdatePlanCommand}
     * @memberof PlansApiApiV1PlansPlanIdPut
     */
    readonly updatePlanCommand?: UpdatePlanCommand
}

/**
 * Request parameters for apiV1PlansPost operation in PlansApi.
 * @export
 * @interface PlansApiApiV1PlansPostRequest
 */
export interface PlansApiApiV1PlansPostRequest {
    /**
     * 
     * @type {CreatePlanCommand}
     * @memberof PlansApiApiV1PlansPost
     */
    readonly createPlanCommand?: CreatePlanCommand
}

/**
 * PlansApi - object-oriented interface
 * @export
 * @class PlansApi
 * @extends {BaseAPI}
 */
export class PlansApi extends BaseAPI {
    /**
     * 
     * @summary Get all plans.
     * @param {PlansApiApiV1PlansGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PlansApi
     */
    public apiV1PlansGet(requestParameters: PlansApiApiV1PlansGetRequest = {}, options?: AxiosRequestConfig) {
        return PlansApiFp(this.configuration).apiV1PlansGet(requestParameters.id, requestParameters.name, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete plan.
     * @param {PlansApiApiV1PlansPlanIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PlansApi
     */
    public apiV1PlansPlanIdDelete(requestParameters: PlansApiApiV1PlansPlanIdDeleteRequest, options?: AxiosRequestConfig) {
        return PlansApiFp(this.configuration).apiV1PlansPlanIdDelete(requestParameters.planId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get plan.
     * @param {PlansApiApiV1PlansPlanIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PlansApi
     */
    public apiV1PlansPlanIdGet(requestParameters: PlansApiApiV1PlansPlanIdGetRequest, options?: AxiosRequestConfig) {
        return PlansApiFp(this.configuration).apiV1PlansPlanIdGet(requestParameters.planId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all plan hospital.
     * @param {PlansApiApiV1PlansPlanIdHospitalsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PlansApi
     */
    public apiV1PlansPlanIdHospitalsGet(requestParameters: PlansApiApiV1PlansPlanIdHospitalsGetRequest, options?: AxiosRequestConfig) {
        return PlansApiFp(this.configuration).apiV1PlansPlanIdHospitalsGet(requestParameters.planId, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete plan hospital.
     * @param {PlansApiApiV1PlansPlanIdHospitalsHospitalIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PlansApi
     */
    public apiV1PlansPlanIdHospitalsHospitalIdDelete(requestParameters: PlansApiApiV1PlansPlanIdHospitalsHospitalIdDeleteRequest, options?: AxiosRequestConfig) {
        return PlansApiFp(this.configuration).apiV1PlansPlanIdHospitalsHospitalIdDelete(requestParameters.planId, requestParameters.hospitalId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get plan hospital.
     * @param {PlansApiApiV1PlansPlanIdHospitalsHospitalIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PlansApi
     */
    public apiV1PlansPlanIdHospitalsHospitalIdGet(requestParameters: PlansApiApiV1PlansPlanIdHospitalsHospitalIdGetRequest, options?: AxiosRequestConfig) {
        return PlansApiFp(this.configuration).apiV1PlansPlanIdHospitalsHospitalIdGet(requestParameters.planId, requestParameters.hospitalId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update plan hospital.
     * @param {PlansApiApiV1PlansPlanIdHospitalsHospitalIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PlansApi
     */
    public apiV1PlansPlanIdHospitalsHospitalIdPut(requestParameters: PlansApiApiV1PlansPlanIdHospitalsHospitalIdPutRequest, options?: AxiosRequestConfig) {
        return PlansApiFp(this.configuration).apiV1PlansPlanIdHospitalsHospitalIdPut(requestParameters.planId, requestParameters.hospitalId, requestParameters.updatePlanHospitalCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create plan hospital.
     * @param {PlansApiApiV1PlansPlanIdHospitalsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PlansApi
     */
    public apiV1PlansPlanIdHospitalsPost(requestParameters: PlansApiApiV1PlansPlanIdHospitalsPostRequest, options?: AxiosRequestConfig) {
        return PlansApiFp(this.configuration).apiV1PlansPlanIdHospitalsPost(requestParameters.planId, requestParameters.createPlanHospitalCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update plan.
     * @param {PlansApiApiV1PlansPlanIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PlansApi
     */
    public apiV1PlansPlanIdPut(requestParameters: PlansApiApiV1PlansPlanIdPutRequest, options?: AxiosRequestConfig) {
        return PlansApiFp(this.configuration).apiV1PlansPlanIdPut(requestParameters.planId, requestParameters.updatePlanCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create a plan.
     * @param {PlansApiApiV1PlansPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PlansApi
     */
    public apiV1PlansPost(requestParameters: PlansApiApiV1PlansPostRequest = {}, options?: AxiosRequestConfig) {
        return PlansApiFp(this.configuration).apiV1PlansPost(requestParameters.createPlanCommand, options).then((request) => request(this.axios, this.basePath));
    }
}
