/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { CreateMediaCommand } from '../models';
// @ts-ignore
import { CreateSpecialtyTypeCommand } from '../models';
// @ts-ignore
import { MarketingType } from '../models';
// @ts-ignore
import { MediaModel } from '../models';
// @ts-ignore
import { MediaType } from '../models';
// @ts-ignore
import { MediasModel } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { SortingResultModel } from '../models';
// @ts-ignore
import { SpecialtyTypeModel } from '../models';
// @ts-ignore
import { SpecialtyTypeSortingCommand } from '../models';
// @ts-ignore
import { SpecialtyTypesModel } from '../models';
// @ts-ignore
import { SpecialtyTypesSimpleModel } from '../models';
// @ts-ignore
import { TranslateSpecialtyTypeCommand } from '../models';
// @ts-ignore
import { UpdateMediaCommand } from '../models';
// @ts-ignore
import { UpdateSpecialtyTypeCommand } from '../models';
/**
 * SpecialtyTypesApi - axios parameter creator
 * @export
 */
export const SpecialtyTypesApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get all Departments.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {string} [description] 
         * @param {MarketingType} [marketingType] 
         * @param {string} [hospitalId] 
         * @param {Date} [created] 
         * @param {Array<string>} [ids] 
         * @param {string} [specialtyTypeCategoryId] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {boolean} [returnDefaultValue] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesGet: async (id?: string, name?: string, description?: string, marketingType?: MarketingType, hospitalId?: string, created?: Date, ids?: Array<string>, specialtyTypeCategoryId?: string, languageCode?: string, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/specialtytypes`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (name !== undefined) {
                localVarQueryParameter['Name'] = name;
            }

            if (description !== undefined) {
                localVarQueryParameter['Description'] = description;
            }

            if (marketingType !== undefined) {
                localVarQueryParameter['MarketingType'] = marketingType;
            }

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (created !== undefined) {
                localVarQueryParameter['Created'] = (created as any instanceof Date) ?
                    (created as any).toISOString() :
                    created;
            }

            if (ids) {
                localVarQueryParameter['Ids'] = ids;
            }

            if (specialtyTypeCategoryId !== undefined) {
                localVarQueryParameter['SpecialtyTypeCategoryId'] = specialtyTypeCategoryId;
            }

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }

            if (showHidden !== undefined) {
                localVarQueryParameter['ShowHidden'] = showHidden;
            }

            if (returnDefaultValue !== undefined) {
                localVarQueryParameter['ReturnDefaultValue'] = returnDefaultValue;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create a Department.
         * @param {CreateSpecialtyTypeCommand} [createSpecialtyTypeCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesPost: async (createSpecialtyTypeCommand?: CreateSpecialtyTypeCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/specialtytypes`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createSpecialtyTypeCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all Departments with simplified model.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {string} [description] 
         * @param {MarketingType} [marketingType] 
         * @param {string} [hospitalId] 
         * @param {Date} [created] 
         * @param {Array<string>} [ids] 
         * @param {string} [specialtyTypeCategoryId] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {boolean} [returnDefaultValue] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesSimpleGet: async (id?: string, name?: string, description?: string, marketingType?: MarketingType, hospitalId?: string, created?: Date, ids?: Array<string>, specialtyTypeCategoryId?: string, languageCode?: string, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/specialtytypes/simple`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (name !== undefined) {
                localVarQueryParameter['Name'] = name;
            }

            if (description !== undefined) {
                localVarQueryParameter['Description'] = description;
            }

            if (marketingType !== undefined) {
                localVarQueryParameter['MarketingType'] = marketingType;
            }

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (created !== undefined) {
                localVarQueryParameter['Created'] = (created as any instanceof Date) ?
                    (created as any).toISOString() :
                    created;
            }

            if (ids) {
                localVarQueryParameter['Ids'] = ids;
            }

            if (specialtyTypeCategoryId !== undefined) {
                localVarQueryParameter['SpecialtyTypeCategoryId'] = specialtyTypeCategoryId;
            }

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }

            if (showHidden !== undefined) {
                localVarQueryParameter['ShowHidden'] = showHidden;
            }

            if (returnDefaultValue !== undefined) {
                localVarQueryParameter['ReturnDefaultValue'] = returnDefaultValue;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get department by slug
         * @param {string} slug 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesSlugGet: async (slug: string, languageCode?: string, returnDefaultValue?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'slug' is not null or undefined
            assertParamExists('apiV1SpecialtytypesSlugGet', 'slug', slug)
            const localVarPath = `/api/v1/specialtytypes/{slug}`
                .replace(`{${"slug"}}`, encodeURIComponent(String(slug)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }

            if (returnDefaultValue !== undefined) {
                localVarQueryParameter['returnDefaultValue'] = returnDefaultValue;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Batch for departments sorting
         * @param {SpecialtyTypeSortingCommand} [specialtyTypeSortingCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesSortPut: async (specialtyTypeSortingCommand?: SpecialtyTypeSortingCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/specialtytypes/sort`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(specialtyTypeSortingCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete Department.
         * @param {string} specialtyTypeId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesSpecialtyTypeIdDelete: async (specialtyTypeId: string, isPermanent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'specialtyTypeId' is not null or undefined
            assertParamExists('apiV1SpecialtytypesSpecialtyTypeIdDelete', 'specialtyTypeId', specialtyTypeId)
            const localVarPath = `/api/v1/specialtytypes/{specialtyTypeId}`
                .replace(`{${"specialtyTypeId"}}`, encodeURIComponent(String(specialtyTypeId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (isPermanent !== undefined) {
                localVarQueryParameter['isPermanent'] = isPermanent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get department
         * @param {string} specialtyTypeId 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesSpecialtyTypeIdGet: async (specialtyTypeId: string, languageCode?: string, returnDefaultValue?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'specialtyTypeId' is not null or undefined
            assertParamExists('apiV1SpecialtytypesSpecialtyTypeIdGet', 'specialtyTypeId', specialtyTypeId)
            const localVarPath = `/api/v1/specialtytypes/{specialtyTypeId}`
                .replace(`{${"specialtyTypeId"}}`, encodeURIComponent(String(specialtyTypeId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }

            if (returnDefaultValue !== undefined) {
                localVarQueryParameter['returnDefaultValue'] = returnDefaultValue;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all SpecialtyTypeMedias.
         * @param {string} specialtyTypeId 
         * @param {string} [id] 
         * @param {MediaType} [mediaType] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesSpecialtyTypeIdMediasGet: async (specialtyTypeId: string, id?: string, mediaType?: MediaType, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'specialtyTypeId' is not null or undefined
            assertParamExists('apiV1SpecialtytypesSpecialtyTypeIdMediasGet', 'specialtyTypeId', specialtyTypeId)
            const localVarPath = `/api/v1/specialtytypes/{specialtyTypeId}/medias`
                .replace(`{${"specialtyTypeId"}}`, encodeURIComponent(String(specialtyTypeId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (mediaType !== undefined) {
                localVarQueryParameter['MediaType'] = mediaType;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete SpecialtyTypeMedia
         * @param {string} specialtyTypeId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdDelete: async (specialtyTypeId: string, mediaId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'specialtyTypeId' is not null or undefined
            assertParamExists('apiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdDelete', 'specialtyTypeId', specialtyTypeId)
            // verify required parameter 'mediaId' is not null or undefined
            assertParamExists('apiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdDelete', 'mediaId', mediaId)
            const localVarPath = `/api/v1/specialtytypes/{specialtyTypeId}/medias/{mediaId}`
                .replace(`{${"specialtyTypeId"}}`, encodeURIComponent(String(specialtyTypeId)))
                .replace(`{${"mediaId"}}`, encodeURIComponent(String(mediaId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get SpecialtyTypeMedia.
         * @param {string} specialtyTypeId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdGet: async (specialtyTypeId: string, mediaId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'specialtyTypeId' is not null or undefined
            assertParamExists('apiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdGet', 'specialtyTypeId', specialtyTypeId)
            // verify required parameter 'mediaId' is not null or undefined
            assertParamExists('apiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdGet', 'mediaId', mediaId)
            const localVarPath = `/api/v1/specialtytypes/{specialtyTypeId}/medias/{mediaId}`
                .replace(`{${"specialtyTypeId"}}`, encodeURIComponent(String(specialtyTypeId)))
                .replace(`{${"mediaId"}}`, encodeURIComponent(String(mediaId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update SpecialtyTypeMedia.
         * @param {string} specialtyTypeId 
         * @param {string} mediaId 
         * @param {UpdateMediaCommand} [updateMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdPut: async (specialtyTypeId: string, mediaId: string, updateMediaCommand?: UpdateMediaCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'specialtyTypeId' is not null or undefined
            assertParamExists('apiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdPut', 'specialtyTypeId', specialtyTypeId)
            // verify required parameter 'mediaId' is not null or undefined
            assertParamExists('apiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdPut', 'mediaId', mediaId)
            const localVarPath = `/api/v1/specialtytypes/{specialtyTypeId}/medias/{mediaId}`
                .replace(`{${"specialtyTypeId"}}`, encodeURIComponent(String(specialtyTypeId)))
                .replace(`{${"mediaId"}}`, encodeURIComponent(String(mediaId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateMediaCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create SpecialtyTypeMedia.
         * @param {string} specialtyTypeId 
         * @param {CreateMediaCommand} [createMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesSpecialtyTypeIdMediasPost: async (specialtyTypeId: string, createMediaCommand?: CreateMediaCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'specialtyTypeId' is not null or undefined
            assertParamExists('apiV1SpecialtytypesSpecialtyTypeIdMediasPost', 'specialtyTypeId', specialtyTypeId)
            const localVarPath = `/api/v1/specialtytypes/{specialtyTypeId}/medias`
                .replace(`{${"specialtyTypeId"}}`, encodeURIComponent(String(specialtyTypeId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createMediaCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update Department.
         * @param {string} specialtyTypeId 
         * @param {UpdateSpecialtyTypeCommand} [updateSpecialtyTypeCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesSpecialtyTypeIdPut: async (specialtyTypeId: string, updateSpecialtyTypeCommand?: UpdateSpecialtyTypeCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'specialtyTypeId' is not null or undefined
            assertParamExists('apiV1SpecialtytypesSpecialtyTypeIdPut', 'specialtyTypeId', specialtyTypeId)
            const localVarPath = `/api/v1/specialtytypes/{specialtyTypeId}`
                .replace(`{${"specialtyTypeId"}}`, encodeURIComponent(String(specialtyTypeId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateSpecialtyTypeCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Reactivate Department (SpecialtyType).
         * @param {string} specialtyTypeId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesSpecialtyTypeIdReactivatePut: async (specialtyTypeId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'specialtyTypeId' is not null or undefined
            assertParamExists('apiV1SpecialtytypesSpecialtyTypeIdReactivatePut', 'specialtyTypeId', specialtyTypeId)
            const localVarPath = `/api/v1/specialtytypes/{specialtyTypeId}/reactivate`
                .replace(`{${"specialtyTypeId"}}`, encodeURIComponent(String(specialtyTypeId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Revalidate specialtyType
         * @param {string} specialtyTypeId 
         * @param {boolean} [includeCurrent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesSpecialtyTypeIdRevalidatePost: async (specialtyTypeId: string, includeCurrent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'specialtyTypeId' is not null or undefined
            assertParamExists('apiV1SpecialtytypesSpecialtyTypeIdRevalidatePost', 'specialtyTypeId', specialtyTypeId)
            const localVarPath = `/api/v1/specialtytypes/{specialtyTypeId}/revalidate`
                .replace(`{${"specialtyTypeId"}}`, encodeURIComponent(String(specialtyTypeId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (includeCurrent !== undefined) {
                localVarQueryParameter['includeCurrent'] = includeCurrent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Translate speciatyType
         * @param {string} specialtyTypeId 
         * @param {TranslateSpecialtyTypeCommand} [translateSpecialtyTypeCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesSpecialtyTypeIdTranslatePost: async (specialtyTypeId: string, translateSpecialtyTypeCommand?: TranslateSpecialtyTypeCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'specialtyTypeId' is not null or undefined
            assertParamExists('apiV1SpecialtytypesSpecialtyTypeIdTranslatePost', 'specialtyTypeId', specialtyTypeId)
            const localVarPath = `/api/v1/specialtytypes/{specialtyTypeId}/translate`
                .replace(`{${"specialtyTypeId"}}`, encodeURIComponent(String(specialtyTypeId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(translateSpecialtyTypeCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * SpecialtyTypesApi - functional programming interface
 * @export
 */
export const SpecialtyTypesApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = SpecialtyTypesApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Get all Departments.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {string} [description] 
         * @param {MarketingType} [marketingType] 
         * @param {string} [hospitalId] 
         * @param {Date} [created] 
         * @param {Array<string>} [ids] 
         * @param {string} [specialtyTypeCategoryId] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {boolean} [returnDefaultValue] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SpecialtytypesGet(id?: string, name?: string, description?: string, marketingType?: MarketingType, hospitalId?: string, created?: Date, ids?: Array<string>, specialtyTypeCategoryId?: string, languageCode?: string, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SpecialtyTypesModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SpecialtytypesGet(id, name, description, marketingType, hospitalId, created, ids, specialtyTypeCategoryId, languageCode, showHidden, returnDefaultValue, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create a Department.
         * @param {CreateSpecialtyTypeCommand} [createSpecialtyTypeCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SpecialtytypesPost(createSpecialtyTypeCommand?: CreateSpecialtyTypeCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SpecialtyTypeModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SpecialtytypesPost(createSpecialtyTypeCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all Departments with simplified model.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {string} [description] 
         * @param {MarketingType} [marketingType] 
         * @param {string} [hospitalId] 
         * @param {Date} [created] 
         * @param {Array<string>} [ids] 
         * @param {string} [specialtyTypeCategoryId] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {boolean} [returnDefaultValue] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SpecialtytypesSimpleGet(id?: string, name?: string, description?: string, marketingType?: MarketingType, hospitalId?: string, created?: Date, ids?: Array<string>, specialtyTypeCategoryId?: string, languageCode?: string, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SpecialtyTypesSimpleModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SpecialtytypesSimpleGet(id, name, description, marketingType, hospitalId, created, ids, specialtyTypeCategoryId, languageCode, showHidden, returnDefaultValue, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get department by slug
         * @param {string} slug 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SpecialtytypesSlugGet(slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SpecialtyTypeModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SpecialtytypesSlugGet(slug, languageCode, returnDefaultValue, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Batch for departments sorting
         * @param {SpecialtyTypeSortingCommand} [specialtyTypeSortingCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SpecialtytypesSortPut(specialtyTypeSortingCommand?: SpecialtyTypeSortingCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SortingResultModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SpecialtytypesSortPut(specialtyTypeSortingCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete Department.
         * @param {string} specialtyTypeId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SpecialtytypesSpecialtyTypeIdDelete(specialtyTypeId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SpecialtytypesSpecialtyTypeIdDelete(specialtyTypeId, isPermanent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get department
         * @param {string} specialtyTypeId 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SpecialtytypesSpecialtyTypeIdGet(specialtyTypeId: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SpecialtyTypeModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SpecialtytypesSpecialtyTypeIdGet(specialtyTypeId, languageCode, returnDefaultValue, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all SpecialtyTypeMedias.
         * @param {string} specialtyTypeId 
         * @param {string} [id] 
         * @param {MediaType} [mediaType] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SpecialtytypesSpecialtyTypeIdMediasGet(specialtyTypeId: string, id?: string, mediaType?: MediaType, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediasModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SpecialtytypesSpecialtyTypeIdMediasGet(specialtyTypeId, id, mediaType, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete SpecialtyTypeMedia
         * @param {string} specialtyTypeId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdDelete(specialtyTypeId: string, mediaId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdDelete(specialtyTypeId, mediaId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get SpecialtyTypeMedia.
         * @param {string} specialtyTypeId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdGet(specialtyTypeId: string, mediaId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediaModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdGet(specialtyTypeId, mediaId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update SpecialtyTypeMedia.
         * @param {string} specialtyTypeId 
         * @param {string} mediaId 
         * @param {UpdateMediaCommand} [updateMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdPut(specialtyTypeId: string, mediaId: string, updateMediaCommand?: UpdateMediaCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediaModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdPut(specialtyTypeId, mediaId, updateMediaCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create SpecialtyTypeMedia.
         * @param {string} specialtyTypeId 
         * @param {CreateMediaCommand} [createMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SpecialtytypesSpecialtyTypeIdMediasPost(specialtyTypeId: string, createMediaCommand?: CreateMediaCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediaModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SpecialtytypesSpecialtyTypeIdMediasPost(specialtyTypeId, createMediaCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update Department.
         * @param {string} specialtyTypeId 
         * @param {UpdateSpecialtyTypeCommand} [updateSpecialtyTypeCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SpecialtytypesSpecialtyTypeIdPut(specialtyTypeId: string, updateSpecialtyTypeCommand?: UpdateSpecialtyTypeCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SpecialtyTypeModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SpecialtytypesSpecialtyTypeIdPut(specialtyTypeId, updateSpecialtyTypeCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Reactivate Department (SpecialtyType).
         * @param {string} specialtyTypeId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SpecialtytypesSpecialtyTypeIdReactivatePut(specialtyTypeId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SpecialtytypesSpecialtyTypeIdReactivatePut(specialtyTypeId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Revalidate specialtyType
         * @param {string} specialtyTypeId 
         * @param {boolean} [includeCurrent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SpecialtytypesSpecialtyTypeIdRevalidatePost(specialtyTypeId: string, includeCurrent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SpecialtytypesSpecialtyTypeIdRevalidatePost(specialtyTypeId, includeCurrent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Translate speciatyType
         * @param {string} specialtyTypeId 
         * @param {TranslateSpecialtyTypeCommand} [translateSpecialtyTypeCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SpecialtytypesSpecialtyTypeIdTranslatePost(specialtyTypeId: string, translateSpecialtyTypeCommand?: TranslateSpecialtyTypeCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SpecialtytypesSpecialtyTypeIdTranslatePost(specialtyTypeId, translateSpecialtyTypeCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * SpecialtyTypesApi - factory interface
 * @export
 */
export const SpecialtyTypesApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = SpecialtyTypesApiFp(configuration)
    return {
        /**
         * 
         * @summary Get all Departments.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {string} [description] 
         * @param {MarketingType} [marketingType] 
         * @param {string} [hospitalId] 
         * @param {Date} [created] 
         * @param {Array<string>} [ids] 
         * @param {string} [specialtyTypeCategoryId] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {boolean} [returnDefaultValue] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesGet(id?: string, name?: string, description?: string, marketingType?: MarketingType, hospitalId?: string, created?: Date, ids?: Array<string>, specialtyTypeCategoryId?: string, languageCode?: string, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<SpecialtyTypesModel> {
            return localVarFp.apiV1SpecialtytypesGet(id, name, description, marketingType, hospitalId, created, ids, specialtyTypeCategoryId, languageCode, showHidden, returnDefaultValue, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create a Department.
         * @param {CreateSpecialtyTypeCommand} [createSpecialtyTypeCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesPost(createSpecialtyTypeCommand?: CreateSpecialtyTypeCommand, options?: any): AxiosPromise<SpecialtyTypeModel> {
            return localVarFp.apiV1SpecialtytypesPost(createSpecialtyTypeCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all Departments with simplified model.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {string} [description] 
         * @param {MarketingType} [marketingType] 
         * @param {string} [hospitalId] 
         * @param {Date} [created] 
         * @param {Array<string>} [ids] 
         * @param {string} [specialtyTypeCategoryId] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {boolean} [returnDefaultValue] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesSimpleGet(id?: string, name?: string, description?: string, marketingType?: MarketingType, hospitalId?: string, created?: Date, ids?: Array<string>, specialtyTypeCategoryId?: string, languageCode?: string, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<SpecialtyTypesSimpleModel> {
            return localVarFp.apiV1SpecialtytypesSimpleGet(id, name, description, marketingType, hospitalId, created, ids, specialtyTypeCategoryId, languageCode, showHidden, returnDefaultValue, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get department by slug
         * @param {string} slug 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesSlugGet(slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: any): AxiosPromise<SpecialtyTypeModel> {
            return localVarFp.apiV1SpecialtytypesSlugGet(slug, languageCode, returnDefaultValue, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Batch for departments sorting
         * @param {SpecialtyTypeSortingCommand} [specialtyTypeSortingCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesSortPut(specialtyTypeSortingCommand?: SpecialtyTypeSortingCommand, options?: any): AxiosPromise<SortingResultModel> {
            return localVarFp.apiV1SpecialtytypesSortPut(specialtyTypeSortingCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete Department.
         * @param {string} specialtyTypeId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesSpecialtyTypeIdDelete(specialtyTypeId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1SpecialtytypesSpecialtyTypeIdDelete(specialtyTypeId, isPermanent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get department
         * @param {string} specialtyTypeId 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesSpecialtyTypeIdGet(specialtyTypeId: string, languageCode?: string, returnDefaultValue?: boolean, options?: any): AxiosPromise<SpecialtyTypeModel> {
            return localVarFp.apiV1SpecialtytypesSpecialtyTypeIdGet(specialtyTypeId, languageCode, returnDefaultValue, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all SpecialtyTypeMedias.
         * @param {string} specialtyTypeId 
         * @param {string} [id] 
         * @param {MediaType} [mediaType] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesSpecialtyTypeIdMediasGet(specialtyTypeId: string, id?: string, mediaType?: MediaType, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<MediasModel> {
            return localVarFp.apiV1SpecialtytypesSpecialtyTypeIdMediasGet(specialtyTypeId, id, mediaType, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete SpecialtyTypeMedia
         * @param {string} specialtyTypeId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdDelete(specialtyTypeId: string, mediaId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdDelete(specialtyTypeId, mediaId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get SpecialtyTypeMedia.
         * @param {string} specialtyTypeId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdGet(specialtyTypeId: string, mediaId: string, options?: any): AxiosPromise<MediaModel> {
            return localVarFp.apiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdGet(specialtyTypeId, mediaId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update SpecialtyTypeMedia.
         * @param {string} specialtyTypeId 
         * @param {string} mediaId 
         * @param {UpdateMediaCommand} [updateMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdPut(specialtyTypeId: string, mediaId: string, updateMediaCommand?: UpdateMediaCommand, options?: any): AxiosPromise<MediaModel> {
            return localVarFp.apiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdPut(specialtyTypeId, mediaId, updateMediaCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create SpecialtyTypeMedia.
         * @param {string} specialtyTypeId 
         * @param {CreateMediaCommand} [createMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesSpecialtyTypeIdMediasPost(specialtyTypeId: string, createMediaCommand?: CreateMediaCommand, options?: any): AxiosPromise<MediaModel> {
            return localVarFp.apiV1SpecialtytypesSpecialtyTypeIdMediasPost(specialtyTypeId, createMediaCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update Department.
         * @param {string} specialtyTypeId 
         * @param {UpdateSpecialtyTypeCommand} [updateSpecialtyTypeCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesSpecialtyTypeIdPut(specialtyTypeId: string, updateSpecialtyTypeCommand?: UpdateSpecialtyTypeCommand, options?: any): AxiosPromise<SpecialtyTypeModel> {
            return localVarFp.apiV1SpecialtytypesSpecialtyTypeIdPut(specialtyTypeId, updateSpecialtyTypeCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Reactivate Department (SpecialtyType).
         * @param {string} specialtyTypeId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesSpecialtyTypeIdReactivatePut(specialtyTypeId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1SpecialtytypesSpecialtyTypeIdReactivatePut(specialtyTypeId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Revalidate specialtyType
         * @param {string} specialtyTypeId 
         * @param {boolean} [includeCurrent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesSpecialtyTypeIdRevalidatePost(specialtyTypeId: string, includeCurrent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1SpecialtytypesSpecialtyTypeIdRevalidatePost(specialtyTypeId, includeCurrent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Translate speciatyType
         * @param {string} specialtyTypeId 
         * @param {TranslateSpecialtyTypeCommand} [translateSpecialtyTypeCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtytypesSpecialtyTypeIdTranslatePost(specialtyTypeId: string, translateSpecialtyTypeCommand?: TranslateSpecialtyTypeCommand, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1SpecialtytypesSpecialtyTypeIdTranslatePost(specialtyTypeId, translateSpecialtyTypeCommand, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1SpecialtytypesGet operation in SpecialtyTypesApi.
 * @export
 * @interface SpecialtyTypesApiApiV1SpecialtytypesGetRequest
 */
export interface SpecialtyTypesApiApiV1SpecialtytypesGetRequest {
    /**
     * 
     * @type {string}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesGet
     */
    readonly id?: string

    /**
     * 
     * @type {string}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesGet
     */
    readonly name?: string

    /**
     * 
     * @type {string}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesGet
     */
    readonly description?: string

    /**
     * 
     * @type {MarketingType}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesGet
     */
    readonly marketingType?: MarketingType

    /**
     * 
     * @type {string}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {Date}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesGet
     */
    readonly created?: Date

    /**
     * 
     * @type {Array<string>}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesGet
     */
    readonly ids?: Array<string>

    /**
     * 
     * @type {string}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesGet
     */
    readonly specialtyTypeCategoryId?: string

    /**
     * 
     * @type {string}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesGet
     */
    readonly showHidden?: boolean

    /**
     * 
     * @type {boolean}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesGet
     */
    readonly returnDefaultValue?: boolean

    /**
     * 
     * @type {number}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1SpecialtytypesPost operation in SpecialtyTypesApi.
 * @export
 * @interface SpecialtyTypesApiApiV1SpecialtytypesPostRequest
 */
export interface SpecialtyTypesApiApiV1SpecialtytypesPostRequest {
    /**
     * 
     * @type {CreateSpecialtyTypeCommand}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesPost
     */
    readonly createSpecialtyTypeCommand?: CreateSpecialtyTypeCommand
}

/**
 * Request parameters for apiV1SpecialtytypesSimpleGet operation in SpecialtyTypesApi.
 * @export
 * @interface SpecialtyTypesApiApiV1SpecialtytypesSimpleGetRequest
 */
export interface SpecialtyTypesApiApiV1SpecialtytypesSimpleGetRequest {
    /**
     * 
     * @type {string}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSimpleGet
     */
    readonly id?: string

    /**
     * 
     * @type {string}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSimpleGet
     */
    readonly name?: string

    /**
     * 
     * @type {string}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSimpleGet
     */
    readonly description?: string

    /**
     * 
     * @type {MarketingType}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSimpleGet
     */
    readonly marketingType?: MarketingType

    /**
     * 
     * @type {string}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSimpleGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {Date}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSimpleGet
     */
    readonly created?: Date

    /**
     * 
     * @type {Array<string>}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSimpleGet
     */
    readonly ids?: Array<string>

    /**
     * 
     * @type {string}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSimpleGet
     */
    readonly specialtyTypeCategoryId?: string

    /**
     * 
     * @type {string}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSimpleGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSimpleGet
     */
    readonly showHidden?: boolean

    /**
     * 
     * @type {boolean}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSimpleGet
     */
    readonly returnDefaultValue?: boolean

    /**
     * 
     * @type {number}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSimpleGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSimpleGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSimpleGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1SpecialtytypesSlugGet operation in SpecialtyTypesApi.
 * @export
 * @interface SpecialtyTypesApiApiV1SpecialtytypesSlugGetRequest
 */
export interface SpecialtyTypesApiApiV1SpecialtytypesSlugGetRequest {
    /**
     * 
     * @type {string}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSlugGet
     */
    readonly slug: string

    /**
     * 
     * @type {string}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSlugGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSlugGet
     */
    readonly returnDefaultValue?: boolean
}

/**
 * Request parameters for apiV1SpecialtytypesSortPut operation in SpecialtyTypesApi.
 * @export
 * @interface SpecialtyTypesApiApiV1SpecialtytypesSortPutRequest
 */
export interface SpecialtyTypesApiApiV1SpecialtytypesSortPutRequest {
    /**
     * 
     * @type {SpecialtyTypeSortingCommand}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSortPut
     */
    readonly specialtyTypeSortingCommand?: SpecialtyTypeSortingCommand
}

/**
 * Request parameters for apiV1SpecialtytypesSpecialtyTypeIdDelete operation in SpecialtyTypesApi.
 * @export
 * @interface SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdDeleteRequest
 */
export interface SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdDelete
     */
    readonly specialtyTypeId: string

    /**
     * 
     * @type {boolean}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdDelete
     */
    readonly isPermanent?: boolean
}

/**
 * Request parameters for apiV1SpecialtytypesSpecialtyTypeIdGet operation in SpecialtyTypesApi.
 * @export
 * @interface SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdGetRequest
 */
export interface SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdGet
     */
    readonly specialtyTypeId: string

    /**
     * 
     * @type {string}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdGet
     */
    readonly returnDefaultValue?: boolean
}

/**
 * Request parameters for apiV1SpecialtytypesSpecialtyTypeIdMediasGet operation in SpecialtyTypesApi.
 * @export
 * @interface SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasGetRequest
 */
export interface SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasGetRequest {
    /**
     * 
     * @type {string}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasGet
     */
    readonly specialtyTypeId: string

    /**
     * 
     * @type {string}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasGet
     */
    readonly id?: string

    /**
     * 
     * @type {MediaType}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasGet
     */
    readonly mediaType?: MediaType

    /**
     * 
     * @type {number}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdDelete operation in SpecialtyTypesApi.
 * @export
 * @interface SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdDeleteRequest
 */
export interface SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdDelete
     */
    readonly specialtyTypeId: string

    /**
     * 
     * @type {string}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdDelete
     */
    readonly mediaId: string
}

/**
 * Request parameters for apiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdGet operation in SpecialtyTypesApi.
 * @export
 * @interface SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdGetRequest
 */
export interface SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdGet
     */
    readonly specialtyTypeId: string

    /**
     * 
     * @type {string}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdGet
     */
    readonly mediaId: string
}

/**
 * Request parameters for apiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdPut operation in SpecialtyTypesApi.
 * @export
 * @interface SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdPutRequest
 */
export interface SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdPut
     */
    readonly specialtyTypeId: string

    /**
     * 
     * @type {string}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdPut
     */
    readonly mediaId: string

    /**
     * 
     * @type {UpdateMediaCommand}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdPut
     */
    readonly updateMediaCommand?: UpdateMediaCommand
}

/**
 * Request parameters for apiV1SpecialtytypesSpecialtyTypeIdMediasPost operation in SpecialtyTypesApi.
 * @export
 * @interface SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasPostRequest
 */
export interface SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasPostRequest {
    /**
     * 
     * @type {string}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasPost
     */
    readonly specialtyTypeId: string

    /**
     * 
     * @type {CreateMediaCommand}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasPost
     */
    readonly createMediaCommand?: CreateMediaCommand
}

/**
 * Request parameters for apiV1SpecialtytypesSpecialtyTypeIdPut operation in SpecialtyTypesApi.
 * @export
 * @interface SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdPutRequest
 */
export interface SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdPut
     */
    readonly specialtyTypeId: string

    /**
     * 
     * @type {UpdateSpecialtyTypeCommand}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdPut
     */
    readonly updateSpecialtyTypeCommand?: UpdateSpecialtyTypeCommand
}

/**
 * Request parameters for apiV1SpecialtytypesSpecialtyTypeIdReactivatePut operation in SpecialtyTypesApi.
 * @export
 * @interface SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdReactivatePutRequest
 */
export interface SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdReactivatePutRequest {
    /**
     * 
     * @type {string}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdReactivatePut
     */
    readonly specialtyTypeId: string
}

/**
 * Request parameters for apiV1SpecialtytypesSpecialtyTypeIdRevalidatePost operation in SpecialtyTypesApi.
 * @export
 * @interface SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdRevalidatePostRequest
 */
export interface SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdRevalidatePostRequest {
    /**
     * 
     * @type {string}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdRevalidatePost
     */
    readonly specialtyTypeId: string

    /**
     * 
     * @type {boolean}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdRevalidatePost
     */
    readonly includeCurrent?: boolean
}

/**
 * Request parameters for apiV1SpecialtytypesSpecialtyTypeIdTranslatePost operation in SpecialtyTypesApi.
 * @export
 * @interface SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdTranslatePostRequest
 */
export interface SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdTranslatePostRequest {
    /**
     * 
     * @type {string}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdTranslatePost
     */
    readonly specialtyTypeId: string

    /**
     * 
     * @type {TranslateSpecialtyTypeCommand}
     * @memberof SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdTranslatePost
     */
    readonly translateSpecialtyTypeCommand?: TranslateSpecialtyTypeCommand
}

/**
 * SpecialtyTypesApi - object-oriented interface
 * @export
 * @class SpecialtyTypesApi
 * @extends {BaseAPI}
 */
export class SpecialtyTypesApi extends BaseAPI {
    /**
     * 
     * @summary Get all Departments.
     * @param {SpecialtyTypesApiApiV1SpecialtytypesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtyTypesApi
     */
    public apiV1SpecialtytypesGet(requestParameters: SpecialtyTypesApiApiV1SpecialtytypesGetRequest = {}, options?: AxiosRequestConfig) {
        return SpecialtyTypesApiFp(this.configuration).apiV1SpecialtytypesGet(requestParameters.id, requestParameters.name, requestParameters.description, requestParameters.marketingType, requestParameters.hospitalId, requestParameters.created, requestParameters.ids, requestParameters.specialtyTypeCategoryId, requestParameters.languageCode, requestParameters.showHidden, requestParameters.returnDefaultValue, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create a Department.
     * @param {SpecialtyTypesApiApiV1SpecialtytypesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtyTypesApi
     */
    public apiV1SpecialtytypesPost(requestParameters: SpecialtyTypesApiApiV1SpecialtytypesPostRequest = {}, options?: AxiosRequestConfig) {
        return SpecialtyTypesApiFp(this.configuration).apiV1SpecialtytypesPost(requestParameters.createSpecialtyTypeCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all Departments with simplified model.
     * @param {SpecialtyTypesApiApiV1SpecialtytypesSimpleGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtyTypesApi
     */
    public apiV1SpecialtytypesSimpleGet(requestParameters: SpecialtyTypesApiApiV1SpecialtytypesSimpleGetRequest = {}, options?: AxiosRequestConfig) {
        return SpecialtyTypesApiFp(this.configuration).apiV1SpecialtytypesSimpleGet(requestParameters.id, requestParameters.name, requestParameters.description, requestParameters.marketingType, requestParameters.hospitalId, requestParameters.created, requestParameters.ids, requestParameters.specialtyTypeCategoryId, requestParameters.languageCode, requestParameters.showHidden, requestParameters.returnDefaultValue, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get department by slug
     * @param {SpecialtyTypesApiApiV1SpecialtytypesSlugGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtyTypesApi
     */
    public apiV1SpecialtytypesSlugGet(requestParameters: SpecialtyTypesApiApiV1SpecialtytypesSlugGetRequest, options?: AxiosRequestConfig) {
        return SpecialtyTypesApiFp(this.configuration).apiV1SpecialtytypesSlugGet(requestParameters.slug, requestParameters.languageCode, requestParameters.returnDefaultValue, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Batch for departments sorting
     * @param {SpecialtyTypesApiApiV1SpecialtytypesSortPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtyTypesApi
     */
    public apiV1SpecialtytypesSortPut(requestParameters: SpecialtyTypesApiApiV1SpecialtytypesSortPutRequest = {}, options?: AxiosRequestConfig) {
        return SpecialtyTypesApiFp(this.configuration).apiV1SpecialtytypesSortPut(requestParameters.specialtyTypeSortingCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete Department.
     * @param {SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtyTypesApi
     */
    public apiV1SpecialtytypesSpecialtyTypeIdDelete(requestParameters: SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdDeleteRequest, options?: AxiosRequestConfig) {
        return SpecialtyTypesApiFp(this.configuration).apiV1SpecialtytypesSpecialtyTypeIdDelete(requestParameters.specialtyTypeId, requestParameters.isPermanent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get department
     * @param {SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtyTypesApi
     */
    public apiV1SpecialtytypesSpecialtyTypeIdGet(requestParameters: SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdGetRequest, options?: AxiosRequestConfig) {
        return SpecialtyTypesApiFp(this.configuration).apiV1SpecialtytypesSpecialtyTypeIdGet(requestParameters.specialtyTypeId, requestParameters.languageCode, requestParameters.returnDefaultValue, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all SpecialtyTypeMedias.
     * @param {SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtyTypesApi
     */
    public apiV1SpecialtytypesSpecialtyTypeIdMediasGet(requestParameters: SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasGetRequest, options?: AxiosRequestConfig) {
        return SpecialtyTypesApiFp(this.configuration).apiV1SpecialtytypesSpecialtyTypeIdMediasGet(requestParameters.specialtyTypeId, requestParameters.id, requestParameters.mediaType, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete SpecialtyTypeMedia
     * @param {SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtyTypesApi
     */
    public apiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdDelete(requestParameters: SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdDeleteRequest, options?: AxiosRequestConfig) {
        return SpecialtyTypesApiFp(this.configuration).apiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdDelete(requestParameters.specialtyTypeId, requestParameters.mediaId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get SpecialtyTypeMedia.
     * @param {SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtyTypesApi
     */
    public apiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdGet(requestParameters: SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdGetRequest, options?: AxiosRequestConfig) {
        return SpecialtyTypesApiFp(this.configuration).apiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdGet(requestParameters.specialtyTypeId, requestParameters.mediaId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update SpecialtyTypeMedia.
     * @param {SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtyTypesApi
     */
    public apiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdPut(requestParameters: SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdPutRequest, options?: AxiosRequestConfig) {
        return SpecialtyTypesApiFp(this.configuration).apiV1SpecialtytypesSpecialtyTypeIdMediasMediaIdPut(requestParameters.specialtyTypeId, requestParameters.mediaId, requestParameters.updateMediaCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create SpecialtyTypeMedia.
     * @param {SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtyTypesApi
     */
    public apiV1SpecialtytypesSpecialtyTypeIdMediasPost(requestParameters: SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdMediasPostRequest, options?: AxiosRequestConfig) {
        return SpecialtyTypesApiFp(this.configuration).apiV1SpecialtytypesSpecialtyTypeIdMediasPost(requestParameters.specialtyTypeId, requestParameters.createMediaCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update Department.
     * @param {SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtyTypesApi
     */
    public apiV1SpecialtytypesSpecialtyTypeIdPut(requestParameters: SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdPutRequest, options?: AxiosRequestConfig) {
        return SpecialtyTypesApiFp(this.configuration).apiV1SpecialtytypesSpecialtyTypeIdPut(requestParameters.specialtyTypeId, requestParameters.updateSpecialtyTypeCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Reactivate Department (SpecialtyType).
     * @param {SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdReactivatePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtyTypesApi
     */
    public apiV1SpecialtytypesSpecialtyTypeIdReactivatePut(requestParameters: SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdReactivatePutRequest, options?: AxiosRequestConfig) {
        return SpecialtyTypesApiFp(this.configuration).apiV1SpecialtytypesSpecialtyTypeIdReactivatePut(requestParameters.specialtyTypeId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Revalidate specialtyType
     * @param {SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdRevalidatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtyTypesApi
     */
    public apiV1SpecialtytypesSpecialtyTypeIdRevalidatePost(requestParameters: SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdRevalidatePostRequest, options?: AxiosRequestConfig) {
        return SpecialtyTypesApiFp(this.configuration).apiV1SpecialtytypesSpecialtyTypeIdRevalidatePost(requestParameters.specialtyTypeId, requestParameters.includeCurrent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Translate speciatyType
     * @param {SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdTranslatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtyTypesApi
     */
    public apiV1SpecialtytypesSpecialtyTypeIdTranslatePost(requestParameters: SpecialtyTypesApiApiV1SpecialtytypesSpecialtyTypeIdTranslatePostRequest, options?: AxiosRequestConfig) {
        return SpecialtyTypesApiFp(this.configuration).apiV1SpecialtytypesSpecialtyTypeIdTranslatePost(requestParameters.specialtyTypeId, requestParameters.translateSpecialtyTypeCommand, options).then((request) => request(this.axios, this.basePath));
    }
}
